/*
Navicat MySQL Data Transfer

Source Server         : UCKeFu
Source Server Version : 50717
Source Host           : localhost:3306
Source Database       : beimi

Target Server Type    : MYSQL
Target Server Version : 50717
File Encoding         : 65001

Date: 2018-03-26 17:08:11
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for `bm_account_config`
-- ----------------------------
DROP TABLE IF EXISTS `bm_account_config`;
CREATE TABLE `bm_account_config` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '创建人用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `enableask` tinyint(4) DEFAULT NULL COMMENT '允许AI主动发起问答',
  `askfirst` tinyint(4) DEFAULT NULL COMMENT 'AI优先',
  `enablescene` tinyint(4) DEFAULT NULL COMMENT '启用场景识别',
  `scenefirst` tinyint(4) DEFAULT NULL COMMENT '优先命中场景',
  `enablekeyword` tinyint(4) DEFAULT NULL COMMENT '启用关键词命中',
  `keywordnum` int(11) DEFAULT NULL COMMENT '关键词数量',
  `noresultmsg` text COMMENT '未命中回复消息',
  `askqs` tinyint(4) DEFAULT NULL COMMENT '询问访客是否解决问题',
  `asktipmsg` varchar(255) DEFAULT NULL COMMENT '询问访客的文本',
  `resolved` varchar(100) DEFAULT NULL COMMENT '已解决的提示文本',
  `unresolved` varchar(100) DEFAULT NULL COMMENT '未解决的提示文本',
  `redirectagent` tinyint(4) DEFAULT NULL COMMENT '跳转到人工坐席',
  `redirecturl` varchar(255) DEFAULT NULL COMMENT '跳转到其他URL',
  `asktimes` int(11) DEFAULT NULL COMMENT '最长多久开始询问',
  `selectskill` int(11) DEFAULT NULL,
  `selectskillmsg` varchar(255) DEFAULT NULL,
  `expdays` int(11) DEFAULT NULL,
  `initaccount` tinyint(4) DEFAULT NULL,
  `initcoins` int(11) DEFAULT NULL,
  `initcards` int(11) DEFAULT NULL,
  `initdiamonds` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_account_config
-- ----------------------------
INSERT INTO `bm_account_config` VALUES ('402888815e058149015e0581dbe40000', 'beimi', '297e8c7b455798280145579c73e501c1', null, null, '2017-08-21 23:55:50', '0', '0', '0', '0', '0', '5', '', '0', '您好，小E是否已经解决了您的问题？', '已解决（关闭对话）', '未解决（转人工坐席）', '0', null, '120', '0', '请选择您要咨询的问题分类？', '0', '1', '5000', '10', '10');

-- ----------------------------
-- Table structure for `bm_attachment_file`
-- ----------------------------
DROP TABLE IF EXISTS `bm_attachment_file`;
CREATE TABLE `bm_attachment_file` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `organ` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  `datastatus` tinyint(4) DEFAULT NULL COMMENT '数据状态（逻辑删除）',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `filelength` int(11) DEFAULT NULL COMMENT '文件长度',
  `filetype` varchar(255) DEFAULT NULL COMMENT '文件类型',
  `image` tinyint(4) DEFAULT NULL COMMENT '是否图片',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属功能模块',
  `fileid` varchar(32) DEFAULT NULL COMMENT '文件ID',
  `modelid` varchar(32) DEFAULT NULL COMMENT '所属模块数据ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_attachment_file
-- ----------------------------
INSERT INTO `bm_attachment_file` VALUES ('402888815c73b8b7015c73c475070008', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-04 23:41:13', '402883965c1dfe92015c1e1291900003', '0', '11.png', null, '2017-06-04 23:41:13', '201306', 'image/png', '1', '5894953fb0fb4dae86b805ad81fda220', 'workorders', '4e16a00b0faa780bbe3b3d6b9df20148', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c73b8b7015c73c475170009', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-04 23:41:13', '402883965c1dfe92015c1e1291900003', '0', '11.png', null, '2017-06-04 23:41:13', '201306', 'image/png', '1', '5894953fb0fb4dae86b805ad81fda220', 'workorders', '4e16a00b0faa780bbe3b3d6b9df20148', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c73b8b7015c73c4afb6000a', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-04 23:41:28', '402883965c1dfe92015c1e1291900003', '0', '捷通华声智能外呼系统解决方案（2016.9.19）.pptx', null, '2017-06-04 23:41:28', '13161290', 'application/vnd.openxmlformats-officedocument.presentationml.presentation', '0', '5894953fb0fb4dae86b805ad81fda220', 'workorders', '34b6bf2000fd6e7e95164be5d85562ac', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c73b8b7015c73c571c9000b', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-04 23:42:18', '402883965c1dfe92015c1e1291900003', '0', 'z3A8_ClTnR6PthP9GHpjlbEl4xcxOW42wzqEw12SbHFJQsmlbjFe2XmwDAqxL2sG4520996343697988632.jpg', null, '2017-06-04 23:42:18', '42235', 'image/jpeg', '1', '33bba4b817324488aa6a9a8dc7f6dc47', 'workorders', '8986587e53473082089fc9f8657dcfe4', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c73b8b7015c73c571e2000c', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-04 23:42:18', '402883965c1dfe92015c1e1291900003', '0', '1.png', null, '2017-06-04 23:42:18', '193645', 'image/png', '1', '33bba4b817324488aa6a9a8dc7f6dc47', 'workorders', '99999a1baa7212603be1070c55152c61', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75c4560a0008', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 09:00:20', '402883965c1dfe92015c1e1291900003', '0', '1.png', null, '2017-06-05 09:00:20', '193645', 'image/png', '1', '5de373b1e76b4d329f812d53456fb87c', 'workorders', '99999a1baa7212603be1070c55152c61', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75c456260009', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 09:00:20', '402883965c1dfe92015c1e1291900003', '0', '2.png', null, '2017-06-05 09:00:20', '169254', 'image/png', '1', '5de373b1e76b4d329f812d53456fb87c', 'workorders', '17dceb992de70f7ed83ed1040484065a', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75c45635000a', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 09:00:20', '402883965c1dfe92015c1e1291900003', '0', '3.png', null, '2017-06-05 09:00:20', '89999', 'image/png', '1', '5de373b1e76b4d329f812d53456fb87c', 'workorders', 'd16e2fb4a152072191ccf658185e7eaa', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75c4563f000b', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 09:00:20', '402883965c1dfe92015c1e1291900003', '0', '4.png', null, '2017-06-05 09:00:20', '66731', 'image/png', '1', '5de373b1e76b4d329f812d53456fb87c', 'workorders', '034921687e3058a30da01a174670e965', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75c4564b000c', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 09:00:20', '402883965c1dfe92015c1e1291900003', '0', '5.png', null, '2017-06-05 09:00:20', '68597', 'image/png', '1', '5de373b1e76b4d329f812d53456fb87c', 'workorders', 'fc7d14a26ccfa6b08f3012c7eecc5d37', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75d3dd800014', 'ukewo', '402883965c1dfe92015c1e12651d0002', '2017-06-05 09:17:18', '402883965c1dfe92015c1e1291900003', '0', '16.png', null, '2017-06-05 09:17:18', '188751', 'image/png', '1', '85406acb810f4103833da3d944d791a0', 'workorders', 'a954290ba95a6e50174869d551ed0970', '5894953fb0fb4dae86b805ad81fda220');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75d3f8760018', 'ukewo', '402883965c1dfe92015c1e12651d0002', '2017-06-05 09:17:24', '402883965c1dfe92015c1e1291900003', '0', '17.png', null, '2017-06-05 09:17:24', '204169', 'image/png', '1', '76686551b9d248a191e69d139f687b17', 'workorders', 'd0cb4b885c21638635ec7ecc52c0693e', 'cefcfdbb10b2413aa7da50a3eadb6e34');
INSERT INTO `bm_attachment_file` VALUES ('402888815c75bfbf015c75d42a43001e', 'ukewo', '402883965c1dfe92015c1e12651d0002', '2017-06-05 09:17:37', '402883965c1dfe92015c1e1291900003', '0', '17.png', null, '2017-06-05 09:17:37', '204169', 'image/png', '1', '8361ceac16d24e1db89ce9fd76a3e24f', 'workorders', 'd0cb4b885c21638635ec7ecc52c0693e', '01ac33e06e0c4479b315ea623f6688b9');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c760d8e760001', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:20:18', '402883965c1dfe92015c1e1291900003', '0', '17.png', null, '2017-06-05 10:20:18', '204169', 'image/png', '1', 'ca9d9189dfef4abbacdf36c249b477d0', 'workorders', 'd0cb4b885c21638635ec7ecc52c0693e', 'ca9d9189dfef4abbacdf36c249b477d0');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c760d8e950002', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:20:18', '402883965c1dfe92015c1e1291900003', '0', '3.png', null, '2017-06-05 10:20:18', '89999', 'image/png', '1', 'ca9d9189dfef4abbacdf36c249b477d0', 'workorders', 'd16e2fb4a152072191ccf658185e7eaa', 'ca9d9189dfef4abbacdf36c249b477d0');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c760d8ea60003', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:20:18', '402883965c1dfe92015c1e1291900003', '0', '8.png', null, '2017-06-05 10:20:18', '124295', 'image/png', '1', 'ca9d9189dfef4abbacdf36c249b477d0', 'workorders', 'b70bb5099910f99bd8ab4bdbf7ea6f19', 'ca9d9189dfef4abbacdf36c249b477d0');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c760e4f6f0005', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:21:08', '402883965c1dfe92015c1e1291900003', '0', '5.png', null, '2017-06-05 10:21:08', '68597', 'image/png', '1', '346a195eed934e9b910d858b62c4dc9c', 'workorders', 'fc7d14a26ccfa6b08f3012c7eecc5d37', '346a195eed934e9b910d858b62c4dc9c');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c760e4f800006', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:21:08', '402883965c1dfe92015c1e1291900003', '0', '6.png', null, '2017-06-05 10:21:08', '158052', 'image/png', '1', '346a195eed934e9b910d858b62c4dc9c', 'workorders', '09def84e6927bb5d75d0b0459f330ac9', '346a195eed934e9b910d858b62c4dc9c');
INSERT INTO `bm_attachment_file` VALUES ('402888815c760cc5015c761a90010009', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:34:31', '402883965c1dfe92015c1e1291900003', '0', '16.png', null, '2017-06-05 10:34:31', '188751', 'image/png', '1', '0debd45ab2b2435ab41fc1f12cbb863c', 'workorders', 'a954290ba95a6e50174869d551ed0970', '346a195eed934e9b910d858b62c4dc9c');
INSERT INTO `bm_attachment_file` VALUES ('402888815c761c97015c761e30650002', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:38:28', '402883965c1dfe92015c1e1291900003', '0', '16.png', null, '2017-06-05 10:38:28', '188751', 'image/png', '1', '56d8fe6c0d634900a3163116a7155870', 'workorders', 'a954290ba95a6e50174869d551ed0970', '346a195eed934e9b910d858b62c4dc9c');
INSERT INTO `bm_attachment_file` VALUES ('402888815c761c97015c761e30840003', 'ukewo', '297e8c7b455798280145579c73e501c1', '2017-06-05 10:38:28', '402883965c1dfe92015c1e1291900003', '0', '7.png', null, '2017-06-05 10:38:28', '258693', 'image/png', '1', '56d8fe6c0d634900a3163116a7155870', 'workorders', '908d198579b97873a5c3681bdecf2a53', '346a195eed934e9b910d858b62c4dc9c');

-- ----------------------------
-- Table structure for `bm_datadic`
-- ----------------------------
DROP TABLE IF EXISTS `bm_datadic`;
CREATE TABLE `bm_datadic` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(32) DEFAULT NULL,
  `TITLE` varchar(32) DEFAULT NULL,
  `CODE` varchar(32) DEFAULT NULL,
  `PARENTID` varchar(32) DEFAULT NULL,
  `TYPE` varchar(32) DEFAULT NULL,
  `MEMO` varchar(255) DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `STATUS` varchar(32) DEFAULT NULL,
  `CREATETIME` timestamp NULL DEFAULT NULL,
  `UPDATETIME` timestamp NULL DEFAULT NULL,
  `CREATER` varchar(255) DEFAULT NULL,
  `PUBLISHEDTYPE` varchar(32) DEFAULT NULL,
  `DESCRIPTION` varchar(255) DEFAULT NULL,
  `TABTYPE` varchar(32) DEFAULT NULL,
  `DSTYPE` varchar(32) DEFAULT NULL,
  `DSTEMPLET` varchar(255) DEFAULT NULL,
  `SORTINDEX` int(11) DEFAULT NULL,
  `DICTYPE` varchar(32) DEFAULT NULL,
  `ICONCLASS` varchar(100) DEFAULT NULL,
  `CSSSTYLE` varchar(255) DEFAULT NULL,
  `AUTHCODE` varchar(100) DEFAULT NULL,
  `DEFAULTMENU` tinyint(4) DEFAULT NULL,
  `DATAID` varchar(32) DEFAULT NULL,
  `DICICON` varchar(32) DEFAULT NULL,
  `CURICON` varchar(32) DEFAULT NULL,
  `BGCOLOR` varchar(32) DEFAULT NULL,
  `CURBGCOLOR` varchar(32) DEFAULT NULL,
  `MENUPOS` varchar(32) DEFAULT NULL,
  `DISTITLE` varchar(100) DEFAULT NULL,
  `NAVMENU` tinyint(4) DEFAULT '0',
  `QUICKMENU` tinyint(4) DEFAULT '0',
  `PROJECTID` varchar(32) DEFAULT NULL,
  UNIQUE KEY `SQL121227155530400` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_datadic
-- ----------------------------

-- ----------------------------
-- Table structure for `bm_gameconfig`
-- ----------------------------
DROP TABLE IF EXISTS `bm_gameconfig`;
CREATE TABLE `bm_gameconfig` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `sessionmsg` varchar(255) DEFAULT NULL COMMENT '会话消息',
  `distribution` varchar(32) DEFAULT NULL COMMENT '坐席分配策略',
  `timeoutmsg` varchar(255) DEFAULT NULL COMMENT '超时提醒消息',
  `retimeoutmsg` varchar(255) DEFAULT NULL COMMENT '再次超时提醒消息',
  `satisfaction` tinyint(4) DEFAULT NULL COMMENT '启用满意度调查',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `lastagent` tinyint(4) DEFAULT NULL COMMENT '最后服务坐席优先分配',
  `sessiontimeout` tinyint(4) DEFAULT NULL COMMENT '会话超时时间',
  `resessiontimeout` tinyint(4) DEFAULT NULL COMMENT '再次超时时间',
  `timeout` int(11) DEFAULT NULL COMMENT '超时时长',
  `retimeout` int(11) DEFAULT NULL COMMENT '再次超时时长',
  `maxuser` int(11) DEFAULT NULL COMMENT '最大用户数',
  `initmaxuser` int(11) DEFAULT NULL COMMENT '首次就绪分配用户数',
  `workinghours` text COMMENT '工作时间段',
  `notinwhmsg` text COMMENT '非工作时间提醒消息',
  `hourcheck` tinyint(4) DEFAULT NULL COMMENT '启用工作时间',
  `gametype` text,
  `gamemodel` varchar(32) DEFAULT NULL,
  `hallgametype` text,
  `waittime` int(11) DEFAULT NULL,
  `anysdk` tinyint(4) DEFAULT '0',
  `anysdkpay` tinyint(4) DEFAULT '0',
  `anysdkshare` tinyint(4) DEFAULT '0',
  `anysdklogin` tinyint(4) DEFAULT '0',
  `oauthserver` varchar(255) DEFAULT NULL,
  `appkey` varchar(150) DEFAULT NULL,
  `appsecret` varchar(200) DEFAULT NULL,
  `privatekey` varchar(200) DEFAULT NULL,
  `subsidy` tinyint(4) DEFAULT NULL,
  `subtimes` int(11) DEFAULT NULL,
  `subgolds` int(11) DEFAULT NULL,
  `submsg` varchar(255) DEFAULT NULL,
  `recmsg` varchar(255) DEFAULT NULL,
  `subovermsg` varchar(255) DEFAULT NULL,
  `nosubmsg` varchar(255) DEFAULT NULL,
  `welfare` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_gameconfig
-- ----------------------------
INSERT INTO `bm_gameconfig` VALUES ('402888815e663eca015e6640058e0001', 'beimi', '297e8c7b455798280145579c73e501c1', null, null, null, null, '未匹配到玩家，房间已解散', null, '0', '2018-03-09 17:50:33', '0', '1', '0', '120', '120', '10', '10', null, null, '0', '402888815e0521d8015e052341f70001,402888815e0521d8015e052342080002', 'hall', null, null, '1', '0', '0', '0', '', '', '', '', '1', '3', '4000', '亲，金币没有了，您可以先领取救济金！', '亲，您的金币不足，请充值。', '您今天的救济次数已用完，请充值。', '请，您没有救济次数啦！', 'turn,over,sign');

-- ----------------------------
-- Table structure for `bm_game_ai`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_ai`;
CREATE TABLE `bm_game_ai` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `sessionmsg` varchar(255) DEFAULT NULL COMMENT '会话消息',
  `distribution` varchar(32) DEFAULT NULL COMMENT '坐席分配策略',
  `timeoutmsg` varchar(255) DEFAULT NULL COMMENT '超时提醒消息',
  `retimeoutmsg` varchar(255) DEFAULT NULL COMMENT '再次超时提醒消息',
  `satisfaction` tinyint(4) DEFAULT NULL COMMENT '启用满意度调查',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `timeout` int(11) DEFAULT NULL COMMENT '超时时长',
  `retimeout` int(11) DEFAULT NULL COMMENT '再次超时时长',
  `maxai` int(11) DEFAULT NULL COMMENT '最大AI数量',
  `initmaxuser` int(11) DEFAULT NULL COMMENT '首次就绪分配用户数',
  `hourcheck` tinyint(4) DEFAULT NULL COMMENT '启用工作时间',
  `gametype` text,
  `gamemodel` varchar(32) DEFAULT NULL,
  `hallgametype` text,
  `enableai` tinyint(4) DEFAULT NULL COMMENT '是否启用AI',
  `waittime` int(11) DEFAULT NULL COMMENT '玩家等待时长',
  `initcoins` int(11) DEFAULT NULL COMMENT '初始化金币',
  `initcards` int(11) DEFAULT NULL COMMENT '初始化房卡',
  `initdiamonds` int(11) DEFAULT NULL COMMENT '初始化钻石',
  `exitcon` varchar(32) DEFAULT NULL COMMENT '退出条件',
  `dicinfo` tinyint(4) DEFAULT NULL,
  `aichat` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_ai
-- ----------------------------
INSERT INTO `bm_game_ai` VALUES ('40288881600d551801600d55a1780000', 'beimi', '297e8c7b455798280145579c73e501c1', null, null, null, null, null, null, null, '2017-12-08 08:42:38', null, null, '0', null, null, null, null, null, '1', '5', '8000', '10', '10', 'bank', '1', '1');

-- ----------------------------
-- Table structure for `bm_game_group`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_group`;
CREATE TABLE `bm_game_group` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(32) DEFAULT NULL,
  `TITLE` varchar(32) DEFAULT NULL,
  `CODE` varchar(32) DEFAULT NULL,
  `PARENTID` varchar(32) DEFAULT NULL,
  `TYPE` varchar(32) DEFAULT NULL,
  `MEMO` varchar(255) DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `STATUS` varchar(32) DEFAULT NULL,
  `CREATETIME` timestamp NULL DEFAULT NULL,
  `UPDATETIME` timestamp NULL DEFAULT NULL,
  `CREATER` varchar(255) DEFAULT NULL,
  `PLAYWAYID` varchar(32) DEFAULT NULL,
  `GAME` varchar(32) DEFAULT NULL,
  `SORTINDEX` int(11) DEFAULT '0',
  `STYLE` varchar(32) DEFAULT NULL,
  UNIQUE KEY `SQL121227155530400` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_group
-- ----------------------------
INSERT INTO `bm_game_group` VALUES ('4028888160297cb001602980d6180000', '确定地主', null, 'dizhu', null, 'radio', null, 'beimi', null, '2017-12-06 23:03:42', '2017-12-06 23:03:42', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', 'four');
INSERT INTO `bm_game_group` VALUES ('4028888160297cb001602982f6780003', '地主封顶', null, 'limit', null, 'radio', null, 'beimi', null, '2017-12-07 09:48:50', '2017-12-07 09:48:50', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '2', 'four');
INSERT INTO `bm_game_group` VALUES ('4028888160297cb00160298458bb0007', '局数', null, 'games', null, 'radio', null, 'beimi', null, '2017-12-06 23:04:00', '2017-12-06 23:04:00', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '2', 'three');
INSERT INTO `bm_game_group` VALUES ('40288881602a0f1701602a100cba0000', '玩法', null, 'game', null, 'radio', null, 'beimi', null, '2017-12-06 23:03:12', '2017-12-06 23:03:12', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', 'four');
INSERT INTO `bm_game_group` VALUES ('402888816045059b016045b092610000', '模式', null, 'model', null, 'checkbox', null, 'beimi', null, '2017-12-11 21:08:08', '2017-12-11 21:08:08', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'four');
INSERT INTO `bm_game_group` VALUES ('402888816045059b016045b2d3de0006', '加倍', null, 'rota', null, 'radio', null, 'beimi', null, '2017-12-11 21:10:36', '2017-12-11 21:10:36', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'four');
INSERT INTO `bm_game_group` VALUES ('402888816045059b016045b5691c000a', '局数', null, 'games', null, 'radio', null, 'beimi', null, '2017-12-11 21:14:28', '2017-12-11 21:14:28', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'three');

-- ----------------------------
-- Table structure for `bm_game_groupitem`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_groupitem`;
CREATE TABLE `bm_game_groupitem` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(32) DEFAULT NULL,
  `TITLE` varchar(32) DEFAULT NULL,
  `CODE` varchar(32) DEFAULT NULL,
  `GROUPID` varchar(32) DEFAULT NULL,
  `TYPE` varchar(32) DEFAULT NULL,
  `MEMO` varchar(255) DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `STATUS` varchar(32) DEFAULT NULL,
  `CREATETIME` timestamp NULL DEFAULT NULL,
  `UPDATETIME` timestamp NULL DEFAULT NULL,
  `CREATER` varchar(255) DEFAULT NULL,
  `PLAYWAYID` varchar(32) DEFAULT NULL,
  `GAME` varchar(32) DEFAULT NULL,
  `DEFAULTVALUE` tinyint(4) DEFAULT NULL,
  `VALUE` varchar(255) DEFAULT NULL,
  `SORTINDEX` int(11) DEFAULT '0',
  UNIQUE KEY `SQL121227155530400` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_groupitem
-- ----------------------------
INSERT INTO `bm_game_groupitem` VALUES ('40288881602977a40160297a6bb20001', '无赖子', null, 'wu', '40288881602977a40160297a42aa0000', null, null, 'beimi', null, '2017-12-06 09:39:37', '2017-12-06 09:39:37', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', 'wu', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb00160298249670001', '抢地主', null, 'qiang', '4028888160297cb001602980d6180000', null, null, 'beimi', null, '2017-12-06 09:48:13', '2017-12-06 09:48:13', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', 'qiang', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb001602982931e0002', '叫分', null, 'score', '4028888160297cb001602980d6180000', null, null, 'beimi', null, '2017-12-06 09:48:31', '2017-12-06 09:48:31', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', 'score', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb0016029834ece0004', '64分', null, 'limit1', '4028888160297cb001602982f6780003', null, null, 'beimi', null, '2017-12-06 09:49:19', '2017-12-06 09:49:19', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', '64', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb00160298381550005', '128分', null, 'limit2', '4028888160297cb001602982f6780003', null, null, 'beimi', null, '2017-12-06 09:49:32', '2017-12-06 09:49:32', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', '128', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb001602983b76b0006', '256分', null, 'limit3', '4028888160297cb001602982f6780003', null, null, 'beimi', null, '2017-12-06 09:49:46', '2017-12-06 09:49:46', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', '256', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb001602984c30b0008', '8局（房卡x1）', null, 'games1', '4028888160297cb00160298458bb0007', null, null, 'beimi', null, '2017-12-06 09:50:55', '2017-12-06 09:50:55', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', '8', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb0016029852b590009', '16局（房卡x2）', null, 'games2', '4028888160297cb00160298458bb0007', null, null, 'beimi', null, '2017-12-06 09:51:21', '2017-12-06 09:51:21', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', '16', '0');
INSERT INTO `bm_game_groupitem` VALUES ('4028888160297cb001602985aebf000a', '25局（房卡x3）', null, 'games3', '4028888160297cb00160298458bb0007', null, null, 'beimi', null, '2017-12-06 09:51:55', '2017-12-06 09:51:55', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', '25', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816029f141016029f359510002', '红中癞子', null, 'hong', '40288881602977a40160297a42aa0000', null, null, 'beimi', null, '2017-12-06 11:51:42', '2017-12-06 11:51:42', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', 'hong', '0');
INSERT INTO `bm_game_groupitem` VALUES ('40288881602a0f1701602a106a530001', '经典玩法', null, 'dizhu', '40288881602a0f1701602a100cba0000', null, null, 'beimi', null, '2017-12-06 12:23:27', '2017-12-06 12:23:27', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '1', 'dizhu', '0');
INSERT INTO `bm_game_groupitem` VALUES ('40288881602a0f1701602a109f490002', '癞子玩法', null, 'laizi', '40288881602a0f1701602a100cba0000', null, null, 'beimi', null, '2017-12-06 12:23:41', '2017-12-06 12:23:41', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba5fe7d0002', '402888815fe3f44a015feba097ce0000', '0', 'laizi', '1');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b0fc420001', '无字牌', null, 'wind', '402888816045059b016045b092610000', null, null, 'beimi', null, '2017-12-11 21:08:35', '2017-12-11 21:08:35', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'true', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b17f5c0002', '可以吃牌', null, 'chi', '402888816045059b016045b092610000', null, null, 'beimi', null, '2017-12-11 21:09:09', '2017-12-11 21:09:09', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'chi', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b1c77a0003', '可抢杠胡', null, 'ganghu', '402888816045059b016045b092610000', null, null, 'beimi', null, '2017-12-11 21:09:27', '2017-12-11 21:09:27', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '1', 'ganghu', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b1fa4f0004', '可点炮胡', null, 'dian', '402888816045059b016045b092610000', null, null, 'beimi', null, '2017-12-11 21:09:40', '2017-12-11 21:09:40', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'dian', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b258ac0005', '可胡七对', null, 'qi', '402888816045059b016045b092610000', null, null, 'beimi', null, '2017-12-11 21:10:04', '2017-12-11 21:10:04', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '1', 'qi', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b30e230007', '跟庄', null, 'zhuang', '402888816045059b016045b2d3de0006', null, null, 'beimi', null, '2017-12-11 21:10:51', '2017-12-11 21:10:51', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '1', 'zhuang', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b356500008', '杠开x2', null, 'gang', '402888816045059b016045b2d3de0006', null, null, 'beimi', null, '2017-12-11 21:11:09', '2017-12-11 21:11:09', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'gang', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b4c6ce0009', '抢杠胡', null, 'qiang', '402888816045059b016045b2d3de0006', null, null, 'beimi', null, '2017-12-11 21:12:43', '2017-12-11 21:12:43', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', 'qiang', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b5fb3c000b', '8局（房卡x1）', null, 'games1', '402888816045059b016045b5691c000a', null, null, 'beimi', null, '2017-12-11 21:14:02', '2017-12-11 21:14:02', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', '8', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b622a1000c', '16局（房卡x2）', null, 'games2', '402888816045059b016045b5691c000a', null, null, 'beimi', null, '2017-12-11 23:38:34', '2017-12-11 23:38:40', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '1', '16', '0');
INSERT INTO `bm_game_groupitem` VALUES ('402888816045059b016045b647e6000d', '25局（房卡x3）', null, 'games3', '402888816045059b016045b5691c000a', null, null, 'beimi', null, '2017-12-11 21:14:22', '2017-12-11 21:14:22', '297e8c7b455798280145579c73e501c1', '402888815fe3f44a015feba86a330003', '402888815fe3f44a015feba097ce0000', '0', '25', '0');

-- ----------------------------
-- Table structure for `bm_game_mjcardstype`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_mjcardstype`;
CREATE TABLE `bm_game_mjcardstype` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级分类ID',
  `GAME` varchar(32) DEFAULT NULL,
  `GANG` varchar(32) DEFAULT NULL,
  `PENG` varchar(32) DEFAULT NULL,
  `CHI` varchar(32) DEFAULT NULL,
  `PAIR` varchar(32) DEFAULT NULL,
  `SELF` tinyint(32) DEFAULT NULL,
  `LAST` tinyint(4) DEFAULT NULL,
  `LASTGANG` tinyint(4) DEFAULT NULL,
  `RATE` int(11) DEFAULT NULL,
  `CARDSTYPE` text,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_mjcardstype
-- ----------------------------

-- ----------------------------
-- Table structure for `bm_game_playway`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_playway`;
CREATE TABLE `bm_game_playway` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `area` text,
  `parentid` varchar(32) DEFAULT '0',
  `typeid` varchar(32) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `game` varchar(32) DEFAULT NULL,
  `players` int(11) DEFAULT NULL,
  `cards` int(11) DEFAULT NULL,
  `roomtype` varchar(32) DEFAULT NULL,
  `score` int(11) DEFAULT NULL,
  `mincoins` int(11) DEFAULT NULL,
  `maxcoins` int(11) DEFAULT NULL,
  `changecard` tinyint(4) DEFAULT NULL,
  `shuffle` tinyint(4) DEFAULT NULL,
  `numofgames` int(11) DEFAULT NULL,
  `cardsnum` int(11) DEFAULT NULL,
  `typelevel` varchar(20) DEFAULT NULL,
  `typecolor` varchar(20) DEFAULT NULL,
  `sortindex` int(11) DEFAULT NULL,
  `powerful` varchar(32) DEFAULT NULL,
  `shuffletimes` int(11) DEFAULT NULL,
  `wind` tinyint(4) DEFAULT NULL,
  `memo` varchar(200) DEFAULT NULL,
  `free` tinyint(4) DEFAULT '0',
  `roomtitle` varchar(50) DEFAULT NULL,
  `extpro` tinyint(4) DEFAULT '0',
  `cardsrules` text,
  `mjwinrules` text,
  `wintype` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_playway
-- ----------------------------
INSERT INTO `bm_game_playway` VALUES ('402888815e21d735015e21d995680000', '初级场', 'dizhu', '2017-08-27 12:01:01', '297e8c7b455798280145579c73e501c1', '2017-09-10 09:48:05', 'beimi', null, null, null, '402888815e14abfb015e14b6e2080002', null, '402888815e0521d8015e052342080002', '3', null, null, '10000', '1000', '100000', '0', '1', '0', '17', '1', '2', '1', null, '1', '0', null, '0', null, '0', null, null, null);
INSERT INTO `bm_game_playway` VALUES ('402888815e671780015e6718ebce0000', '高级场', 'dizhu', '2017-09-09 22:44:00', '297e8c7b455798280145579c73e501c1', '2017-09-10 09:48:09', 'beimi', null, null, null, '402888815e14abfb015e14b6e2080002', null, '402888815e0521d8015e052342080002', '3', null, null, '50000', '50000', '200000', '0', '1', '0', '17', '2', '2', '3', null, '1', '0', null, '0', null, '0', null, null, null);
INSERT INTO `bm_game_playway` VALUES ('402888815e672639015e675125750000', '初级场（不洗牌）', 'dizhu', '2017-09-09 23:45:25', '297e8c7b455798280145579c73e501c1', '2017-09-10 09:48:07', 'beimi', null, null, null, '402888815e14abfb015e14b6e2080002', null, '402888815e0521d8015e052342080002', '3', null, null, '10000', '1000', '100000', '0', '0', '0', '17', '1', '1', '2', null, '1', '0', null, '0', null, '0', null, null, null);
INSERT INTO `bm_game_playway` VALUES ('402888815e672639015e675215ed0001', '高级场（不洗牌）', 'dizhu', '2017-09-09 23:46:26', '297e8c7b455798280145579c73e501c1', '2017-09-10 09:48:11', 'beimi', null, null, null, '402888815e14abfb015e14b6e2080002', null, '402888815e0521d8015e052342080002', '3', null, null, '50000', '50000', '200000', '0', '0', '0', '17', '2', '2', '4', null, '1', '0', null, '0', null, '0', null, null, null);
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e71529f3a0001', '初级场', 'majiang', '2017-09-11 22:23:14', '297e8c7b455798280145579c73e501c1', '2018-01-01 23:14:14', 'beimi', null, null, null, '402888815e14abfb015e14b5f6840001', null, '402888815e0521d8015e052341f70001', '4', null, null, '2000', '2000', '100000', '0', '0', '0', '13', '1', '1', '1', null, '0', '1', '', '0', '房间-经典斗地主', '0', null, null, 'river');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e715337570002', '初级场（换三张）', 'majiang', '2017-09-11 22:23:53', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:00', 'beimi', null, null, null, '402888815e14abfb015e14b5f6570000', null, '402888815e0521d8015e052341f70001', '4', null, null, '2000', '2000', '100000', '1', '0', '0', '13', '1', '2', '2', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'end');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e7153aa0a0003', '高级场', 'majiang', '2017-09-11 22:24:22', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:07', 'beimi', null, null, null, '402888815e14abfb015e14b5f6570000', null, '402888815e0521d8015e052341f70001', '4', null, null, '5000', '5000', '200000', '0', '0', '0', '13', '2', '1', '3', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'end');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e7155dc180004', '高级场（换三张）', 'majiang', '2017-09-11 22:26:46', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:11', 'beimi', null, null, null, '402888815e14abfb015e14b5f6570000', null, '402888815e0521d8015e052341f70001', '4', null, null, '5000', '5000', '200000', '0', '0', '0', '13', '2', '2', '4', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'end');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e7159b5120005', '初级场', 'majiang', '2017-09-11 22:30:58', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:26:57', 'beimi', null, null, null, '402888815e14abfb015e14b5f6570000', null, '402888815e0521d8015e052341f70001', '4', null, null, '2000', '2000', '100000', '0', '0', '0', '13', '1', '1', '1', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'end');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e715a32980006', '初级场（换三张）', 'majiang', '2017-09-11 22:31:30', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:17', 'beimi', null, null, null, '402888815e14abfb015e14b5f6840001', null, '402888815e0521d8015e052341f70001', '4', null, null, '2000', '2000', '100000', '1', '0', '0', '13', '1', '2', '2', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'river');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e715bd3d40007', '高级场', 'majiang', '2017-09-11 22:33:17', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:20', 'beimi', null, null, null, '402888815e14abfb015e14b5f6840001', null, '402888815e0521d8015e052341f70001', '4', null, null, '5000', '5000', '200000', '0', '0', '0', '13', '2', '1', '3', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'river');
INSERT INTO `bm_game_playway` VALUES ('402888815e6f0177015e715ce4300008', '高级场（换三张）', 'majiang', '2017-09-11 22:34:27', '297e8c7b455798280145579c73e501c1', '2017-12-22 16:27:25', 'beimi', null, null, null, '402888815e14abfb015e14b5f6840001', null, '402888815e0521d8015e052341f70001', '2', null, null, '5000', '5000', '200000', '1', '0', '0', '13', '2', '2', '4', null, '0', '0', '', '0', '房间-经典斗地主', '0', null, null, 'river');
INSERT INTO `bm_game_playway` VALUES ('402888815fe3f44a015feba5fe7d0002', '经典斗地主', 'dizhu', '2017-11-24 09:30:45', '297e8c7b455798280145579c73e501c1', '2017-12-07 18:45:00', 'beimi', null, null, null, '402888815fe3f44a015feba50c940001', null, '402888815fe3f44a015feba097ce0000', '3', null, null, '2', '0', '0', '0', '1', '0', '17', '3', '1', '1', null, '0', '0', '斗地主玩法简介，测试一下简介信息是否能够正常显示在界面上。', '1', '房间-经典斗地主', '1', null, null, null);
INSERT INTO `bm_game_playway` VALUES ('402888815fe3f44a015feba86a330003', '广东麻将', 'majiang', '2017-11-24 09:33:24', '297e8c7b455798280145579c73e501c1', '2017-12-13 15:15:29', 'beimi', null, null, null, '402888815fe3f44a015feba50c940001', null, '402888815fe3f44a015feba097ce0000', '4', null, null, '2', '0', '0', '0', '0', '0', '13', '3', '1', '1', null, '0', '1', '麻将玩法简介，测试一下是否能够正常显示玩法信息，看下游戏显示', '0', '房间-广东麻将', '1', null, null, null);

-- ----------------------------
-- Table structure for `bm_game_room`
-- ----------------------------
DROP TABLE IF EXISTS `bm_game_room`;
CREATE TABLE `bm_game_room` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `area` text,
  `parentid` varchar(32) DEFAULT '0',
  `typeid` varchar(32) DEFAULT NULL,
  `roomid` varchar(32) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `game` varchar(32) DEFAULT NULL,
  `players` int(11) DEFAULT NULL,
  `master` varchar(32) DEFAULT NULL,
  `roomtype` varchar(32) DEFAULT NULL,
  `playway` varchar(32) DEFAULT NULL,
  `numofgames` int(11) DEFAULT NULL,
  `currentnum` int(11) DEFAULT NULL,
  `curpalyers` int(11) DEFAULT NULL,
  `cardroom` tinyint(4) DEFAULT NULL,
  `cardsnum` int(11) DEFAULT NULL,
  `matchmodel` tinyint(4) DEFAULT NULL,
  `matchid` varchar(32) DEFAULT NULL,
  `matchscreen` int(11) DEFAULT NULL,
  `matchtype` varchar(32) DEFAULT NULL,
  `lastwinner` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_game_room
-- ----------------------------
INSERT INTO `bm_game_room` VALUES ('12f50d0807384a6186885f0423453289', null, null, '2018-02-23 18:04:28', '61a72e84e1414f5ab87944755677eeaa', '2018-02-23 18:04:28', 'beimi', null, null, null, null, '06c639ab3fda43c5941fb1a725a9203d', 'CRERATED', null, '3', '61a72e84e1414f5ab87944755677eeaa', 'hall', '402888815e671780015e6718ebce0000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('2525dae2f8bf460fa68130750f03b464', null, null, '2018-02-23 18:48:13', 'f9f0bc5773a74eaea525ff369d5f9a0a', '2018-02-23 18:48:13', 'beimi', null, null, null, null, '7b440ca47e5048588332bb91a610653a', 'CRERATED', null, '3', 'f9f0bc5773a74eaea525ff369d5f9a0a', 'hall', '402888815e672639015e675125750000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('4296e4d4668e44d7a5ff1528a82e0785', null, null, '2018-02-07 19:33:40', '2e6a8c45c67948429f6d634eb1b7a765', '2018-02-07 19:33:40', 'beimi', null, null, null, null, '4058111c2d1248888a04c429c108adef', 'CRERATED', null, '3', '2e6a8c45c67948429f6d634eb1b7a765', 'hall', '402888815e21d735015e21d995680000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('4ba0c5a6754941f69cb0e95184c9cd6b', null, null, '2018-02-23 18:03:48', '7db33a3794014e2c9815df44409376cd', '2018-02-23 18:03:48', 'beimi', null, null, null, null, '49982c7636064c22906b61dc8daf9883', 'CRERATED', null, '3', '7db33a3794014e2c9815df44409376cd', 'hall', '402888815e671780015e6718ebce0000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('8def85a62f9e47eb8c4d3494e17ca2fb', null, null, '2018-02-23 17:55:14', '30ce1a7d191841e3a5cfdd1c1da20ac3', '2018-02-23 17:55:14', 'beimi', null, null, null, null, '2582938ec7e44905875cc92c054d7079', 'CRERATED', null, '3', '30ce1a7d191841e3a5cfdd1c1da20ac3', 'hall', '402888815e21d735015e21d995680000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('9009b3bac6ca4d898ea913b3d58d1120', null, null, '2018-02-28 15:07:10', '4fa01cb4344c4eff9b83a847d842621a', '2018-02-28 15:07:10', 'beimi', null, null, null, null, 'b7f540e2a4844b18bbbbcca6a29052ae', 'CRERATED', null, '3', '4fa01cb4344c4eff9b83a847d842621a', 'hall', '402888815e21d735015e21d995680000', '0', '0', '1', '0', '17', '0', null, '0', null, null);
INSERT INTO `bm_game_room` VALUES ('e435a49c6c814dbeb55514052518327d', null, null, '2018-02-23 18:43:08', '9ea899c8191049e9ae87b7d28c9e23b0', '2018-02-23 18:43:08', 'beimi', null, null, null, null, '36dddaec746a48739e0eb8b861b8e1ee', 'CRERATED', null, '3', '9ea899c8191049e9ae87b7d28c9e23b0', 'hall', '402888815e672639015e675215ed0001', '0', '0', '1', '0', '17', '0', null, '0', null, null);

-- ----------------------------
-- Table structure for `bm_generation`
-- ----------------------------
DROP TABLE IF EXISTS `bm_generation`;
CREATE TABLE `bm_generation` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属组件',
  `startinx` int(11) DEFAULT NULL COMMENT '开始位置',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_generation
-- ----------------------------
INSERT INTO `bm_generation` VALUES ('402888815c7106fb015c712334910009', 'workorders', '63', 'ukewo', null, '2017-06-04 11:25:51');

-- ----------------------------
-- Table structure for `bm_organ`
-- ----------------------------
DROP TABLE IF EXISTS `bm_organ`;
CREATE TABLE `bm_organ` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENT` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `SKILL` tinyint(4) DEFAULT '0' COMMENT '启用技能组',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_organ
-- ----------------------------
INSERT INTO `bm_organ` VALUES ('40288881601a365301601a3b79560000', '项目开发', null, null, null, null, 'beimi', null, null, '0');

-- ----------------------------
-- Table structure for `bm_organrole`
-- ----------------------------
DROP TABLE IF EXISTS `bm_organrole`;
CREATE TABLE `bm_organrole` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `organ_id` varchar(32) DEFAULT NULL COMMENT '机构ID',
  `role_id` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_organrole
-- ----------------------------

-- ----------------------------
-- Table structure for `bm_playuser`
-- ----------------------------
DROP TABLE IF EXISTS `bm_playuser`;
CREATE TABLE `bm_playuser` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `LANGUAGE` varchar(255) DEFAULT NULL COMMENT '语言',
  `USERNAME` varchar(255) DEFAULT NULL COMMENT '用户名',
  `PASSWORD` varchar(255) DEFAULT NULL COMMENT '密码',
  `SECURECONF` varchar(255) DEFAULT NULL COMMENT '安全级别',
  `EMAIL` varchar(255) DEFAULT NULL COMMENT '邮件',
  `FIRSTNAME` varchar(255) DEFAULT NULL COMMENT '姓',
  `MIDNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `LASTNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `JOBTITLE` varchar(255) DEFAULT NULL COMMENT '职位',
  `DEPARTMENT` varchar(255) DEFAULT NULL COMMENT '部门',
  `GENDER` varchar(255) DEFAULT NULL COMMENT '性别',
  `BIRTHDAY` varchar(255) DEFAULT NULL COMMENT '生日',
  `NICKNAME` varchar(255) DEFAULT NULL COMMENT '昵称',
  `USERTYPE` varchar(255) DEFAULT NULL COMMENT '用户类型',
  `RULENAME` varchar(255) DEFAULT NULL COMMENT '角色',
  `SEARCHPROJECTID` varchar(255) DEFAULT NULL COMMENT '备用',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `MEMO` varchar(255) DEFAULT NULL COMMENT '备注',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `MOBILE` varchar(32) DEFAULT NULL COMMENT '手机号',
  `passupdatetime` datetime DEFAULT NULL COMMENT '最后 一次密码修改时间',
  `sign` varchar(100) DEFAULT NULL,
  `del` tinyint(4) DEFAULT '0',
  `login` tinyint(4) DEFAULT '0',
  `online` tinyint(4) DEFAULT '0',
  `headimg` tinyint(4) DEFAULT '0' COMMENT '是否设置头像',
  `secquestion` tinyint(4) DEFAULT '0' COMMENT '是否设置密保问题',
  `playerlevel` varchar(32) DEFAULT NULL COMMENT '玩家等级',
  `experience` int(11) DEFAULT '0' COMMENT '玩家积分',
  `uname` varchar(100) DEFAULT NULL,
  `musteditpassword` tinyint(4) DEFAULT NULL,
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `fans` int(11) DEFAULT '0' COMMENT '关注人数',
  `follows` int(11) DEFAULT '0' COMMENT '被关注次数',
  `integral` int(11) DEFAULT '0',
  `lastlogintime` datetime DEFAULT NULL COMMENT '最后登录时间',
  `status` varchar(10) DEFAULT NULL COMMENT '状态',
  `deactivetime` datetime DEFAULT NULL COMMENT '离线时间',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `token` varchar(50) DEFAULT NULL,
  `cards` int(11) DEFAULT NULL,
  `goldcoins` int(11) DEFAULT NULL,
  `diamonds` int(11) DEFAULT NULL,
  `openid` varchar(100) DEFAULT NULL,
  `qqid` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `region` varchar(200) DEFAULT NULL,
  `isp` varchar(100) DEFAULT NULL,
  `ostype` varchar(32) DEFAULT NULL,
  `disabled` tinyint(4) DEFAULT NULL,
  `useragent` varchar(255) DEFAULT NULL,
  `browser` varchar(100) DEFAULT NULL,
  `playertype` varchar(50) DEFAULT NULL,
  `gamestatus` varchar(50) DEFAULT NULL,
  `roomid` varchar(32) DEFAULT NULL,
  `roomready` tinyint(4) DEFAULT '0',
  `opendeal` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_playuser
-- ----------------------------
INSERT INTO `bm_playuser` VALUES ('01eb1966041548d8bee982bc1310d6ab', null, 'Guest_1hxEZN', '79cc84b72b26f2eb9cdc782c5fbf779f', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:31:14', null, '2018-02-24 00:31:14', null, '2018-02-24 00:31:14', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:31:14', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('0b274bde8921429e88124eeb015dac08', null, 'Guest_09NYl0', 'a84cc50724d95a28a63a594e3f8e5ba8', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:26:10', null, '2018-02-23 16:26:10', null, '2018-02-23 16:26:10', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:26:10', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('0dc54e6fe24d46f297a664286eafc681', null, 'Guest_1sQpBM', '031e55299edfafc9c497e044fe426248', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:41:40', null, '2018-02-23 18:41:40', null, '2018-02-23 18:41:40', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:41:40', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('103d1852766b44939a4b7b25c075113f', null, 'Guest_0sR18U', '396dd9633d0ce06e657787e8f6678152', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 01:05:45', null, '2018-02-24 01:05:45', null, '2018-02-24 01:05:45', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 01:05:45', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('10ec74c483fb43a1b088d6b00bdf4a1d', null, 'Guest_0wkssR', 'ef1ce5200ec1308539915bf4865ca6ab', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 01:12:42', null, '2018-02-24 01:12:42', null, '2018-02-24 01:12:42', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 01:12:42', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('11c83b108fea45d9b236b9631ece78e7', null, 'Guest_00gkNA', 'bb8e8acd603ce826cf850d2b2da5910e', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:37:50', null, '2018-02-23 16:37:50', null, '2018-02-23 16:37:50', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:37:50', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('11eeccca37d44899a18333e4b13e0659', null, 'Guest_1RQA0h', '85f3f7fb0e8872be1a2734487822e7f9', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:41:35', null, '2018-02-23 19:41:35', null, '2018-02-23 19:41:35', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:41:35', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('1814b27c3ed64190a86944752b536054', null, 'Guest_1AEsIt', 'd9b8c3d04b3b68d4444f3ae2b7b4b88c', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 12:05:44', null, '2018-02-23 12:05:44', null, '2018-02-23 12:05:44', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 12:05:44', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('1a0da82354d04c30a4e0ed68af838a8a', null, 'Guest_0s0sJ0', 'ae6b555b33501b155ac1cb5a1fef097a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:49:43', null, '2018-02-23 18:49:43', null, '2018-02-23 18:49:43', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:49:43', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('1af55a3113624e14bddcf8a03dd38e13', null, 'Guest_1wgAwU', '308b2ce97ec77ccc86862c5549ba1ef7', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:52:49', null, '2018-02-23 18:52:49', null, '2018-02-23 18:52:49', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:52:49', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('1dba09fa72b644edbe461e865601704e', null, 'Guest_1RsFlZ', 'f55b13fd0de82d9ed80fe790e78196c1', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:42:12', null, '2018-02-23 19:42:12', null, '2018-02-23 19:42:12', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:42:12', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('1f4a54186f844d9da36f0869a1414694', null, 'Guest_0tRhgR', '5d2c57c1ca5af2175e432d3a756bd143', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:55:50', null, '2018-02-23 18:55:50', null, '2018-02-23 18:55:50', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:55:50', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('216798ee2ad641e58e247ee16b4da753', null, 'Guest_11tE0w', 'da9b70d74c8126547b37cccb3276772d', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:40:46', null, '2018-02-23 18:40:46', null, '2018-02-23 18:40:46', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:40:46', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('25224aad346e429ab133d25cdadd26c6', null, 'Guest_1AxYpg', '429c97e8f9e340f0158616d7448f5997', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:10:45', null, '2018-02-23 18:10:45', null, '2018-02-23 18:10:45', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:10:45', null, null, null, '0', 'f51b777236764805a816de5705a67790', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', 'ready', '4ba0c5a6754941f69cb0e95184c9cd6b', '0', '0');
INSERT INTO `bm_playuser` VALUES ('286d533fff3b4aa180db0a209150c079', null, 'Guest_0xdQw0', 'bb5ec35b49b0874e1e6c940d037a776a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:40:38', null, '2018-02-23 16:40:38', null, '2018-02-23 16:40:38', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:40:38', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('287113f6d09144749f0c46b85116999a', null, 'Guest_148ZMR', 'fb1fb8f095236379c65a673eb7132396', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:23:08', null, '2018-02-23 16:23:08', null, '2018-02-23 16:23:08', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:23:08', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('28fed02e346740cc945bbe766aaf7704', null, 'Guest_1kE81N', '58c6d06ae9623f064ccc174ab80c1c16', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:02:16', null, '2018-02-23 16:02:16', null, '2018-02-23 16:02:16', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:02:16', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/64142', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('2bd3860ddcc54ac1b5739d7cb02bfc21', null, 'Guest_1MdQVY', '70ed10af50b5b56d3b028a59ded92474', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 17:39:20', null, '2018-02-23 17:39:20', null, '2018-02-23 17:39:20', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 17:39:20', null, null, null, '0', '4126d5514e8640cea61b1390273f990c', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', 'ready', '4296e4d4668e44d7a5ff1528a82e0785', '0', '0');
INSERT INTO `bm_playuser` VALUES ('2e6a8c45c67948429f6d634eb1b7a765', null, 'Guest_1pkIsJ', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-07 19:33:09', null, '2018-02-07 19:33:09', null, '2018-02-07 19:33:09', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-07 19:33:09', null, null, null, '0', '476691c772e34e689aa7567065fe8d7b', '10', '21000', '10', null, null, null, null, null, null, '0', null, null, 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('30ce1a7d191841e3a5cfdd1c1da20ac3', null, 'Guest_0lBk0c', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 17:55:11', null, '2018-02-23 17:55:11', null, '2018-02-23 17:55:11', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 17:55:11', null, null, null, '0', '9f12578b1cb547259a118f0f244d55a1', '10', '0', '10', null, null, null, null, null, null, '0', null, null, 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('32085f7a904b47e1bcd9455e0220be63', null, 'Guest_0EVUsQ', 'c849d433c9de0be2c2ae32b6664d8faa', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:47:33', null, '2018-02-23 18:47:33', null, '2018-02-23 18:47:33', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:47:33', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('33862e5253ea4872a0217d90ca08b84b', null, 'Guest_1IAhs9', 'ef97f94372504cd5dcda25ba74250840', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:40:02', null, '2018-02-23 19:40:02', null, '2018-02-23 19:40:02', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:40:02', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('3803bd5554d44399b56a11755233ab2f', null, 'Guest_1hFgQs', 'c3e63a006b779c1ffdc284edfdfed2b9', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-12 18:05:35', null, '2018-03-12 18:05:35', null, '2018-03-12 18:05:35', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-12 18:05:35', null, null, null, '0', null, '10', '13000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('3a2eb50cb2274974ade9ca51a211ea2b', null, 'Guest_0Fc4cJ', '96c46a1c60cc06cc58b9aa6b6ad2dcb5', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 15:14:24', null, '2018-03-07 15:14:24', null, '2018-03-07 15:14:24', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 15:14:24', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('3b79e2aae2b04927af2a271b0f9dd72b', null, 'Guest_0VolcV', 'e66859646dddb85980c214f073edce47', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:24:50', null, '2018-02-24 00:24:50', null, '2018-02-24 00:24:50', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:24:50', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('3ea302307a294f7dbdf8253e301ceee8', null, 'Guest_1554V8', '2cb8b0a782101389912093fd61e6f6db', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:20:59', null, '2018-02-24 00:20:59', null, '2018-02-24 00:20:59', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:20:59', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('434b75edfbcc4b298995399a9efb88a9', null, 'Guest_0tp90V', 'f6c1734e2d3619abc6eee6953b9ee81a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 01:09:01', null, '2018-02-24 01:09:01', null, '2018-02-24 01:09:01', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 01:09:01', null, null, null, '0', '1110d1bb4d0943e488c8fffeebbb638e', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('4fa01cb4344c4eff9b83a847d842621a', null, 'Guest_1I0IQM', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-28 11:04:27', null, '2018-02-28 11:04:27', null, '2018-02-28 11:04:27', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-28 11:04:27', null, null, null, '0', '9c775b3995e54748aae76b0bae4e330e', '10', '0', '10', null, null, null, null, null, null, '0', null, null, 'normal', 'ready', '9009b3bac6ca4d898ea913b3d58d1120', '0', '0');
INSERT INTO `bm_playuser` VALUES ('511fd97bfd0c4c8db1fa55d64b0138aa', null, 'Guest_108Fg1', 'e17cdf12a4848c32e107f1e76c0bc283', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 01:20:51', null, '2018-02-24 01:20:51', null, '2018-02-24 01:20:51', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 01:20:51', null, null, null, '0', 'd32431bd68aa436dbf5de9b38116209f', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', 'ready', '4296e4d4668e44d7a5ff1528a82e0785', '0', '0');
INSERT INTO `bm_playuser` VALUES ('515e2be3e0ee4fd3ae0129ec73328f31', null, 'Guest_0o4lAd', '791d5d207611e63fd8918ed224de5087', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:53:41', null, '2018-02-23 18:53:41', null, '2018-02-23 18:53:41', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:53:41', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('535dd41eac894777bbbc6a9709621b78', null, 'Guest_1ts8wp', 'de6c925fd1ec2a087a46a2dde718ce7e', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:41:01', null, '2018-02-23 16:41:01', null, '2018-02-23 16:41:01', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:41:01', null, null, null, '0', '2432e7fdb5be47f7985b87054a895252', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('56f62075b6764186ba500aef4ec34db5', null, 'Guest_1R0hI0', 'a2c6d8d64f939eb7152ee01e6f8290f1', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:43:55', null, '2018-02-23 18:43:55', null, '2018-02-23 18:43:55', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:43:55', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('580d3654daa84bad98407b108fd5407a', null, 'Guest_1sJRU4', '7fb8904d38d671532953afb20a333eaa', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:54:17', null, '2018-02-23 18:54:17', null, '2018-02-23 18:54:17', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:54:17', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('58eae07fd8b94246aa4392509f4938a3', null, 'Guest_0ZEpJs', 'd3352618828abd787f080dd70f8c3ef2', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:42:21', null, '2018-02-23 18:42:21', null, '2018-02-23 18:42:21', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:42:21', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('5b658aa83bd342abb319281f06570028', null, 'Guest_0hhxtI', '9d4ff58bcb43d764da2bd95314da05a3', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:25:33', null, '2018-02-23 16:25:33', null, '2018-02-23 16:25:33', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:25:33', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('61a72e84e1414f5ab87944755677eeaa', null, 'Guest_0Yl4RA', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:04:24', null, '2018-02-23 18:04:24', null, '2018-02-23 18:04:24', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:04:24', null, null, null, '0', '690492a1689847489f51466757f7e7b7', '10', '9000', '10', null, null, null, null, null, null, '0', null, null, 'normal', 'ready', '12f50d0807384a6186885f0423453289', '0', '0');
INSERT INTO `bm_playuser` VALUES ('6204b78677e34ca9b78405f653d7de75', null, 'Guest_0w9AwY', '6fe408a6fe08508cd02829e4a922e606', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:42:04', null, '2018-02-23 18:42:04', null, '2018-02-23 18:42:04', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:42:04', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('674a7d593c5349099c5ed34758738327', null, 'Guest_10A0pl', 'cd8cfd689c1c14d76a2710d78132adfb', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:19:40', null, '2018-02-23 16:19:40', null, '2018-02-23 16:19:40', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:19:40', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('6b3ba1ce4fef4976b2340a8d68e284ef', null, 'Guest_1lwZ55', '281229a50525c95a140ddf453456a3f3', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:40:47', null, '2018-02-23 19:40:47', null, '2018-02-23 19:40:47', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:40:47', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('6c1e2d61c6e44025849515b5f5c64b51', null, 'Guest_0Jplpx', '6f934dcdffb4a9f149c989f9ed7ad973', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:37:34', null, '2018-02-23 18:37:34', null, '2018-02-23 18:37:34', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:37:34', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('76b22431adf04fb8b176e24d789aa333', null, 'Guest_0dxV0k', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 18:31:27', null, '2018-03-07 18:31:27', null, '2018-03-07 18:31:27', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 18:31:27', null, null, null, '0', '1aa3cec458eb4913a1ce0f373e2a15fc', '10', '149000', '10', null, null, null, null, null, null, '0', null, null, 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('77373c63f10042489a35c5e72ebe69e4', null, 'Guest_0MgYR1', 'e9fa2c437a2cc23986a4bf385401412b', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 15:14:28', null, '2018-03-07 15:14:28', null, '2018-03-07 15:14:28', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 15:14:28', null, null, null, '0', null, '10', '17000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('7c9579f43fa641bc9cf187ca39cd715b', null, 'Guest_0MgF0M', '3104e3a28a19b9b1218efa887c11964d', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 12:06:02', null, '2018-02-23 12:06:02', null, '2018-02-23 12:06:02', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 12:06:02', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('7db33a3794014e2c9815df44409376cd', null, 'Guest_0NJhJc', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:03:46', null, '2018-02-23 18:03:46', null, '2018-02-23 18:03:46', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:03:46', null, null, null, '0', '7ea5c5cd90a24779a9d48b4fbf4c7814', '10', '9000', '10', null, null, null, null, null, null, '0', null, null, 'normal', 'ready', '4ba0c5a6754941f69cb0e95184c9cd6b', '0', '0');
INSERT INTO `bm_playuser` VALUES ('7ff48bca6b544d0b9dbce2dc3e44f2a9', null, 'Guest_1x5Ztp', '6017accbc853c31fe056930a70fefb1b', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-12 18:05:27', null, '2018-03-12 18:05:27', null, '2018-03-12 18:05:27', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-12 18:05:27', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('810a26b816c64750830238b9c4df55ae', null, 'Guest_0NN1dk', '111b103b19da4336738e2d5828b5fe5a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:36:33', null, '2018-02-23 18:36:33', null, '2018-02-23 18:36:33', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:36:33', null, null, null, '0', '171aa191f4f14ebb9ff2cef7a21dc81e', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('81b02e25ce564c518f941d00f998e8b6', null, 'Guest_185wdJ', '646de14391a5f61a704be4e377864c31', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 17:55:58', null, '2018-03-07 17:55:58', null, '2018-03-07 17:55:58', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 17:55:58', null, null, null, '0', null, '10', '49000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('83db5d6f7eaf4abeb4645b672dc6a8df', null, 'Guest_1kokV5', 'abd5f14c177b28f99ded305d6fee7934', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:12:47', null, '2018-02-23 18:12:47', null, '2018-02-23 18:12:47', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:12:47', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/49203', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('876f912300234ce9830427a392c8752b', null, 'Guest_0cNdpR', '2dcf1f2c2bf62638e2558d5becd60a3f', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-23 22:15:52', null, '2018-03-23 22:15:52', null, '2018-03-23 22:15:52', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-23 22:15:52', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'UnKnown', '0', 'beimi-mobile/1.0 CFNetwork/893.14 Darwin/17.3.0', 'UnKnown', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('8dc286f968ed47a7a1685c76cd9a69a9', null, 'Guest_1U1Y5J', '47436a9285ad2c7c7007ba67036013eb', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:40:05', null, '2018-02-23 18:40:05', null, '2018-02-23 18:40:05', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:40:05', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('95ec6d26d6154b1fbabd05f26fc9c4ae', null, 'Guest_1EIAhF', '8d173603a620d69acbe6a49ebe275fd2', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:02:08', null, '2018-02-23 19:02:08', null, '2018-02-23 19:02:08', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:02:08', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('963675d0b8eb4979bd74b27f3c4d35f8', null, 'Guest_058FRI', '0fee0923447191f711543b5fbd8dcf96', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-22 10:45:43', null, '2018-03-22 10:45:43', null, '2018-03-22 10:45:43', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-22 10:45:43', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', null, '0', null, null, 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('99577fe6f0134fa3bfdb7115d9c00d07', null, 'Guest_0ERdtQ', 'db17c3a1465d9a9e6e39fdbafa0abbe3', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:53:09', null, '2018-02-23 18:53:09', null, '2018-02-23 18:53:09', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:53:09', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('9a334537c00f4818bcc529b79e232f05', null, 'Guest_00BBEN', '07acac0e071fd168d113035849b69b39', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:11:20', null, '2018-02-23 18:11:20', null, '2018-02-23 18:11:20', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:11:20', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/49203', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('9ad2d58f791e4017b63c999fcc6cea2e', null, 'Guest_00RdYY', '67521355d116980604f0d1df683d0242', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:02:03', null, '2018-02-23 19:02:03', null, '2018-02-23 19:02:03', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:02:03', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('9cc039a555f24448a3ddafc4a6f1cc4a', null, 'Guest_0dR9cl', 'd081c9be8441a4297ca5142aed040cb9', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:40:20', null, '2018-02-23 16:40:20', null, '2018-02-23 16:40:20', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:40:20', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('9ea899c8191049e9ae87b7d28c9e23b0', null, 'Guest_0BocUU', '4806b475e30ecbd91dffd79db464fb5f', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:43:03', null, '2018-02-23 18:43:03', null, '2018-02-23 18:43:03', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:43:03', null, null, null, '0', 'b4627374bc1a4f63912be66fa3b31733', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', 'ready', 'e435a49c6c814dbeb55514052518327d', '0', '0');
INSERT INTO `bm_playuser` VALUES ('9f3486d579b645e398c66c730f8f6d3a', null, 'Guest_1B1sMU', '0ba82ae168e85922ca4329e5dd9a880b', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:37:10', null, '2018-02-23 16:37:10', null, '2018-02-23 16:37:10', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:37:10', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('a0c500e4cff44040a57cc392a00c3f3e', null, 'Guest_01U95o', '48e5797351b3d711ad58cde2f65de763', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:33:23', null, '2018-02-23 16:33:23', null, '2018-02-23 16:33:23', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:33:23', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('a3fb61a769654e7ea67fa75ea0b43741', null, 'Guest_1ttNBt', '050900f6c84a749a926e37f6a63097b7', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-28 11:04:42', null, '2018-02-28 11:04:42', null, '2018-02-28 11:04:42', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-28 11:04:42', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('a63ecfc9ef384723892e320295a7633e', null, 'Guest_0dYIZY', '3c259d38a7325d0037eeaebd3472a886', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 17:55:55', null, '2018-03-07 17:55:55', null, '2018-03-07 17:55:55', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 17:55:55', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('a7e5b4c24fd340c986b78d8aae5e27a5', null, 'Guest_054lAA', 'f2a101a33bb452fd98da8e7094fa6c1e', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:00:06', null, '2018-02-23 19:00:06', null, '2018-02-23 19:00:06', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:00:06', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('a9a6456b384d47e7b3f49db756472340', null, 'Guest_1BgY5t', '9dc00458cc64917b86598d95fc05a5a9', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:47:47', null, '2018-02-23 18:47:47', null, '2018-02-23 18:47:47', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:47:47', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('ad2b75d3cf5c44f59c60ebe51dddbb39', null, 'Guest_0cA5wF', 'afc4adb4fac8cbd3162f72461ecc1dec', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-28 11:04:24', null, '2018-02-28 11:04:24', null, '2018-02-28 11:04:24', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-28 11:04:24', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('afe0ea06ee034b189d1e3a309147ca0f', null, 'Guest_1B9FoJ', 'be7fb8ed70d3c3e074fbd9dfde5c07ba', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-23 11:34:03', null, '2018-03-23 11:34:03', null, '2018-03-23 11:34:03', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-23 11:34:03', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'UnKnown', '0', 'Cocos%20Simulator/20180313 CFNetwork/893.13.1 Darwin/17.3.0 (x86_64)', 'UnKnown', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b0ccedfcd4c44b4fb25813d658fa6b45', null, 'Guest_1Fc55t', '02a56b4364e058bfd8b3d494cd2f4060', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:22:47', null, '2018-02-24 00:22:47', null, '2018-02-24 00:22:47', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:22:47', null, null, null, '0', '89ca44e11dbb4782be38910b5d726600', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b12be20407ac463995e5c654f32f054c', null, 'Guest_0opZ9M', '406c3b3f5ed72a47c1ebbc2de1e18d10', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:44:30', null, '2018-02-23 18:44:30', null, '2018-02-23 18:44:30', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:44:30', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b12c95c2165e476ea8673ec438801170', null, 'Guest_150Qc0', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:11:34', null, '2018-02-23 18:11:34', null, '2018-02-23 18:11:34', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:11:34', null, null, null, '0', '98ee87614e4e417dbcf5d0db7c7a5327', '10', '0', '10', null, null, null, null, null, null, '0', null, null, 'normal', 'ready', '12f50d0807384a6186885f0423453289', '0', '0');
INSERT INTO `bm_playuser` VALUES ('b165eb8234664e09b7c4b3260d1beca5', null, 'Guest_0R85d4', '3db6e5f63486cb6c0426073457553cea', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:37:22', null, '2018-02-23 18:37:22', null, '2018-02-23 18:37:22', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:37:22', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b307b8199413479cb76409e586e438ce', null, 'Guest_0JtUox', 'c46228ec38e928d6ee26dded7633ef08', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-07 19:33:05', null, '2018-02-07 19:33:05', null, '2018-02-07 19:33:05', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-07 19:33:05', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b3b3c9d80ee54abc821406e8a5188001', null, 'Guest_1AdpBE', 'a90053d3947b630a62b909f35e878862', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:41:14', null, '2018-02-23 19:41:14', null, '2018-02-23 19:41:14', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:41:14', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b6009fa012f24ce1b10bdd0fa67a5916', null, 'Guest_0Yl5NQ', 'f303ed30d304d7b3ff8e5e3c79d1f9dc', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:42:58', null, '2018-02-23 19:42:58', null, '2018-02-23 19:42:58', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:42:58', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('b93884f5e53e4147954f5d1c46e9562f', null, 'Guest_0R5pB9', '37d471cc683ab3add349407055019cbe', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-23 10:52:26', null, '2018-03-23 10:52:26', null, '2018-03-23 10:52:26', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-23 10:52:26', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7', 'Safari', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('ba41a0c4269e4eb39fda5149f17ae4d6', null, 'Guest_1cpJ0F', 'ab95e1e93c5d82c5676252f6a00cf7a3', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-07 15:52:55', null, '2018-03-07 15:52:55', null, '2018-03-07 15:52:55', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-07 15:52:55', null, null, null, '0', null, '10', '49000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('bafcb046c2504a90844b914b2053b3a3', null, 'Guest_0Vhtwg', 'ace969c4a85862a1dbcb4d11074ba905', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:56:31', null, '2018-02-23 18:56:31', null, '2018-02-23 18:56:31', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:56:31', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('c36b22bec3d14389ae2b4e4eba43d4c2', null, 'Guest_05lExg', 'f8c84ebff88ed0c06cec28e91da6bde5', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-28 11:06:06', null, '2018-02-28 11:06:06', null, '2018-02-28 11:06:06', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-28 11:06:06', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('c5b96fa0b7a743ec92d1156e5e0156ab', null, 'Guest_0QQttd', '85fce96875c77f7489fe3b7dba2ea0ba', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:38:45', null, '2018-02-23 16:38:45', null, '2018-02-23 16:38:45', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:38:45', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('cbaef51113454784a4657d096d1440b1', null, 'Guest_1d0ApI', '332ca436754d2eaf338335056d450a90', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-23 21:32:55', null, '2018-03-23 21:32:55', null, '2018-03-23 21:32:55', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-23 21:32:55', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'UnKnown', '0', 'beimi-mobile/1.0 CFNetwork/893.14 Darwin/17.3.0', 'UnKnown', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('cd1281546184484296b4541a7bd17319', null, 'Guest_0ooF55', '0e6777d31a83650ce4d413545346f7eb', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:56:15', null, '2018-02-24 00:56:15', null, '2018-02-24 00:56:15', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:56:15', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('d8d78a14f15143de8bfc9062fed95c06', null, 'Guest_0YJ9w0', '56365d7d777df2da8ff65292e2f7a1fb', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:39:47', null, '2018-02-23 16:39:47', null, '2018-02-23 16:39:47', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:39:47', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('db0031f32e614038ab22700f5c743335', null, 'Guest_0xI8d4', '86691e7a77a5860faf116699fd303d5d', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:59:23', null, '2018-02-23 18:59:23', null, '2018-02-23 18:59:23', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:59:23', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('dcb54685ca42486da6be386a4e6cc33c', null, 'Guest_0t9g91', '953a9ede4b2299d2e2a8f2f6a830d464', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:44:04', null, '2018-02-23 18:44:04', null, '2018-02-23 18:44:04', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:44:04', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('dd6705b9545643d2b8e1da91ea5dd94f', null, 'Guest_1Ug05w', '759b0682981f077ab5deb185c2437c8a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 01:06:29', null, '2018-02-24 01:06:29', null, '2018-02-24 01:06:29', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 01:06:29', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63692', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('ded0a3801a174f64bbdf6714e9b02656', null, 'Guest_1thcIl', 'd34f1a7f1edd81d2199e796cd10dc03d', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:05:02', null, '2018-02-23 19:05:02', null, '2018-02-23 19:05:02', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:05:02', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('dfb10910a6f74bc395ebfe1b5895917c', null, 'Guest_19gAgJ', '73fa4cbc7d30bcc5db9c997ce036d0d3', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:46:33', null, '2018-02-23 18:46:33', null, '2018-02-23 18:46:33', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:46:33', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('e29238e9d56b4844a7535b5b0c5551fa', null, 'Guest_11Ud8l', '35bec4009b869892aca17e4b3003ca29', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:38:42', null, '2018-02-23 19:38:42', null, '2018-02-23 19:38:42', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:38:42', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('e802327fdab641ccb75f7a7c8e330700', null, 'Guest_1lgx8h', '55fbd23bb5af02a3570a4037665250bc', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 16:07:09', null, '2018-02-23 16:07:09', null, '2018-02-23 16:07:09', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 16:07:09', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/63709', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('e923ba180ef540db9efcf5e1693a1909', null, 'Guest_0x4QAo', 'af0086b2044b29cb59f0a72f1dc05c58', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:38:05', null, '2018-02-23 18:38:05', null, '2018-02-23 18:38:05', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:38:05', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('ecbd3ff1701f4d20a0979784d8887a52', null, 'Guest_1BR114', null, '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-22 09:38:14', null, '2018-03-22 09:38:14', null, '2018-03-22 09:38:14', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-22 09:38:14', null, null, null, '0', 'ca4ce63a529f4221a6fd7e2f753abf71', '10', '4000', '10', null, null, null, null, null, null, '0', null, null, 'leave', 'ready', '8def85a62f9e47eb8c4d3494e17ca2fb', '1', '1');
INSERT INTO `bm_playuser` VALUES ('ed881d972a1f43b5be187c19dd6b90d5', null, 'Guest_1sBBZA', '5fda438251b3eda1c0ea7f92b786034c', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:09:51', null, '2018-02-23 18:09:51', null, '2018-02-23 18:09:51', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:09:51', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'mac', '0', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2 like Mac OS X) AppleWebKit/602.3.12 (KHTML, like Gecko) Mobile/14C92 Safari/601.1 wechatdevtools/1.02.1712280 MicroMessenger/6.5.7 Language/zh_CN webview/20000 gameservice port/49203', 'Mozilla/5.0', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f1f390b0b74e467abc35d81a0976e873', null, 'Guest_0RNtk4', '42f913581902cdee05c8dce82258698f', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:46:02', null, '2018-02-23 18:46:02', null, '2018-02-23 18:46:02', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:46:02', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f2080b3168f24513babc10d284e29120', null, 'Guest_1R4d0F', '94ddf2e807917357e44af9270a6a6b58', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:38:35', null, '2018-02-23 18:38:35', null, '2018-02-23 18:38:35', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:38:35', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f40a28280ae54654b79e60be054ee4d7', null, 'Guest_0BVINl', '6ba773865d4ad9f69869ee19f774b199', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:39:06', null, '2018-02-23 19:39:06', null, '2018-02-23 19:39:06', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:39:06', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f4bcad56c720468b8fbf12c15328b969', null, 'Guest_18pl0I', '3f027119851261318ad85bb028dfb0b4', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-03-23 11:43:22', null, '2018-03-23 11:43:22', null, '2018-03-23 11:43:22', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-03-23 11:43:22', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'UnKnown', '0', 'beimi-mobile/1.0 CFNetwork/894 Darwin/17.4.0', 'UnKnown', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f623ace25a9e41d1829f96a7df68f3ce', null, 'Guest_0A0Axl', 'e03c3db6be4e95dd541d25ab503a0a27', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 15:57:57', null, '2018-02-23 15:57:57', null, '2018-02-23 15:57:57', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 15:57:57', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('f9f0bc5773a74eaea525ff369d5f9a0a', null, 'Guest_1NQlwA', 'fc029568843e8be6e38ab50b09a28b4b', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:48:04', null, '2018-02-23 18:48:04', null, '2018-02-23 18:48:04', null, '0', '0', '1', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:48:04', null, null, null, '0', 'add09da8c57e4593b90ec816de42ac69', '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('fbc0c83897f240a6b1abcc7b60c1bc26', null, 'Guest_1dkJ9M', '2f4c347d476cbf64f78dbbf7f7a1f09f', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 18:45:43', null, '2018-02-23 18:45:43', null, '2018-02-23 18:45:43', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 18:45:43', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('fefbaf94441a417dab0502efc37492d9', null, 'Guest_19clY1', 'abaee111cb79476525ecba0e094bb78a', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-24 00:24:18', null, '2018-02-24 00:24:18', null, '2018-02-24 00:24:18', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-24 00:24:18', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');
INSERT INTO `bm_playuser` VALUES ('ff1dd6a87f28479e9a5da42c839d0006', null, 'Guest_1Jdt5N', '0a98e55662c7f4123320bc0fe4b0a9bb', '5', null, null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2018-02-23 19:39:08', null, '2018-02-23 19:39:08', null, '2018-02-23 19:39:08', null, '0', '0', '0', '0', '0', null, '0', null, null, '0', '0', '0', '0', '0', '2018-02-23 19:39:08', null, null, null, '0', null, '10', '5000', '10', null, null, '未分配或者内网IP', '0', '0', 'windows', '0', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', 'Chrome', 'normal', null, null, '0', '0');

-- ----------------------------
-- Table structure for `bm_project`
-- ----------------------------
DROP TABLE IF EXISTS `bm_project`;
CREATE TABLE `bm_project` (
  `id` varchar(32) NOT NULL DEFAULT '',
  `name` varchar(255) DEFAULT NULL,
  `orgi` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `demo` varchar(255) DEFAULT NULL,
  `contexturl` longtext,
  `multilang` smallint(6) NOT NULL,
  `langtype` varchar(255) DEFAULT NULL,
  `packagename` varchar(255) DEFAULT NULL,
  `dbid` varchar(255) DEFAULT NULL,
  `creater` varchar(32) DEFAULT NULL,
  `createtime` datetime DEFAULT NULL,
  `updatetime` datetime DEFAULT NULL,
  `custom` tinyint(4) DEFAULT NULL,
  `accessafterlogin` tinyint(4) DEFAULT NULL,
  `params` varchar(255) DEFAULT NULL,
  `toptemplet` varchar(255) DEFAULT NULL,
  `lefttemplet` varchar(255) DEFAULT NULL,
  `description` text,
  `teamid` varchar(32) DEFAULT NULL,
  `color` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_project
-- ----------------------------
INSERT INTO `bm_project` VALUES ('40288881601f44eb01601fc9361b0002', '网贷催收系统', 'beimi', 'cuishou', null, null, '0', null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-04 12:29:28', '2017-12-04 12:29:28', '0', '0', null, null, null, '电话催收系统，名单清洗、分配，M1~12催收，自动名单分配电话催收系统，名单清洗、分配，M1~12催收，自动名单分配电话催收系统，名单清洗、分配，M1~12催收，自动名单分配', null, null);
INSERT INTO `bm_project` VALUES ('40288881601f44eb01601fd0c8be0003', '号码盾牌系统', 'beimi', 'dun', null, null, '0', null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-04 12:37:45', '2017-12-04 12:37:45', '0', '0', null, null, null, '网约车号码盾牌，对接第三方系统，包含对接接口和运营监控系统，网约车号码盾牌，对接第三方系统，包含对接接口和运营监控系统', null, null);
INSERT INTO `bm_project` VALUES ('40288881601f44eb01601fd19f730004', '客户资料管理系统', 'beimi', 'customer', null, null, '0', null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-04 12:38:40', '2017-12-04 12:38:40', '0', '0', null, null, null, '联系人信息统一管理，CRM系统基础功能，为各个系统提供客户信息视图，联系人信息统一管理，CRM系统基础功能，为各个系统提供客户信息视图', null, null);
INSERT INTO `bm_project` VALUES ('40288881601f44eb01601fd374770005', 'asdfa', 'beimi', 'sdfasdfa', null, null, '0', null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-04 12:40:40', '2017-12-04 12:40:40', '0', '0', null, null, null, 'sdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdf', null, null);

-- ----------------------------
-- Table structure for `bm_role`
-- ----------------------------
DROP TABLE IF EXISTS `bm_role`;
CREATE TABLE `bm_role` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_role
-- ----------------------------
INSERT INTO `bm_role` VALUES ('402888815e026a43015e02aba80f0000', 'ces', null, '2017-08-21 10:42:38', '297e8c7b455798280145579c73e501c1', '2017-08-21 10:42:42', 'ukewo', null);

-- ----------------------------
-- Table structure for `bm_role_auth`
-- ----------------------------
DROP TABLE IF EXISTS `bm_role_auth`;
CREATE TABLE `bm_role_auth` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `ROLEID` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `DICID` varchar(32) DEFAULT NULL COMMENT '权限ID',
  `DICVALUE` varchar(30) DEFAULT NULL COMMENT '权限代码',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_role_auth
-- ----------------------------

-- ----------------------------
-- Table structure for `bm_secret`
-- ----------------------------
DROP TABLE IF EXISTS `bm_secret`;
CREATE TABLE `bm_secret` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` varchar(32) DEFAULT NULL COMMENT '创建时间',
  `password` varchar(100) DEFAULT NULL COMMENT '二次密码',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属组件',
  `enable` tinyint(4) DEFAULT NULL COMMENT '是否启用',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_secret
-- ----------------------------
INSERT INTO `bm_secret` VALUES ('402888815ca1209a015ca122a8da0001', '297e8c7b455798280145579c73e501c1', '2017-06-13 19:07:02', '7b8218cd30ca98e7ac043df820c39d00', 'ukewo', null, '1');

-- ----------------------------
-- Table structure for `bm_sysdic`
-- ----------------------------
DROP TABLE IF EXISTS `bm_sysdic`;
CREATE TABLE `bm_sysdic` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(100) DEFAULT NULL COMMENT '字典名称',
  `TITLE` varchar(100) DEFAULT NULL COMMENT '标题',
  `CODE` varchar(100) DEFAULT NULL COMMENT '代码',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CTYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '描述',
  `MEMO` varchar(32) DEFAULT NULL COMMENT '备注',
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '图标',
  `ICONSKIN` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `CATETYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `HASCHILD` tinyint(4) DEFAULT NULL COMMENT '是否有下级',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `DEFAULTVALUE` tinyint(4) DEFAULT NULL COMMENT '默认值',
  `DISCODE` tinyint(4) DEFAULT NULL COMMENT '编码',
  `URL` varchar(255) DEFAULT NULL COMMENT '系统权限资源的URL',
  `MODULE` varchar(32) DEFAULT NULL COMMENT '权限资源所属模块',
  `MLEVEL` varchar(32) DEFAULT NULL COMMENT '菜单级别（一级/二级）',
  `RULES` varchar(100) DEFAULT NULL,
  `MENUTYPE` varchar(32) DEFAULT NULL COMMENT '菜单类型（顶部菜单/左侧菜单）',
  PRIMARY KEY (`ID`),
  UNIQUE KEY `SQL121227155532210` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_sysdic
-- ----------------------------
INSERT INTO `bm_sysdic` VALUES ('297e1e874f5ae37e014f5af969e30120', '性别', 'pub', 'com.dic.contacts.sex', 'ukewo', 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:19', '2015-08-23 22:32:19', '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f5ae37e014f5af9ceba0126', '男', 'pub', '01', 'ukewo', 'data', '297e1e874f5ae37e014f5af969e30120', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:44', '2016-10-13 16:37:40', '0', '1', '297e1e874f5ae37e014f5af969e30120', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f5ae37e014f5af9cecf0127', '女', 'pub', '02', 'ukewo', 'data', '297e1e874f5ae37e014f5af969e30120', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:45', '2015-08-27 17:20:25', '0', '2', '297e1e874f5ae37e014f5af969e30120', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832090e200b8', '国家、省市区县', 'pub', 'com.dic.address.area', 'ukewo', 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:39:53', '2015-08-31 17:39:53', '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832154c800c3', '北京市', 'pub', '110000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '1', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832154d900c4', '天津市', 'pub', '120000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '2', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832154e800c5', '河北省', 'pub', '130000', 'ukewo', 'data', '297e1e874f83129d014f832090e200b8', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '3', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832154fa00c6', '山西省', 'pub', '140000', 'ukewo', 'data', '297e1e874f83129d014f832090e200b8', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '4', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321550a00c7', '内蒙古自治区', 'pub', '150000', 'ukewo', 'data', '297e1e874f83129d014f832090e200b8', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '5', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321551a00c8', '辽宁省', 'pub', '210000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '6', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321552c00c9', '吉林省', 'pub', '220000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '7', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321553b00ca', '黑龙江省', 'pub', '230000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '8', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321554a00cb', '上海市', 'pub', '310000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '9', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321555900cc', '江苏省', 'pub', '320000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', '0', '10', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321556b00cd', '浙江省', 'pub', '330000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '11', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321557d00ce', '安徽省', 'pub', '340000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '12', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321558a00cf', '福建省', 'pub', '350000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '13', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321559900d0', '江西省', 'pub', '360000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '14', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155a500d1', '山东省', 'pub', '370000', 'ukewo', 'data', '297e1e874f83129d014f832090e200b8', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '15', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155b200d2', '河南省', 'pub', '410000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '16', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155bf00d3', '湖北省', 'pub', '420000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '17', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155cb00d4', '湖南省', 'pub', '430000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '18', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155d800d5', '广东省', 'pub', '440000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '19', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155e400d6', '广西壮族自治区', 'pub', '450000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '20', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155f300d7', '海南省', 'pub', '460000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '21', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832155ff00d8', '重庆市', 'pub', '500000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '22', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321560b00d9', '四川省', 'pub', '510000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '23', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321561800da', '贵州省', 'pub', '520000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '24', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321562400db', '云南省', 'pub', '530000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '25', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321563300dc', '西藏自治区', 'pub', '540000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '26', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321564100dd', '陕西省', 'pub', '610000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '27', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321564f00de', '甘肃省', 'pub', '620000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '28', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321565d00df', '青海省', 'pub', '630000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '29', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321566d00e0', '宁夏回族自治区', 'pub', '640000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '30', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321567900e1', '新疆维吾尔自治区', 'pub', '650000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '31', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321568900e2', '台湾省', 'pub', '710000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '32', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8321569700e3', '香港特别行政区', 'pub', '810000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '33', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f832156a900e4', '澳门特别行政区', 'pub', '820000', 'ukewo', null, '297e1e874f83129d014f832090e200b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', '0', '34', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3430242', '市辖区', 'pub', '110100', 'ukewo', null, '297e1e874f83129d014f832154c800c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '35', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3550243', '县', 'pub', '110200', 'ukewo', null, '297e1e874f83129d014f832154c800c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '36', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3860244', '市辖区', 'pub', '120100', 'ukewo', null, '297e1e874f83129d014f832154d900c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '37', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3960245', '县', 'pub', '120200', 'ukewo', null, '297e1e874f83129d014f832154d900c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '38', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3c00246', '石家庄市', 'pub', '130100', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '39', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3cc0247', '唐山市', 'pub', '130200', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '40', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3d80248', '秦皇岛市', 'pub', '130300', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '41', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3e50249', '邯郸市', 'pub', '130400', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '42', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3f1024a', '邢台市', 'pub', '130500', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '43', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e3fd024b', '保定市', 'pub', '130600', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '44', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e409024c', '张家口市', 'pub', '130700', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '45', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e418024d', '承德市', 'pub', '130800', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '46', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e424024e', '沧州市', 'pub', '130900', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '47', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e430024f', '廊坊市', 'pub', '131000', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '48', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e43e0250', '衡水市', 'pub', '131100', 'ukewo', null, '297e1e874f83129d014f832154e800c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', '0', '49', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6310251', '太原市', 'pub', '140100', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '50', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6420252', '大同市', 'pub', '140200', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '51', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e64e0253', '阳泉市', 'pub', '140300', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '52', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e65a0254', '长治市', 'pub', '140400', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '53', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6650255', '晋城市', 'pub', '140500', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '54', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6730256', '朔州市', 'pub', '140600', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '55', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e67f0257', '晋中市', 'pub', '140700', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '56', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e68e0258', '运城市', 'pub', '140800', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '57', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e69e0259', '忻州市', 'pub', '140900', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '58', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6ae025a', '临汾市', 'pub', '141000', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '59', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6bb025b', '吕梁市', 'pub', '141100', 'ukewo', null, '297e1e874f83129d014f832154fa00c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '60', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6e0025c', '呼和浩特市', 'pub', '150100', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '61', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e6f5025d', '包头市', 'pub', '150200', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '62', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e702025e', '乌海市', 'pub', '150300', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '63', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e70e025f', '赤峰市', 'pub', '150400', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '64', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e71a0260', '通辽市', 'pub', '150500', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '65', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7270261', '鄂尔多斯市', 'pub', '150600', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '66', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7360262', '呼伦贝尔市', 'pub', '150700', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '67', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7430263', '巴彦淖尔市', 'pub', '150800', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '68', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e74e0264', '乌兰察布市', 'pub', '150900', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '69', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e75b0265', '兴安盟', 'pub', '152200', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '70', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7680266', '锡林郭勒盟', 'pub', '152500', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '71', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7740267', '阿拉善盟', 'pub', '152900', 'ukewo', null, '297e1e874f83129d014f8321550a00c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '72', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7960268', '沈阳市', 'pub', '210100', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '73', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7a40269', '大连市', 'pub', '210200', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '74', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7b2026a', '鞍山市', 'pub', '210300', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '75', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7c2026b', '抚顺市', 'pub', '210400', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '76', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7ce026c', '本溪市', 'pub', '210500', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '77', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7da026d', '丹东市', 'pub', '210600', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '78', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7e6026e', '锦州市', 'pub', '210700', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '79', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e7f3026f', '营口市', 'pub', '210800', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '80', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8010270', '阜新市', 'pub', '210900', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '81', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e80f0272', '辽阳市', 'pub', '211000', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '82', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e81e0273', '盘锦市', 'pub', '211100', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '83', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e82c0274', '铁岭市', 'pub', '211200', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '84', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8410275', '朝阳市', 'pub', '211300', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '85', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e84e0276', '葫芦岛市', 'pub', '211400', 'ukewo', null, '297e1e874f83129d014f8321551a00c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '86', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8730277', '长春市', 'pub', '220100', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '87', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8800278', '吉林市', 'pub', '220200', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '88', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e88f0279', '四平市', 'pub', '220300', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '89', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e89c027a', '辽源市', 'pub', '220400', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '90', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8a8027b', '通化市', 'pub', '220500', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '91', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8b9027c', '白山市', 'pub', '220600', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '92', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8c6027d', '松原市', 'pub', '220700', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '93', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8d4027e', '白城市', 'pub', '220800', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '94', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e8e1027f', '延边朝鲜族自治州', 'pub', '222400', 'ukewo', null, '297e1e874f83129d014f8321552c00c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '95', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e91d0280', '哈尔滨市', 'pub', '230100', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', '0', '96', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9290281', '齐齐哈尔市', 'pub', '230200', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '97', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9390282', '鸡西市', 'pub', '230300', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '98', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9470283', '鹤岗市', 'pub', '230400', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '99', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9570284', '双鸭山市', 'pub', '230500', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '100', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9630285', '大庆市', 'pub', '230600', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '101', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9710286', '伊春市', 'pub', '230700', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '102', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e97d0287', '佳木斯市', 'pub', '230800', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '103', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e98e0288', '七台河市', 'pub', '230900', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '104', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e99a0289', '牡丹江市', 'pub', '231000', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '105', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9a8028a', '黑河市', 'pub', '231100', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '106', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9b5028b', '绥化市', 'pub', '231200', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '107', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9c4028c', '大兴安岭地区', 'pub', '232700', 'ukewo', null, '297e1e874f83129d014f8321553b00ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '108', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9e5028d', '市辖区', 'pub', '310100', 'ukewo', null, '297e1e874f83129d014f8321554a00cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '109', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334e9f3028e', '县', 'pub', '310200', 'ukewo', null, '297e1e874f83129d014f8321554a00cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '110', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea23028f', '南京市', 'pub', '320100', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '111', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea320290', '无锡市', 'pub', '320200', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '112', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea430291', '徐州市', 'pub', '320300', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '113', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea510292', '常州市', 'pub', '320400', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '114', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea5e0293', '苏州市', 'pub', '320500', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '115', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea6d0294', '南通市', 'pub', '320600', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '116', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea790295', '连云港市', 'pub', '320700', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '117', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea850296', '淮安市', 'pub', '320800', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '118', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ea940297', '盐城市', 'pub', '320900', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '119', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eab00298', '扬州市', 'pub', '321000', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '120', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eaca0299', '镇江市', 'pub', '321100', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '121', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eaed029a', '泰州市', 'pub', '321200', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '122', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb01029b', '宿迁市', 'pub', '321300', 'ukewo', null, '297e1e874f83129d014f8321555900cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '123', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb38029c', '杭州市', 'pub', '330100', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '124', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb45029d', '宁波市', 'pub', '330200', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '125', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb53029e', '温州市', 'pub', '330300', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '126', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb60029f', '嘉兴市', 'pub', '330400', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '127', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb6e02a0', '湖州市', 'pub', '330500', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '128', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb7d02a1', '绍兴市', 'pub', '330600', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '129', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb8902a2', '金华市', 'pub', '330700', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '130', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eb9902a3', '衢州市', 'pub', '330800', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '131', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eba502a4', '舟山市', 'pub', '330900', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '132', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ebb202a5', '台州市', 'pub', '331000', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '133', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ebbe02a6', '丽水市', 'pub', '331100', 'ukewo', null, '297e1e874f83129d014f8321556b00cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '134', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ebe802a7', '合肥市', 'pub', '340100', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '135', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ebf602a8', '芜湖市', 'pub', '340200', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', '0', '136', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed2f02a9', '蚌埠市', 'pub', '340300', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '137', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed4302aa', '淮南市', 'pub', '340400', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '138', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed5202ab', '马鞍山市', 'pub', '340500', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '139', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed6202ac', '淮北市', 'pub', '340600', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '140', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed6e02ad', '铜陵市', 'pub', '340700', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '141', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed7b02ae', '安庆市', 'pub', '340800', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '142', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed8802af', '黄山市', 'pub', '341000', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '143', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ed9602b0', '滁州市', 'pub', '341100', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '144', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eda302b1', '阜阳市', 'pub', '341200', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '145', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334edb402b2', '宿州市', 'pub', '341300', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '146', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334edc002b3', '巢湖市', 'pub', '341400', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '147', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334edcf02b4', '六安市', 'pub', '341500', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '148', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334eddb02b5', '亳州市', 'pub', '341600', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '149', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334edee02b6', '池州市', 'pub', '341700', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '150', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334edfb02b7', '宣城市', 'pub', '341800', 'ukewo', null, '297e1e874f83129d014f8321557d00ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '151', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef4d02b8', '福州市', 'pub', '350100', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '152', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef5e02b9', '厦门市', 'pub', '350200', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '153', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef6902ba', '莆田市', 'pub', '350300', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '154', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef7602bb', '三明市', 'pub', '350400', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '155', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef8202bc', '泉州市', 'pub', '350500', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '156', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef9002bd', '漳州市', 'pub', '350600', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '157', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ef9d02be', '南平市', 'pub', '350700', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '158', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334efa902bf', '龙岩市', 'pub', '350800', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '159', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334efb702c0', '宁德市', 'pub', '350900', 'ukewo', null, '297e1e874f83129d014f8321558a00cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '160', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334efde02c1', '南昌市', 'pub', '360100', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', '0', '161', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f11902c2', '景德镇市', 'pub', '360200', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '162', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f12702c3', '萍乡市', 'pub', '360300', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '163', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f13602c4', '九江市', 'pub', '360400', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '164', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f14c02c5', '新余市', 'pub', '360500', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '165', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f15b02c6', '鹰潭市', 'pub', '360600', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '166', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f16c02c7', '赣州市', 'pub', '360700', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '167', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f18502c8', '吉安市', 'pub', '360800', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '168', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f19402c9', '宜春市', 'pub', '360900', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '169', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f1a302ca', '抚州市', 'pub', '361000', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '170', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f1b202cb', '上饶市', 'pub', '361100', 'ukewo', null, '297e1e874f83129d014f8321559900d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '171', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f1da02cc', '济南市', 'pub', '370100', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '172', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f1e902cd', '青岛市', 'pub', '370200', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '173', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f20c02ce', '淄博市', 'pub', '370300', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '174', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f21e02cf', '枣庄市', 'pub', '370400', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '175', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f22d02d0', '东营市', 'pub', '370500', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '176', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f23d02d1', '烟台市', 'pub', '370600', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '177', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f37702d2', '潍坊市', 'pub', '370700', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '178', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f38a02d3', '济宁市', 'pub', '370800', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '179', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f39602d4', '泰安市', 'pub', '370900', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '180', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3a202d5', '威海市', 'pub', '371000', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '181', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3b002d6', '日照市', 'pub', '371100', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '182', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3c302d7', '莱芜市', 'pub', '371200', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '183', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3d202d8', '临沂市', 'pub', '371300', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '184', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3dd02d9', '德州市', 'pub', '371400', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '185', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3ec02da', '聊城市', 'pub', '371500', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '186', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f3fb02db', '滨州市', 'pub', '371600', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '187', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f40802dc', '荷泽市', 'pub', '371700', 'ukewo', null, '297e1e874f83129d014f832155a500d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '188', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f43002dd', '郑州市', 'pub', '410100', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', '0', '189', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f56b02de', '开封市', 'pub', '410200', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '190', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f57a02df', '洛阳市', 'pub', '410300', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '191', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f59902e0', '平顶山市', 'pub', '410400', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '192', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5a902e1', '安阳市', 'pub', '410500', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '193', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5b602e2', '鹤壁市', 'pub', '410600', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '194', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5c602e3', '新乡市', 'pub', '410700', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '195', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5d202e4', '焦作市', 'pub', '410800', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '196', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5e202e5', '濮阳市', 'pub', '410900', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '197', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5ef02e6', '许昌市', 'pub', '411000', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '198', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f5fb02e7', '漯河市', 'pub', '411100', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '199', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f60902e8', '三门峡市', 'pub', '411200', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '200', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f61802e9', '南阳市', 'pub', '411300', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '201', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f62802ea', '商丘市', 'pub', '411400', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '202', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f63402eb', '信阳市', 'pub', '411500', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '203', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f64202ec', '周口市', 'pub', '411600', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '204', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f65102ed', '驻马店市', 'pub', '411700', 'ukewo', null, '297e1e874f83129d014f832155b200d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '205', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f7a802ee', '武汉市', 'pub', '420100', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '206', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f7c902ef', '黄石市', 'pub', '420200', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '207', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f7ee02f0', '十堰市', 'pub', '420300', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '208', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f7fd02f1', '宜昌市', 'pub', '420500', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '209', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f80b02f2', '襄樊市', 'pub', '420600', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '210', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f81a02f3', '鄂州市', 'pub', '420700', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '211', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f82702f4', '荆门市', 'pub', '420800', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '212', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f83502f5', '孝感市', 'pub', '420900', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '213', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f84302f6', '荆州市', 'pub', '421000', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '214', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f85b02f7', '黄冈市', 'pub', '421100', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '215', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f87102f8', '咸宁市', 'pub', '421200', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '216', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f88002f9', '随州市', 'pub', '421300', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '217', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f89202fa', '恩施土家族苗族自治州', 'pub', '422800', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '218', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f89f02fb', '省直辖行政单位', 'pub', '429000', 'ukewo', null, '297e1e874f83129d014f832155bf00d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', '0', '219', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f8d802fc', '长沙市', 'pub', '430100', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '220', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334f8f902fd', '株洲市', 'pub', '430200', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '221', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fa3e02fe', '湘潭市', 'pub', '430300', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '222', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fa5b02ff', '衡阳市', 'pub', '430400', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '223', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fa6c0300', '邵阳市', 'pub', '430500', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '224', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fa840301', '岳阳市', 'pub', '430600', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '225', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fa950302', '常德市', 'pub', '430700', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '226', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fac00303', '张家界市', 'pub', '430800', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '227', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fafb0304', '益阳市', 'pub', '430900', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '228', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fb1b0305', '郴州市', 'pub', '431000', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '229', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fb3d0306', '永州市', 'pub', '431100', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '230', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fb5d0307', '怀化市', 'pub', '431200', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '231', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fb800308', '娄底市', 'pub', '431300', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '232', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fb9f030a', '湘西土家族苗族自治州', 'pub', '433100', 'ukewo', null, '297e1e874f83129d014f832155cb00d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '233', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fbf4030b', '广州市', 'pub', '440100', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '234', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fc0d030c', '韶关市', 'pub', '440200', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '235', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fc35030d', '深圳市', 'pub', '440300', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '236', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fc4d030e', '珠海市', 'pub', '440400', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '237', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fc64030f', '汕头市', 'pub', '440500', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '238', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fc830310', '佛山市', 'pub', '440600', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', '0', '239', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fca40311', '江门市', 'pub', '440700', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '240', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fcc10312', '湛江市', 'pub', '440800', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '241', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fcdb0313', '茂名市', 'pub', '440900', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '242', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fceb0314', '肇庆市', 'pub', '441200', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '243', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fd140315', '惠州市', 'pub', '441300', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '244', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fd2f0316', '梅州市', 'pub', '441400', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '245', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fd4d0317', '汕尾市', 'pub', '441500', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '246', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fd650318', '河源市', 'pub', '441600', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '247', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fd7b0319', '阳江市', 'pub', '441700', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '248', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fda2031a', '清远市', 'pub', '441800', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '249', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fdbd031b', '东莞市', 'pub', '441900', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '250', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fdd3031c', '中山市', 'pub', '442000', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '251', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fde1031d', '潮州市', 'pub', '445100', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '252', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fdf3031e', '揭阳市', 'pub', '445200', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '253', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fe01031f', '云浮市', 'pub', '445300', 'ukewo', null, '297e1e874f83129d014f832155d800d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '254', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff530320', '南宁市', 'pub', '450100', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '255', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff630321', '柳州市', 'pub', '450200', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '256', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff6f0322', '桂林市', 'pub', '450300', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '257', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff7c0323', '梧州市', 'pub', '450400', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '258', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff890324', '北海市', 'pub', '450500', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '259', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ff970325', '防城港市', 'pub', '450600', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '260', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffa50326', '钦州市', 'pub', '450700', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '261', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffb30327', '贵港市', 'pub', '450800', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '262', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffbf0328', '玉林市', 'pub', '450900', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '263', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffce0329', '百色市', 'pub', '451000', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '264', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffda032a', '贺州市', 'pub', '451100', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '265', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334ffe8032b', '河池市', 'pub', '451200', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '266', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8334fff6032c', '来宾市', 'pub', '451300', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', '0', '267', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350136032d', '崇左市', 'pub', '451400', 'ukewo', null, '297e1e874f83129d014f832155e400d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '268', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335015b032e', '海口市', 'pub', '460100', 'ukewo', null, '297e1e874f83129d014f832155f300d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '269', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350167032f', '三亚市', 'pub', '460200', 'ukewo', null, '297e1e874f83129d014f832155f300d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '270', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833501740330', '省直辖县级行政单位', 'pub', '469000', 'ukewo', null, '297e1e874f83129d014f832155f300d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '271', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833501a30331', '市辖区', 'pub', '500100', 'ukewo', null, '297e1e874f83129d014f832155ff00d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '272', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833501b20332', '县', 'pub', '500200', 'ukewo', null, '297e1e874f83129d014f832155ff00d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '273', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833501c00333', '市', 'pub', '500300', 'ukewo', null, '297e1e874f83129d014f832155ff00d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '274', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503160334', '成都市', 'pub', '510100', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '275', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335032b0335', '自贡市', 'pub', '510300', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '276', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335033a0336', '攀枝花市', 'pub', '510400', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '277', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503490337', '泸州市', 'pub', '510500', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '278', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503570338', '德阳市', 'pub', '510600', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '279', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503650339', '绵阳市', 'pub', '510700', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '280', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350373033a', '广元市', 'pub', '510800', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '281', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335037f033b', '遂宁市', 'pub', '510900', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '282', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350393033c', '内江市', 'pub', '511000', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '283', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503b0033d', '乐山市', 'pub', '511100', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '284', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503bf033e', '南充市', 'pub', '511300', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '285', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503cf033f', '眉山市', 'pub', '511400', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '286', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503df0340', '宜宾市', 'pub', '511500', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '287', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833503f10341', '广安市', 'pub', '511600', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '288', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833504010342', '达州市', 'pub', '511700', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '289', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833504100343', '雅安市', 'pub', '511800', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '290', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833504230344', '巴中市', 'pub', '511900', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', '0', '291', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505600345', '资阳市', 'pub', '512000', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '292', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505730346', '阿坝藏族羌族自治州', 'pub', '513200', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '293', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505830347', '甘孜藏族自治州', 'pub', '513300', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '294', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505940348', '凉山彝族自治州', 'pub', '513400', 'ukewo', null, '297e1e874f83129d014f8321560b00d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '295', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505ca0349', '贵阳市', 'pub', '520100', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '296', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505d9034a', '六盘水市', 'pub', '520200', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '297', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505ea034b', '遵义市', 'pub', '520300', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '298', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833505fb034c', '安顺市', 'pub', '520400', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '299', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335060c034d', '铜仁地区', 'pub', '522200', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '300', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335061f034e', '黔西南布依族苗族自治州', 'pub', '522300', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '301', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335062e034f', '毕节地区', 'pub', '522400', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '302', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833506400350', '黔东南苗族侗族自治州', 'pub', '522600', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '303', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833506500351', '黔南布依族苗族自治州', 'pub', '522700', 'ukewo', null, '297e1e874f83129d014f8321561800da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '304', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833506810352', '昆明市', 'pub', '530100', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '305', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833507bf0353', '曲靖市', 'pub', '530300', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '306', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833507cd0354', '玉溪市', 'pub', '530400', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '307', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833507e00355', '保山市', 'pub', '530500', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '308', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833507f60356', '昭通市', 'pub', '530600', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '309', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833508050357', '丽江市', 'pub', '530700', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '310', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833508180358', '思茅市', 'pub', '530800', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '311', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833508270359', '临沧市', 'pub', '530900', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '312', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335083b035a', '楚雄彝族自治州', 'pub', '532300', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '313', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335084a035b', '红河哈尼族彝族自治州', 'pub', '532500', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', '0', '314', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335085b035c', '文山壮族苗族自治州', 'pub', '532600', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '315', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335086c035d', '西双版纳傣族自治州', 'pub', '532800', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '316', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335087a035e', '大理白族自治州', 'pub', '532900', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '317', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335088a035f', '德宏傣族景颇族自治州', 'pub', '533100', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '318', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335089b0360', '怒江傈僳族自治州', 'pub', '533300', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '319', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833508b20361', '迪庆藏族自治州', 'pub', '533400', 'ukewo', null, '297e1e874f83129d014f8321562400db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '320', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833508e00362', '拉萨市', 'pub', '540100', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '321', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a1c0363', '昌都地区', 'pub', '542100', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '322', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a2b0364', '山南地区', 'pub', '542200', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '323', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a3a0365', '日喀则地区', 'pub', '542300', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '324', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a480366', '那曲地区', 'pub', '542400', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '325', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a560367', '阿里地区', 'pub', '542500', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '326', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a650368', '林芝地区', 'pub', '542600', 'ukewo', null, '297e1e874f83129d014f8321563300dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '327', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350a8e0369', '西安市', 'pub', '610100', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '328', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350aa1036a', '铜川市', 'pub', '610200', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '329', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ab6036b', '宝鸡市', 'pub', '610300', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '330', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ad3036c', '咸阳市', 'pub', '610400', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '331', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ae2036d', '渭南市', 'pub', '610500', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '332', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350af0036e', '延安市', 'pub', '610600', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '333', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350afe036f', '汉中市', 'pub', '610700', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '334', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350b0b0370', '榆林市', 'pub', '610800', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '335', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350b170371', '安康市', 'pub', '610900', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', '0', '336', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350c540372', '商洛市', 'pub', '611000', 'ukewo', null, '297e1e874f83129d014f8321564100dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '337', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350c7b0373', '兰州市', 'pub', '620100', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '338', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350c890374', '嘉峪关市', 'pub', '620200', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '339', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350c960375', '金昌市', 'pub', '620300', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '340', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ca40376', '白银市', 'pub', '620400', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '341', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cb10377', '天水市', 'pub', '620500', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '342', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cc20378', '武威市', 'pub', '620600', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '343', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cd10379', '张掖市', 'pub', '620700', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '344', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cde037a', '平凉市', 'pub', '620800', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '345', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cec037b', '酒泉市', 'pub', '620900', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '346', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350cf9037c', '庆阳市', 'pub', '621000', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '347', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350d09037d', '定西市', 'pub', '621100', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '348', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350d19037e', '陇南市', 'pub', '621200', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '349', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350e53037f', '临夏回族自治州', 'pub', '622900', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '350', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350e600380', '甘南藏族自治州', 'pub', '623000', 'ukewo', null, '297e1e874f83129d014f8321564f00de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '351', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350e890381', '西宁市', 'pub', '630100', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '352', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350e990382', '海东地区', 'pub', '632100', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '353', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ea80383', '海北藏族自治州', 'pub', '632200', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '354', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350eb90384', '黄南藏族自治州', 'pub', '632300', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '355', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ec60385', '海南藏族自治州', 'pub', '632500', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '356', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ed80386', '果洛藏族自治州', 'pub', '632600', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '357', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350ee90387', '玉树藏族自治州', 'pub', '632700', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '358', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350efd0388', '海西蒙古族藏族自治州', 'pub', '632800', 'ukewo', null, '297e1e874f83129d014f8321565d00df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '359', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83350f24038a', '银川市', 'pub', '640100', 'ukewo', null, '297e1e874f83129d014f8321566d00e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', '0', '360', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335105f038b', '石嘴山市', 'pub', '640200', 'ukewo', null, '297e1e874f83129d014f8321566d00e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '361', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335106f038c', '吴忠市', 'pub', '640300', 'ukewo', null, '297e1e874f83129d014f8321566d00e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '362', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83351081038d', '固原市', 'pub', '640400', 'ukewo', null, '297e1e874f83129d014f8321566d00e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '363', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83351091038e', '中卫市', 'pub', '640500', 'ukewo', null, '297e1e874f83129d014f8321566d00e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '364', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833510c5038f', '乌鲁木齐市', 'pub', '650100', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '365', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833510d30390', '克拉玛依市', 'pub', '650200', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '366', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833510e90391', '吐鲁番地区', 'pub', '652100', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '367', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833510fa0392', '哈密地区', 'pub', '652200', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '368', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833511050393', '昌吉回族自治州', 'pub', '652300', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '369', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335111a0394', '博尔塔拉蒙古自治州', 'pub', '652700', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '370', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833511280395', '巴音郭楞蒙古自治州', 'pub', '652800', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '371', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833512b80396', '阿克苏地区', 'pub', '652900', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '372', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833512c90397', '克孜勒苏柯尔克孜自治州', 'pub', '653000', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '373', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833512e50398', '喀什地区', 'pub', '653100', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '374', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833512f60399', '和田地区', 'pub', '653200', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '375', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335130a039a', '伊犁哈萨克自治州', 'pub', '654000', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '376', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8335131d039b', '塔城地区', 'pub', '654200', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '377', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83351330039c', '阿勒泰地区', 'pub', '654300', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '378', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83351347039d', '省直辖行政单位', 'pub', '659000', 'ukewo', null, '297e1e874f83129d014f8321567900e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', '0', '379', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337713e03bd', '东城区', 'pub', '110101', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', '0', '35', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337715003be', '西城区', 'pub', '110102', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', '0', '36', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337716903bf', '崇文区', 'pub', '110103', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', '0', '37', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337718003c0', '宣武区', 'pub', '110104', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', '0', '38', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337719403c1', '朝阳区', 'pub', '110105', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '39', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833771a603c2', '丰台区', 'pub', '110106', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '40', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833771b803c3', '石景山区', 'pub', '110107', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '41', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833771cb03c4', '海淀区', 'pub', '110108', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '42', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833771df03c5', '门头沟区', 'pub', '110109', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '43', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833771f403c6', '房山区', 'pub', '110111', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '44', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337720303c7', '通州区', 'pub', '110112', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '45', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337721c03c8', '顺义区', 'pub', '110113', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '46', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337722b03c9', '昌平区', 'pub', '110114', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '47', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337724203ca', '大兴区', 'pub', '110115', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '48', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337725203cb', '怀柔区', 'pub', '110116', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '49', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337726203cc', '平谷区', 'pub', '110117', 'ukewo', null, '297e1e874f83129d014f8334e3430242', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '50', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337729303cd', '密云县', 'pub', '110228', 'ukewo', null, '297e1e874f83129d014f8334e3550243', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '51', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833772a503ce', '延庆县', 'pub', '110229', 'ukewo', null, '297e1e874f83129d014f8334e3550243', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '52', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833772e803cf', '和平区', 'pub', '120101', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '53', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337731503d0', '河东区', 'pub', '120102', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '54', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337732a03d1', '河西区', 'pub', '120103', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '55', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337733b03d2', '南开区', 'pub', '120104', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '56', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337735003d3', '河北区', 'pub', '120105', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '57', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337736103d4', '红桥区', 'pub', '120106', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '58', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337737103d5', '塘沽区', 'pub', '120107', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '59', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337738303d6', '汉沽区', 'pub', '120108', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '60', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337739203d7', '大港区', 'pub', '120109', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '61', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773a503d8', '东丽区', 'pub', '120110', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '62', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773b703d9', '西青区', 'pub', '120111', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '63', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773c503da', '津南区', 'pub', '120112', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '64', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773d603db', '北辰区', 'pub', '120113', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '65', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773e703dc', '武清区', 'pub', '120114', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '66', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833773f903dd', '宝坻区', 'pub', '120115', 'ukewo', null, '297e1e874f83129d014f8334e3860244', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '67', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337742703de', '宁河县', 'pub', '120221', 'ukewo', null, '297e1e874f83129d014f8334e3960245', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '68', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337743e03df', '静海县', 'pub', '120223', 'ukewo', null, '297e1e874f83129d014f8334e3960245', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '69', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337745203e0', '蓟　县', 'pub', '120225', 'ukewo', null, '297e1e874f83129d014f8334e3960245', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '70', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337748003e1', '市辖区', 'pub', '130101', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '71', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337748e03e2', '长安区', 'pub', '130102', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '72', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337749e03e3', '桥东区', 'pub', '130103', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '73', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774ad03e4', '桥西区', 'pub', '130104', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '74', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774bb03e5', '新华区', 'pub', '130105', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '75', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774c903e6', '井陉矿区', 'pub', '130107', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '76', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774da03e7', '裕华区', 'pub', '130108', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '77', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774e903e8', '井陉县', 'pub', '130121', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '78', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833774fb03e9', '正定县', 'pub', '130123', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '79', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337750b03ea', '栾城县', 'pub', '130124', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '80', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337751e03eb', '行唐县', 'pub', '130125', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '81', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337753403ec', '灵寿县', 'pub', '130126', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '82', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337754303ed', '高邑县', 'pub', '130127', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '83', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337755403ee', '深泽县', 'pub', '130128', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '84', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337756603ef', '赞皇县', 'pub', '130129', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', '0', '85', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337757f03f0', '无极县', 'pub', '130130', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '86', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337759303f1', '平山县', 'pub', '130131', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '87', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775a203f2', '元氏县', 'pub', '130132', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '88', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775b803f3', '赵　县', 'pub', '130133', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '89', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775ca03f4', '辛集市', 'pub', '130181', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '90', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775d903f5', '藁城市', 'pub', '130182', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '91', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775e603f6', '晋州市', 'pub', '130183', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '92', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833775f503f7', '新乐市', 'pub', '130184', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '93', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337760203f8', '鹿泉市', 'pub', '130185', 'ukewo', null, '297e1e874f83129d014f8334e3c00246', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '94', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337762f03f9', '市辖区', 'pub', '130201', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '95', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337763e03fa', '路南区', 'pub', '130202', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '96', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337764d03fb', '路北区', 'pub', '130203', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '97', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337765d03fc', '古冶区', 'pub', '130204', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '98', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337766e03fd', '开平区', 'pub', '130205', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '99', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337768003fe', '丰南区', 'pub', '130207', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '100', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337768f03ff', '丰润区', 'pub', '130208', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '101', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337769f0400', '滦　县', 'pub', '130223', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '102', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833776af0401', '滦南县', 'pub', '130224', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '103', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833776c10402', '乐亭县', 'pub', '130225', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '104', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833776d00403', '迁西县', 'pub', '130227', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '105', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833776e00404', '玉田县', 'pub', '130229', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '106', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833776f20405', '唐海县', 'pub', '130230', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '107', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777020406', '遵化市', 'pub', '130281', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '108', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777140407', '迁安市', 'pub', '130283', 'ukewo', null, '297e1e874f83129d014f8334e3cc0247', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '109', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777430408', '市辖区', 'pub', '130301', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '110', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777530409', '海港区', 'pub', '130302', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '111', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377765040a', '山海关区', 'pub', '130303', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '112', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377773040b', '北戴河区', 'pub', '130304', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '113', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377783040c', '青龙满族自治县', 'pub', '130321', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '114', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377793040d', '昌黎县', 'pub', '130322', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '115', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777a4040e', '抚宁县', 'pub', '130323', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '116', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777b4040f', '卢龙县', 'pub', '130324', 'ukewo', null, '297e1e874f83129d014f8334e3d80248', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '117', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777de0410', '市辖区', 'pub', '130401', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '118', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777eb0411', '邯山区', 'pub', '130402', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '119', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833777f90412', '丛台区', 'pub', '130403', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '120', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337780a0413', '复兴区', 'pub', '130404', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '121', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337781b0414', '峰峰矿区', 'pub', '130406', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '122', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778290415', '邯郸县', 'pub', '130421', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '123', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778380416', '临漳县', 'pub', '130423', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '124', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778470417', '成安县', 'pub', '130424', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '125', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778570418', '大名县', 'pub', '130425', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '126', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778650419', '涉　县', 'pub', '130426', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '127', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377873041a', '磁　县', 'pub', '130427', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '128', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377884041b', '肥乡县', 'pub', '130428', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '129', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377895041c', '永年县', 'pub', '130429', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '130', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778a5041d', '邱　县', 'pub', '130430', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '131', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778b4041e', '鸡泽县', 'pub', '130431', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '132', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778c3041f', '广平县', 'pub', '130432', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '133', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778d10420', '馆陶县', 'pub', '130433', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '134', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778e10421', '魏　县', 'pub', '130434', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '135', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833778f20422', '曲周县', 'pub', '130435', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '136', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833779010423', '武安市', 'pub', '130481', 'ukewo', null, '297e1e874f83129d014f8334e3e50249', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '137', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337792c0424', '市辖区', 'pub', '130501', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', '0', '138', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377a700425', '桥东区', 'pub', '130502', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '139', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377a820426', '桥西区', 'pub', '130503', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '140', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377aa70427', '邢台县', 'pub', '130521', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '141', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377abe0428', '临城县', 'pub', '130522', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '142', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377ace0429', '内丘县', 'pub', '130523', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '143', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377adc042a', '柏乡县', 'pub', '130524', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '144', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377ae9042b', '隆尧县', 'pub', '130525', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '145', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377bfa042c', '任　县', 'pub', '130526', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '146', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377c09042d', '南和县', 'pub', '130527', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '147', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377c1a042e', '宁晋县', 'pub', '130528', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '148', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377d05042f', '巨鹿县', 'pub', '130529', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '149', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377d2b0430', '新河县', 'pub', '130530', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', '0', '150', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377d570431', '广宗县', 'pub', '130531', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '151', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377e800432', '平乡县', 'pub', '130532', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '152', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377fa40433', '威　县', 'pub', '130533', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '153', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83377fba0434', '清河县', 'pub', '130534', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '154', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833780d30436', '临西县', 'pub', '130535', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '155', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833780e30437', '南宫市', 'pub', '130581', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '156', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833780f40438', '沙河市', 'pub', '130582', 'ukewo', null, '297e1e874f83129d014f8334e3f1024a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', '0', '157', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833781d40439', '市辖区', 'pub', '130601', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '158', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833781e2043a', '新市区', 'pub', '130602', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '159', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833781f4043b', '北市区', 'pub', '130603', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '160', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337820f043c', '南市区', 'pub', '130604', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '161', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378221043d', '满城县', 'pub', '130621', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '162', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378339043e', '清苑县', 'pub', '130622', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '163', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337834d043f', '涞水县', 'pub', '130623', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '164', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337846b0440', '阜平县', 'pub', '130624', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '165', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833784820441', '徐水县', 'pub', '130625', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', '0', '166', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785420442', '定兴县', 'pub', '130626', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '167', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785540443', '唐　县', 'pub', '130627', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '168', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785630444', '高阳县', 'pub', '130628', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '169', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785730445', '容城县', 'pub', '130629', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '170', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785820446', '涞源县', 'pub', '130630', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '171', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785950447', '望都县', 'pub', '130631', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '172', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833785af0448', '安新县', 'pub', '130632', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '173', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833786d00449', '易　县', 'pub', '130633', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '174', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833786e1044a', '曲阳县', 'pub', '130634', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '175', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833787a8044b', '蠡　县', 'pub', '130635', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '176', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833787bb044c', '顺平县', 'pub', '130636', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '177', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833787ce044d', '博野县', 'pub', '130637', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '178', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833787df044e', '雄　县', 'pub', '130638', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '179', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833787f4044f', '涿州市', 'pub', '130681', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '180', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788030450', '定州市', 'pub', '130682', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '181', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788130451', '安国市', 'pub', '130683', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '182', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788220452', '高碑店市', 'pub', '130684', 'ukewo', null, '297e1e874f83129d014f8334e3fd024b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '183', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337884d0453', '市辖区', 'pub', '130701', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '184', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337885e0454', '桥东区', 'pub', '130702', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '185', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337886d0455', '桥西区', 'pub', '130703', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '186', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788820456', '宣化区', 'pub', '130705', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '187', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788980457', '下花园区', 'pub', '130706', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '188', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788a70458', '宣化县', 'pub', '130721', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '189', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788ba0459', '张北县', 'pub', '130722', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '190', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788cc045a', '康保县', 'pub', '130723', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '191', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788da045b', '沽源县', 'pub', '130724', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '192', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788ef045c', '尚义县', 'pub', '130725', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', '0', '193', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833788ff045d', '蔚　县', 'pub', '130726', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '194', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378913045e', '阳原县', 'pub', '130727', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '195', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378928045f', '怀安县', 'pub', '130728', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '196', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789360460', '万全县', 'pub', '130729', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '197', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337894d0461', '怀来县', 'pub', '130730', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '198', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337895e0462', '涿鹿县', 'pub', '130731', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '199', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337896d0463', '赤城县', 'pub', '130732', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '200', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337897e0464', '崇礼县', 'pub', '130733', 'ukewo', null, '297e1e874f83129d014f8334e409024c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '201', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789ab0465', '市辖区', 'pub', '130801', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '202', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789ba0466', '双桥区', 'pub', '130802', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '203', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789c90467', '双滦区', 'pub', '130803', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '204', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789d90468', '鹰手营子矿区', 'pub', '130804', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '205', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833789ec0469', '承德县', 'pub', '130821', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '206', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a07046a', '兴隆县', 'pub', '130822', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '207', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a1a046b', '平泉县', 'pub', '130823', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '208', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a2e046c', '滦平县', 'pub', '130824', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '209', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a3f046d', '隆化县', 'pub', '130825', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '210', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a51046e', '丰宁满族自治县', 'pub', '130826', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '211', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a72046f', '宽城满族自治县', 'pub', '130827', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '212', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378a860470', '围场满族蒙古族自治县', 'pub', '130828', 'ukewo', null, '297e1e874f83129d014f8334e418024d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '213', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378aaf0471', '市辖区', 'pub', '130901', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '214', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378abf0472', '新华区', 'pub', '130902', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '215', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ad10473', '运河区', 'pub', '130903', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '216', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ae60474', '沧　县', 'pub', '130921', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '217', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378af70475', '青　县', 'pub', '130922', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '218', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b070476', '东光县', 'pub', '130923', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '219', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b190477', '海兴县', 'pub', '130924', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '220', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b2a0478', '盐山县', 'pub', '130925', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '221', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b3c0479', '肃宁县', 'pub', '130926', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '222', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b4d047a', '南皮县', 'pub', '130927', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '223', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b5c047b', '吴桥县', 'pub', '130928', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '224', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b6a047c', '献　县', 'pub', '130929', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '225', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b7a047d', '孟村回族自治县', 'pub', '130930', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '226', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378b96047e', '泊头市', 'pub', '130981', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '227', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378bab047f', '任丘市', 'pub', '130982', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '228', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378bc00480', '黄骅市', 'pub', '130983', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '229', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378bcf0481', '河间市', 'pub', '130984', 'ukewo', null, '297e1e874f83129d014f8334e424024e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '230', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378bfe0482', '市辖区', 'pub', '131001', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '231', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c0f0483', '安次区', 'pub', '131002', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '232', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c230484', '广阳区', 'pub', '131003', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '233', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c3a0485', '固安县', 'pub', '131022', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '234', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c4c0486', '永清县', 'pub', '131023', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '235', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c5b0487', '香河县', 'pub', '131024', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '236', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c6b0488', '大城县', 'pub', '131025', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '237', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c800489', '文安县', 'pub', '131026', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '238', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378c99048a', '大厂回族自治县', 'pub', '131028', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '239', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ca9048b', '霸州市', 'pub', '131081', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '240', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378cbc048c', '三河市', 'pub', '131082', 'ukewo', null, '297e1e874f83129d014f8334e430024f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', '0', '241', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ce8048d', '市辖区', 'pub', '131101', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '242', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378cf7048e', '桃城区', 'pub', '131102', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '243', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d06048f', '枣强县', 'pub', '131121', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '244', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d190490', '武邑县', 'pub', '131122', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '245', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d2d0491', '武强县', 'pub', '131123', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '246', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d440492', '饶阳县', 'pub', '131124', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '247', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d520493', '安平县', 'pub', '131125', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '248', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d650494', '故城县', 'pub', '131126', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '249', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d770495', '景　县', 'pub', '131127', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '250', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d870496', '阜城县', 'pub', '131128', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '251', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378d960497', '冀州市', 'pub', '131181', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '252', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378dab0498', '深州市', 'pub', '131182', 'ukewo', null, '297e1e874f83129d014f8334e43e0250', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '253', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378de00499', '市辖区', 'pub', '140101', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '254', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378def049a', '小店区', 'pub', '140105', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '255', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e01049b', '迎泽区', 'pub', '140106', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '256', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e12049c', '杏花岭区', 'pub', '140107', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '257', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e27049d', '尖草坪区', 'pub', '140108', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '258', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e38049e', '万柏林区', 'pub', '140109', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '259', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e46049f', '晋源区', 'pub', '140110', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '260', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e5f04a0', '清徐县', 'pub', '140121', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '261', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e6f04a1', '阳曲县', 'pub', '140122', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '262', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e8104a2', '娄烦县', 'pub', '140123', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '263', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378e9504a3', '古交市', 'pub', '140181', 'ukewo', null, '297e1e874f83129d014f8334e6310251', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '264', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ebe04a4', '市辖区', 'pub', '140201', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '265', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ed204a5', '城　区', 'pub', '140202', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '266', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ee704a6', '矿　区', 'pub', '140203', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '267', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378efa04a7', '南郊区', 'pub', '140211', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '268', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f0a04a8', '新荣区', 'pub', '140212', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '269', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f1b04a9', '阳高县', 'pub', '140221', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '270', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f3304aa', '天镇县', 'pub', '140222', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '271', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f4804ab', '广灵县', 'pub', '140223', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '272', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f5b04ac', '灵丘县', 'pub', '140224', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '273', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f6f04ad', '浑源县', 'pub', '140225', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '274', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378f8d04ae', '左云县', 'pub', '140226', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '275', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378fa304af', '大同县', 'pub', '140227', 'ukewo', null, '297e1e874f83129d014f8334e6420252', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '276', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83378ff204b0', '市辖区', 'pub', '140301', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '277', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337900504b1', '城　区', 'pub', '140302', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '278', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337901a04b2', '矿　区', 'pub', '140303', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '279', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337903204b3', '郊　区', 'pub', '140311', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '280', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337904d04b4', '平定县', 'pub', '140321', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '281', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337906504b5', '盂　县', 'pub', '140322', 'ukewo', null, '297e1e874f83129d014f8334e64e0253', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '282', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833790a204b6', '市辖区', 'pub', '140401', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '283', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833790b304b7', '城　区', 'pub', '140402', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '284', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833790c404b8', '郊　区', 'pub', '140411', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', '0', '285', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833790d504b9', '长治县', 'pub', '140421', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '286', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833790ea04ba', '襄垣县', 'pub', '140423', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '287', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337922a04bb', '屯留县', 'pub', '140424', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '288', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337923f04bc', '平顺县', 'pub', '140425', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '289', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337925704bd', '黎城县', 'pub', '140426', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '290', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337926e04be', '壶关县', 'pub', '140427', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '291', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337928104bf', '长子县', 'pub', '140428', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '292', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337929404c0', '武乡县', 'pub', '140429', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '293', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833792a404c1', '沁　县', 'pub', '140430', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '294', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833792b304c2', '沁源县', 'pub', '140431', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '295', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833792c804c3', '潞城市', 'pub', '140481', 'ukewo', null, '297e1e874f83129d014f8334e65a0254', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '296', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833792fe04c4', '市辖区', 'pub', '140501', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '297', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337930f04c5', '城　区', 'pub', '140502', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '298', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337932404c6', '沁水县', 'pub', '140521', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '299', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337933604c7', '阳城县', 'pub', '140522', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '300', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337934d04c8', '陵川县', 'pub', '140524', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '301', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337935e04c9', '泽州县', 'pub', '140525', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '302', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337936d04ca', '高平市', 'pub', '140581', 'ukewo', null, '297e1e874f83129d014f8334e6650255', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '303', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337939804cb', '市辖区', 'pub', '140601', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', '0', '304', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833794d304cd', '朔城区', 'pub', '140602', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '305', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833794e604ce', '平鲁区', 'pub', '140603', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '306', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833794f704cf', '山阴县', 'pub', '140621', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '307', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337951004d0', '应　县', 'pub', '140622', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '308', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337952304d1', '右玉县', 'pub', '140623', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '309', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337953604d2', '怀仁县', 'pub', '140624', 'ukewo', null, '297e1e874f83129d014f8334e6730256', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '310', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337956804d3', '市辖区', 'pub', '140701', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '311', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337957804d4', '榆次区', 'pub', '140702', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '312', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337958904d5', '榆社县', 'pub', '140721', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '313', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833795a204d6', '左权县', 'pub', '140722', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '314', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833795b904d7', '和顺县', 'pub', '140723', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '315', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833796fd04d8', '昔阳县', 'pub', '140724', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '316', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337970e04d9', '寿阳县', 'pub', '140725', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '317', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337971f04da', '太谷县', 'pub', '140726', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '318', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337973104db', '祁　县', 'pub', '140727', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '319', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337973f04dc', '平遥县', 'pub', '140728', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '320', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337974f04dd', '灵石县', 'pub', '140729', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '321', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337975e04de', '介休市', 'pub', '140781', 'ukewo', null, '297e1e874f83129d014f8334e67f0257', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '322', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337978c04df', '市辖区', 'pub', '140801', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '323', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833797a004e0', '盐湖区', 'pub', '140802', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '324', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833797c604e1', '临猗县', 'pub', '140821', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '325', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833797e504e2', '万荣县', 'pub', '140822', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '326', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833797fa04e3', '闻喜县', 'pub', '140823', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '327', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337980a04e4', '稷山县', 'pub', '140824', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '328', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337981f04e5', '新绛县', 'pub', '140825', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '329', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337982f04e6', '绛　县', 'pub', '140826', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '330', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337984104e7', '垣曲县', 'pub', '140827', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '331', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337985304e8', '夏　县', 'pub', '140828', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '332', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337986304e9', '平陆县', 'pub', '140829', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '333', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337987a04ea', '芮城县', 'pub', '140830', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '334', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337988a04eb', '永济市', 'pub', '140881', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', '0', '335', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337989904ec', '河津市', 'pub', '140882', 'ukewo', null, '297e1e874f83129d014f8334e68e0258', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '336', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833799f404ed', '市辖区', 'pub', '140901', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '337', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a0204ee', '忻府区', 'pub', '140902', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '338', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a1304ef', '定襄县', 'pub', '140921', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '339', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a2504f0', '五台县', 'pub', '140922', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '340', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a3504f1', '代　县', 'pub', '140923', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '341', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a4a04f2', '繁峙县', 'pub', '140924', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '342', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a5a04f3', '宁武县', 'pub', '140925', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '343', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a6904f4', '静乐县', 'pub', '140926', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '344', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a8204f5', '神池县', 'pub', '140927', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '345', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379a9704f6', '五寨县', 'pub', '140928', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '346', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379aa604f7', '岢岚县', 'pub', '140929', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '347', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379abd04f8', '河曲县', 'pub', '140930', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '348', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379acb04f9', '保德县', 'pub', '140931', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '349', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c0604fa', '偏关县', 'pub', '140932', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '350', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c1d04fb', '原平市', 'pub', '140981', 'ukewo', null, '297e1e874f83129d014f8334e69e0259', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '351', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c4904fc', '市辖区', 'pub', '141001', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '352', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c5704fd', '尧都区', 'pub', '141002', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '353', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c6804fe', '曲沃县', 'pub', '141021', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '354', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c7704ff', '翼城县', 'pub', '141022', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', '0', '355', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c850500', '襄汾县', 'pub', '141023', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '356', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379c930501', '洪洞县', 'pub', '141024', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '357', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ca20502', '古　县', 'pub', '141025', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '358', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cb00503', '安泽县', 'pub', '141026', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '359', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cbf0504', '浮山县', 'pub', '141027', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '360', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cce0505', '吉　县', 'pub', '141028', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '361', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cdd0506', '乡宁县', 'pub', '141029', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '362', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cee0507', '大宁县', 'pub', '141030', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '363', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379cff0508', '隰　县', 'pub', '141031', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '364', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379d120509', '永和县', 'pub', '141032', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '365', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379e4d050a', '蒲　县', 'pub', '141033', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '366', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379e5b050b', '汾西县', 'pub', '141034', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '367', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379e68050c', '侯马市', 'pub', '141081', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '368', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379e77050d', '霍州市', 'pub', '141082', 'ukewo', null, '297e1e874f83129d014f8334e6ae025a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '369', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ea4050e', '市辖区', 'pub', '141101', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '370', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379eb2050f', '离石区', 'pub', '141102', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '371', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ec10510', '文水县', 'pub', '141121', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '372', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ed10511', '交城县', 'pub', '141122', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '373', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ee00512', '兴　县', 'pub', '141123', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '374', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379ef20513', '临　县', 'pub', '141124', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '375', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f030514', '柳林县', 'pub', '141125', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '376', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f120515', '石楼县', 'pub', '141126', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '377', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f210516', '岚　县', 'pub', '141127', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '378', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f300517', '方山县', 'pub', '141128', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '379', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f420518', '中阳县', 'pub', '141129', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '380', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83379f4f0519', '交口县', 'pub', '141130', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', '0', '381', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a08c051a', '孝义市', 'pub', '141181', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '382', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a09a051b', '汾阳市', 'pub', '141182', 'ukewo', null, '297e1e874f83129d014f8334e6bb025b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '383', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a0c2051c', '市辖区', 'pub', '150101', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '384', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a0d1051d', '新城区', 'pub', '150102', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '385', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a0df051e', '回民区', 'pub', '150103', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '386', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a0ee051f', '玉泉区', 'pub', '150104', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '387', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a0fe0520', '赛罕区', 'pub', '150105', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '388', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a10d0521', '土默特左旗', 'pub', '150121', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '389', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a1200522', '托克托县', 'pub', '150122', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '390', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a12d0523', '和林格尔县', 'pub', '150123', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '391', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a13b0524', '清水河县', 'pub', '150124', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '392', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a14d0525', '武川县', 'pub', '150125', 'ukewo', null, '297e1e874f83129d014f8334e6e0025c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '393', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2a30526', '市辖区', 'pub', '150201', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '394', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2b10527', '东河区', 'pub', '150202', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '395', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2be0528', '昆都仑区', 'pub', '150203', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '396', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2cc0529', '青山区', 'pub', '150204', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '397', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2da052a', '石拐区', 'pub', '150205', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '398', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2ea052b', '白云矿区', 'pub', '150206', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '399', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a2fa052c', '九原区', 'pub', '150207', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '400', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a308052d', '土默特右旗', 'pub', '150221', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '401', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a315052e', '固阳县', 'pub', '150222', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '402', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a324052f', '达尔罕茂明安联合旗', 'pub', '150223', 'ukewo', null, '297e1e874f83129d014f8334e6f5025d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '403', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a34e0530', '市辖区', 'pub', '150301', 'ukewo', null, '297e1e874f83129d014f8334e702025e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '404', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a35c0531', '海勃湾区', 'pub', '150302', 'ukewo', null, '297e1e874f83129d014f8334e702025e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', '0', '405', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a49a0532', '海南区', 'pub', '150303', 'ukewo', null, '297e1e874f83129d014f8334e702025e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '406', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a4a80533', '乌达区', 'pub', '150304', 'ukewo', null, '297e1e874f83129d014f8334e702025e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '407', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a4d20534', '市辖区', 'pub', '150401', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '408', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a4e20535', '红山区', 'pub', '150402', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '409', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a4f20536', '元宝山区', 'pub', '150403', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '410', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a5020537', '松山区', 'pub', '150404', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '411', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a5110538', '阿鲁科尔沁旗', 'pub', '150421', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '412', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a5200539', '巴林左旗', 'pub', '150422', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '413', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a530053a', '巴林右旗', 'pub', '150423', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '414', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a53e053b', '林西县', 'pub', '150424', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '415', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a54d053c', '克什克腾旗', 'pub', '150425', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '416', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a55c053d', '翁牛特旗', 'pub', '150426', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '417', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a56a053e', '喀喇沁旗', 'pub', '150428', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '418', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a57e053f', '宁城县', 'pub', '150429', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '419', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a58e0540', '敖汉旗', 'pub', '150430', 'ukewo', null, '297e1e874f83129d014f8334e70e025f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '420', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a6ed0541', '市辖区', 'pub', '150501', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '421', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7080542', '科尔沁区', 'pub', '150502', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '422', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a71b0543', '科尔沁左翼中旗', 'pub', '150521', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '423', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a72e0545', '科尔沁左翼后旗', 'pub', '150522', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '424', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7440546', '开鲁县', 'pub', '150523', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '425', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7530547', '库伦旗', 'pub', '150524', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '426', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7650548', '奈曼旗', 'pub', '150525', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '427', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7740549', '扎鲁特旗', 'pub', '150526', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '428', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a784054a', '霍林郭勒市', 'pub', '150581', 'ukewo', null, '297e1e874f83129d014f8334e71a0260', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '429', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a7ad054b', '东胜区', 'pub', '150602', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', '0', '430', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a8e9054c', '达拉特旗', 'pub', '150621', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '431', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a8f9054d', '准格尔旗', 'pub', '150622', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '432', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a90a054e', '鄂托克前旗', 'pub', '150623', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '433', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a91a054f', '鄂托克旗', 'pub', '150624', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '434', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a92a0550', '杭锦旗', 'pub', '150625', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '435', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a93d0551', '乌审旗', 'pub', '150626', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '436', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a94e0552', '伊金霍洛旗', 'pub', '150627', 'ukewo', null, '297e1e874f83129d014f8334e7270261', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '437', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9770553', '市辖区', 'pub', '150701', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '438', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9860554', '海拉尔区', 'pub', '150702', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '439', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a99a0555', '阿荣旗', 'pub', '150721', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '440', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9ad0556', '莫力达瓦达斡尔族自治旗', 'pub', '150722', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '441', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9bc0557', '鄂伦春自治旗', 'pub', '150723', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '442', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9c90558', '鄂温克族自治旗', 'pub', '150724', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '443', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9da0559', '陈巴尔虎旗', 'pub', '150725', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '444', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337a9f8055a', '新巴尔虎左旗', 'pub', '150726', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '445', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337aa06055b', '新巴尔虎右旗', 'pub', '150727', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '446', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ab42055c', '满洲里市', 'pub', '150781', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '447', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ab52055d', '牙克石市', 'pub', '150782', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '448', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ab61055e', '扎兰屯市', 'pub', '150783', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '449', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ab72055f', '额尔古纳市', 'pub', '150784', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '450', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ab820560', '根河市', 'pub', '150785', 'ukewo', null, '297e1e874f83129d014f8334e7360262', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '451', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abab0561', '市辖区', 'pub', '150801', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '452', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abba0562', '临河区', 'pub', '150802', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '453', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abca0563', '五原县', 'pub', '150821', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '454', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abdd0564', '磴口县', 'pub', '150822', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '455', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abed0565', '乌拉特前旗', 'pub', '150823', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '456', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337abff0566', '乌拉特中旗', 'pub', '150824', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '457', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ac110567', '乌拉特后旗', 'pub', '150825', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '458', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ac1e0568', '杭锦后旗', 'pub', '150826', 'ukewo', null, '297e1e874f83129d014f8334e7430263', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', '0', '459', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ac4e0569', '市辖区', 'pub', '150901', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '460', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ad8a056a', '集宁区', 'pub', '150902', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '461', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ada2056b', '卓资县', 'pub', '150921', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '462', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337add5056c', '化德县', 'pub', '150922', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '463', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ade9056d', '商都县', 'pub', '150923', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '464', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337adfe056e', '兴和县', 'pub', '150924', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '465', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae0d056f', '凉城县', 'pub', '150925', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '466', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae1d0570', '察哈尔右翼前旗', 'pub', '150926', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '467', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae2e0571', '察哈尔右翼中旗', 'pub', '150927', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '468', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae3e0572', '察哈尔右翼后旗', 'pub', '150928', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '469', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae4d0573', '四子王旗', 'pub', '150929', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '470', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae5e0574', '丰镇市', 'pub', '150981', 'ukewo', null, '297e1e874f83129d014f8334e74e0264', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '471', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae8e0575', '乌兰浩特市', 'pub', '152201', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '472', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ae9e0576', '阿尔山市', 'pub', '152202', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '473', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337aeb10577', '科尔沁右翼前旗', 'pub', '152221', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '474', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337aec10578', '科尔沁右翼中旗', 'pub', '152222', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '475', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337aecf0579', '扎赉特旗', 'pub', '152223', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '476', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337aedf057a', '突泉县', 'pub', '152224', 'ukewo', null, '297e1e874f83129d014f8334e75b0265', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', '0', '477', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b03c057b', '二连浩特市', 'pub', '152501', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '478', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b04e057c', '锡林浩特市', 'pub', '152502', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '479', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b062057d', '阿巴嘎旗', 'pub', '152522', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '480', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b077057e', '苏尼特左旗', 'pub', '152523', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '481', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b08b057f', '苏尼特右旗', 'pub', '152524', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '482', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b09f0580', '东乌珠穆沁旗', 'pub', '152525', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '483', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b0b80581', '西乌珠穆沁旗', 'pub', '152526', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '484', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b0ca0582', '太仆寺旗', 'pub', '152527', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '485', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b0dd0583', '镶黄旗', 'pub', '152528', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '486', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b0ed0584', '正镶白旗', 'pub', '152529', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '487', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b1020585', '正蓝旗', 'pub', '152530', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '488', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b1130586', '多伦县', 'pub', '152531', 'ukewo', null, '297e1e874f83129d014f8334e7680266', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '489', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b13e0587', '阿拉善左旗', 'pub', '152921', 'ukewo', null, '297e1e874f83129d014f8334e7740267', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '490', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b1530588', '阿拉善右旗', 'pub', '152922', 'ukewo', null, '297e1e874f83129d014f8334e7740267', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '491', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b1670589', '额济纳旗', 'pub', '152923', 'ukewo', null, '297e1e874f83129d014f8334e7740267', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '492', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b2c8058a', '市辖区', 'pub', '210101', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '493', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b2d8058b', '和平区', 'pub', '210102', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '494', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b2e8058c', '沈河区', 'pub', '210103', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '495', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b2fa058d', '大东区', 'pub', '210104', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '496', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b310058e', '皇姑区', 'pub', '210105', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '497', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b321058f', '铁西区', 'pub', '210106', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '498', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3320590', '苏家屯区', 'pub', '210111', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '499', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3420591', '东陵区', 'pub', '210112', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '500', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3530592', '新城子区', 'pub', '210113', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '501', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3630593', '于洪区', 'pub', '210114', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '502', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3740594', '辽中县', 'pub', '210122', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '503', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3820595', '康平县', 'pub', '210123', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '504', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3980596', '法库县', 'pub', '210124', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '505', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3ac0597', '新民市', 'pub', '210181', 'ukewo', null, '297e1e874f83129d014f8334e7960268', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '506', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3da0598', '市辖区', 'pub', '210201', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '507', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b3ea0599', '中山区', 'pub', '210202', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', '0', '508', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b400059a', '西岗区', 'pub', '210203', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '509', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b412059b', '沙河口区', 'pub', '210204', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '510', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b550059c', '甘井子区', 'pub', '210211', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '511', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b560059d', '旅顺口区', 'pub', '210212', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '512', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b56f059e', '金州区', 'pub', '210213', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '513', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b58b059f', '长海县', 'pub', '210224', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '514', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b59b05a0', '瓦房店市', 'pub', '210281', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '515', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b5af05a1', '普兰店市', 'pub', '210282', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '516', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b5c105a2', '庄河市', 'pub', '210283', 'ukewo', null, '297e1e874f83129d014f8334e7a40269', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '517', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b5ec05a3', '市辖区', 'pub', '210301', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '518', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b5fa05a4', '铁东区', 'pub', '210302', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '519', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b60a05a5', '铁西区', 'pub', '210303', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '520', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b61905a6', '立山区', 'pub', '210304', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '521', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b62905a7', '千山区', 'pub', '210311', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '522', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b63c05a8', '台安县', 'pub', '210321', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '523', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b64b05a9', '岫岩满族自治县', 'pub', '210323', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '524', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b65c05aa', '海城市', 'pub', '210381', 'ukewo', null, '297e1e874f83129d014f8334e7b2026a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '525', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7ae05ab', '市辖区', 'pub', '210401', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '526', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7bc05ac', '新抚区', 'pub', '210402', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '527', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7ca05ad', '东洲区', 'pub', '210403', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', '0', '528', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7da05ae', '望花区', 'pub', '210404', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '529', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7e805af', '顺城区', 'pub', '210411', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '530', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b7f905b0', '抚顺县', 'pub', '210421', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '531', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b80b05b1', '新宾满族自治县', 'pub', '210422', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '532', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b81a05b2', '清原满族自治县', 'pub', '210423', 'ukewo', null, '297e1e874f83129d014f8334e7c2026b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '533', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b84605b3', '市辖区', 'pub', '210501', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '534', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b85805b4', '平山区', 'pub', '210502', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '535', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b86905b5', '溪湖区', 'pub', '210503', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '536', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b9a605b6', '明山区', 'pub', '210504', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '537', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b9b505b7', '南芬区', 'pub', '210505', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '538', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b9c305b8', '本溪满族自治县', 'pub', '210521', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '539', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337b9d405b9', '桓仁满族自治县', 'pub', '210522', 'ukewo', null, '297e1e874f83129d014f8334e7ce026c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '540', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba1105ba', '市辖区', 'pub', '210601', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '541', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba1f05bb', '元宝区', 'pub', '210602', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '542', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba3005bc', '振兴区', 'pub', '210603', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '543', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba3e05bd', '振安区', 'pub', '210604', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '544', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba4b05be', '宽甸满族自治县', 'pub', '210624', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '545', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba5c05bf', '东港市', 'pub', '210681', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '546', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba6b05c0', '凤城市', 'pub', '210682', 'ukewo', null, '297e1e874f83129d014f8334e7da026d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '547', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ba9605c1', '市辖区', 'pub', '210701', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '548', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337baa405c2', '古塔区', 'pub', '210702', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '549', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bab405c4', '凌河区', 'pub', '210703', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', '0', '550', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bbfc05c5', '太和区', 'pub', '210711', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '551', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc0905c6', '黑山县', 'pub', '210726', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '552', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc1a05c7', '义　县', 'pub', '210727', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '553', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc2705c8', '凌海市', 'pub', '210781', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '554', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc3505c9', '北宁市', 'pub', '210782', 'ukewo', null, '297e1e874f83129d014f8334e7e6026e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '555', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc6205ca', '市辖区', 'pub', '210801', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '556', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc7005cb', '站前区', 'pub', '210802', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '557', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc8105cc', '西市区', 'pub', '210803', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '558', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bc9505cd', '鲅鱼圈区', 'pub', '210804', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '559', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bca605ce', '老边区', 'pub', '210811', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '560', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bcbe05cf', '盖州市', 'pub', '210881', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '561', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bdf805d0', '大石桥市', 'pub', '210882', 'ukewo', null, '297e1e874f83129d014f8334e7f3026f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '562', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be2805d1', '市辖区', 'pub', '210901', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '563', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be3d05d2', '海州区', 'pub', '210902', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '564', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be4c05d3', '新邱区', 'pub', '210903', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '565', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be5a05d4', '太平区', 'pub', '210904', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '566', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be6705d5', '清河门区', 'pub', '210905', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '567', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be7505d6', '细河区', 'pub', '210911', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '568', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337be8b05d7', '阜新蒙古族自治县', 'pub', '210921', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '569', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bea305d8', '彰武县', 'pub', '210922', 'ukewo', null, '297e1e874f83129d014f8334e8010270', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '570', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bede05d9', '市辖区', 'pub', '211001', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '571', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337beec05da', '白塔区', 'pub', '211002', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '572', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf0005db', '文圣区', 'pub', '211003', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '573', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf0e05dc', '宏伟区', 'pub', '211004', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '574', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf2405dd', '弓长岭区', 'pub', '211005', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '575', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf3205de', '太子河区', 'pub', '211011', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '576', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf4b05df', '辽阳县', 'pub', '211021', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '577', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337bf6105e0', '灯塔市', 'pub', '211081', 'ukewo', null, '297e1e874f83129d014f8334e80f0272', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', '0', '578', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c0ba05e1', '市辖区', 'pub', '211101', 'ukewo', null, '297e1e874f83129d014f8334e81e0273', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '579', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c0c805e2', '双台子区', 'pub', '211102', 'ukewo', null, '297e1e874f83129d014f8334e81e0273', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '580', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c0d605e3', '兴隆台区', 'pub', '211103', 'ukewo', null, '297e1e874f83129d014f8334e81e0273', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '581', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c0e705e4', '大洼县', 'pub', '211121', 'ukewo', null, '297e1e874f83129d014f8334e81e0273', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '582', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c0f405e5', '盘山县', 'pub', '211122', 'ukewo', null, '297e1e874f83129d014f8334e81e0273', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '583', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c12105e6', '市辖区', 'pub', '211201', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '584', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c12e05e7', '银州区', 'pub', '211202', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '585', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c13d05e8', '清河区', 'pub', '211204', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '586', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c15005e9', '铁岭县', 'pub', '211221', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '587', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c16705ea', '西丰县', 'pub', '211223', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '588', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c17905eb', '昌图县', 'pub', '211224', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '589', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c2b805ec', '调兵山市', 'pub', '211281', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '590', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c2cc05ed', '开原市', 'pub', '211282', 'ukewo', null, '297e1e874f83129d014f8334e82c0274', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '591', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c2fa05ee', '市辖区', 'pub', '211301', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '592', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c31005ef', '双塔区', 'pub', '211302', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '593', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c32605f0', '龙城区', 'pub', '211303', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '594', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c33c05f1', '朝阳县', 'pub', '211321', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '595', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c34f05f2', '建平县', 'pub', '211322', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '596', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c36405f3', '喀喇沁左翼蒙古族自治县', 'pub', '211324', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '597', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c37c05f4', '北票市', 'pub', '211381', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '598', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c38d05f5', '凌源市', 'pub', '211382', 'ukewo', null, '297e1e874f83129d014f8334e8410275', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', '0', '599', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c3b805f6', '市辖区', 'pub', '211401', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '600', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c3cc05f7', '连山区', 'pub', '211402', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '601', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c3df05f8', '龙港区', 'pub', '211403', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '602', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c3ef05f9', '南票区', 'pub', '211404', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '603', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c40005fa', '绥中县', 'pub', '211421', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '604', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c41605fb', '建昌县', 'pub', '211422', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '605', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c42c05fc', '兴城市', 'pub', '211481', 'ukewo', null, '297e1e874f83129d014f8334e84e0276', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '606', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c58b05fd', '市辖区', 'pub', '220101', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '607', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c59f05fe', '南关区', 'pub', '220102', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '608', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c5b705ff', '宽城区', 'pub', '220103', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '609', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c5c80600', '朝阳区', 'pub', '220104', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '610', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c5db0601', '二道区', 'pub', '220105', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '611', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c5f00602', '绿园区', 'pub', '220106', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '612', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6040603', '双阳区', 'pub', '220112', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '613', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6130604', '农安县', 'pub', '220122', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '614', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6270605', '九台市', 'pub', '220181', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '615', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c63b0606', '榆树市', 'pub', '220182', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '616', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c64f0607', '德惠市', 'pub', '220183', 'ukewo', null, '297e1e874f83129d014f8334e8730277', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '617', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c67f0608', '市辖区', 'pub', '220201', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '618', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c68f0609', '昌邑区', 'pub', '220202', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '619', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6a3060a', '龙潭区', 'pub', '220203', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '620', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6b9060b', '船营区', 'pub', '220204', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '621', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6c8060c', '丰满区', 'pub', '220211', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '622', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c6d8060d', '永吉县', 'pub', '220221', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', '0', '623', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c813060e', '蛟河市', 'pub', '220281', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '624', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c822060f', '桦甸市', 'pub', '220282', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '625', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8360610', '舒兰市', 'pub', '220283', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '626', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8440611', '磐石市', 'pub', '220284', 'ukewo', null, '297e1e874f83129d014f8334e8800278', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '627', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c86d0612', '市辖区', 'pub', '220301', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '628', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c87b0613', '铁西区', 'pub', '220302', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '629', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8880614', '铁东区', 'pub', '220303', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '630', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8950615', '梨树县', 'pub', '220322', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '631', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8a50616', '伊通满族自治县', 'pub', '220323', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '632', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8b30617', '公主岭市', 'pub', '220381', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '633', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8c40618', '双辽市', 'pub', '220382', 'ukewo', null, '297e1e874f83129d014f8334e88f0279', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '634', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337c8ea0619', '市辖区', 'pub', '220401', 'ukewo', null, '297e1e874f83129d014f8334e89c027a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '635', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca40061a', '龙山区', 'pub', '220402', 'ukewo', null, '297e1e874f83129d014f8334e89c027a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '636', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca4d061b', '西安区', 'pub', '220403', 'ukewo', null, '297e1e874f83129d014f8334e89c027a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '637', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca5d061c', '东丰县', 'pub', '220421', 'ukewo', null, '297e1e874f83129d014f8334e89c027a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '638', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca6a061d', '东辽县', 'pub', '220422', 'ukewo', null, '297e1e874f83129d014f8334e89c027a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '639', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca91061e', '市辖区', 'pub', '220501', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '640', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ca9e061f', '东昌区', 'pub', '220502', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '641', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337caad0620', '二道江区', 'pub', '220503', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '642', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337caba0621', '通化县', 'pub', '220521', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '643', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cac70622', '辉南县', 'pub', '220523', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '644', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cad50623', '柳河县', 'pub', '220524', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '645', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cae20624', '梅河口市', 'pub', '220581', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '646', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337caf20625', '集安市', 'pub', '220582', 'ukewo', null, '297e1e874f83129d014f8334e8a8027b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '647', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cb1b0626', '市辖区', 'pub', '220601', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', '0', '648', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cc580627', '八道江区', 'pub', '220602', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '649', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cc650628', '抚松县', 'pub', '220621', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '650', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cc750629', '靖宇县', 'pub', '220622', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '651', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cc87062a', '长白朝鲜族自治县', 'pub', '220623', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '652', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cc96062b', '江源县', 'pub', '220625', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '653', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cca6062c', '临江市', 'pub', '220681', 'ukewo', null, '297e1e874f83129d014f8334e8b9027c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '654', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ccd3062d', '市辖区', 'pub', '220701', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '655', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cce0062e', '宁江区', 'pub', '220702', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '656', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ccef062f', '前郭尔罗斯蒙古族自治县', 'pub', '220721', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '657', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ccfd0630', '长岭县', 'pub', '220722', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '658', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cd0a0631', '乾安县', 'pub', '220723', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '659', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cd190632', '扶余县', 'pub', '220724', 'ukewo', null, '297e1e874f83129d014f8334e8c6027d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '660', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf2f0634', '市辖区', 'pub', '220801', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '661', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf400635', '洮北区', 'pub', '220802', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', '0', '662', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf4d0636', '镇赉县', 'pub', '220821', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '663', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf5d0637', '通榆县', 'pub', '220822', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '664', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf6c0638', '洮南市', 'pub', '220881', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '665', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cf7c0639', '大安市', 'pub', '220882', 'ukewo', null, '297e1e874f83129d014f8334e8d4027e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '666', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfa6063a', '延吉市', 'pub', '222401', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '667', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfb4063b', '图们市', 'pub', '222402', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '668', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfc1063c', '敦化市', 'pub', '222403', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '669', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfcf063d', '珲春市', 'pub', '222404', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '670', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfdd063e', '龙井市', 'pub', '222405', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '671', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cfea063f', '和龙市', 'pub', '222406', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '672', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337cffc0640', '汪清县', 'pub', '222424', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '673', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d0090641', '安图县', 'pub', '222426', 'ukewo', null, '297e1e874f83129d014f8334e8e1027f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '674', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d0340642', '市辖区', 'pub', '230101', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '675', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d0410643', '道里区', 'pub', '230102', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '676', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d17c0644', '南岗区', 'pub', '230103', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '677', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d18f0645', '道外区', 'pub', '230104', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '678', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d19f0646', '香坊区', 'pub', '230106', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '679', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1af0647', '动力区', 'pub', '230107', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '680', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1c30648', '平房区', 'pub', '230108', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '681', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1d10649', '松北区', 'pub', '230109', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '682', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1e1064a', '呼兰区', 'pub', '230111', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '683', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1ee064b', '依兰县', 'pub', '230123', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '684', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d1fb064c', '方正县', 'pub', '230124', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '685', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d209064d', '宾　县', 'pub', '230125', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '686', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d219064e', '巴彦县', 'pub', '230126', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '687', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d228064f', '木兰县', 'pub', '230127', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '688', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d2370650', '通河县', 'pub', '230128', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '689', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d2490651', '延寿县', 'pub', '230129', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '690', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d2580652', '阿城市', 'pub', '230181', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '691', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d2660653', '双城市', 'pub', '230182', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '692', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d2730654', '尚志市', 'pub', '230183', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', '0', '693', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d3ad0655', '五常市', 'pub', '230184', 'ukewo', null, '297e1e874f83129d014f8334e91d0280', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '694', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d3d80656', '市辖区', 'pub', '230201', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '695', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d3e70657', '龙沙区', 'pub', '230202', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '696', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d3f40658', '建华区', 'pub', '230203', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '697', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d4010659', '铁锋区', 'pub', '230204', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '698', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d410065a', '昂昂溪区', 'pub', '230205', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '699', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d41d065b', '富拉尔基区', 'pub', '230206', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '700', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d42c065c', '碾子山区', 'pub', '230207', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '701', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d43d065d', '梅里斯达斡尔族区', 'pub', '230208', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '702', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d44a065e', '龙江县', 'pub', '230221', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '703', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d457065f', '依安县', 'pub', '230223', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '704', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d4640660', '泰来县', 'pub', '230224', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '705', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d4760661', '甘南县', 'pub', '230225', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '706', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d5b30662', '富裕县', 'pub', '230227', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '707', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d5c30663', '克山县', 'pub', '230229', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '708', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d5d10664', '克东县', 'pub', '230230', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '709', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d5df0665', '拜泉县', 'pub', '230231', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '710', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d5ee0666', '讷河市', 'pub', '230281', 'ukewo', null, '297e1e874f83129d014f8334e9290281', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '711', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d61f0667', '市辖区', 'pub', '230301', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '712', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d62f0668', '鸡冠区', 'pub', '230302', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '713', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d63f0669', '恒山区', 'pub', '230303', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '714', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d650066a', '滴道区', 'pub', '230304', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '715', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d65f066b', '梨树区', 'pub', '230305', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '716', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d670066c', '城子河区', 'pub', '230306', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '717', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d688066d', '麻山区', 'pub', '230307', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '718', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d69c066e', '鸡东县', 'pub', '230321', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '719', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d6ab066f', '虎林市', 'pub', '230381', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '720', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d6bd0670', '密山市', 'pub', '230382', 'ukewo', null, '297e1e874f83129d014f8334e9390282', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', '0', '721', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d81b0671', '市辖区', 'pub', '230401', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '722', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d82f0672', '向阳区', 'pub', '230402', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '723', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8420673', '工农区', 'pub', '230403', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '724', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8580674', '南山区', 'pub', '230404', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '725', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d86c0675', '兴安区', 'pub', '230405', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '726', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8800676', '东山区', 'pub', '230406', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '727', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8910677', '兴山区', 'pub', '230407', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '728', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d89f0678', '萝北县', 'pub', '230421', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '729', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8ab0679', '绥滨县', 'pub', '230422', 'ukewo', null, '297e1e874f83129d014f8334e9470283', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '730', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8db067a', '市辖区', 'pub', '230501', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '731', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8eb067b', '尖山区', 'pub', '230502', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '732', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d8fc067c', '岭东区', 'pub', '230503', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '733', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d90d067d', '四方台区', 'pub', '230505', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '734', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d91b067e', '宝山区', 'pub', '230506', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '735', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337d92b067f', '集贤县', 'pub', '230521', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '736', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337da6e0680', '友谊县', 'pub', '230522', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '737', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337da810681', '宝清县', 'pub', '230523', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '738', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337da8e0682', '饶河县', 'pub', '230524', 'ukewo', null, '297e1e874f83129d014f8334e9570284', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '739', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dabe0683', '市辖区', 'pub', '230601', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '740', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dacd0684', '萨尔图区', 'pub', '230602', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '741', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dadf0685', '龙凤区', 'pub', '230603', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '742', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337daed0686', '让胡路区', 'pub', '230604', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '743', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dafb0687', '红岗区', 'pub', '230605', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', '0', '744', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db090688', '大同区', 'pub', '230606', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '745', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db1a0689', '肇州县', 'pub', '230621', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '746', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db2a068a', '肇源县', 'pub', '230622', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '747', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db40068b', '林甸县', 'pub', '230623', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '748', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db4f068c', '杜尔伯特蒙古族自治县', 'pub', '230624', 'ukewo', null, '297e1e874f83129d014f8334e9630285', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '749', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337db7a068d', '市辖区', 'pub', '230701', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '750', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dcb4068e', '伊春区', 'pub', '230702', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '751', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dcc4068f', '南岔区', 'pub', '230703', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '752', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dcd20690', '友好区', 'pub', '230704', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '753', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dce30691', '西林区', 'pub', '230705', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '754', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dcf20692', '翠峦区', 'pub', '230706', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '755', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd010693', '新青区', 'pub', '230707', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '756', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd0f0694', '美溪区', 'pub', '230708', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '757', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd1f0695', '金山屯区', 'pub', '230709', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '758', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd2c0696', '五营区', 'pub', '230710', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '759', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd3d0697', '乌马河区', 'pub', '230711', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '760', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd4d0698', '汤旺河区', 'pub', '230712', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '761', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd5c0699', '带岭区', 'pub', '230713', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '762', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd69069a', '乌伊岭区', 'pub', '230714', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '763', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd7b069b', '红星区', 'pub', '230715', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '764', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dd89069c', '上甘岭区', 'pub', '230716', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '765', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337deca069d', '嘉荫县', 'pub', '230722', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '766', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ded8069e', '铁力市', 'pub', '230781', 'ukewo', null, '297e1e874f83129d014f8334e9710286', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', '0', '767', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df02069f', '市辖区', 'pub', '230801', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '768', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df1306a0', '永红区', 'pub', '230802', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '769', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df2106a1', '向阳区', 'pub', '230803', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '770', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df3006a2', '前进区', 'pub', '230804', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '771', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df4106a3', '东风区', 'pub', '230805', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '772', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df5106a4', '郊　区', 'pub', '230811', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '773', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df5e06a5', '桦南县', 'pub', '230822', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '774', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df6c06a6', '桦川县', 'pub', '230826', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '775', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df7a06a7', '汤原县', 'pub', '230828', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '776', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df8a06a8', '抚远县', 'pub', '230833', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '777', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337df9806a9', '同江市', 'pub', '230881', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '778', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dfa706aa', '富锦市', 'pub', '230882', 'ukewo', null, '297e1e874f83129d014f8334e97d0287', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '779', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337dfd206ab', '市辖区', 'pub', '230901', 'ukewo', null, '297e1e874f83129d014f8334e98e0288', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '780', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e10b06ac', '新兴区', 'pub', '230902', 'ukewo', null, '297e1e874f83129d014f8334e98e0288', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '781', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e11906ad', '桃山区', 'pub', '230903', 'ukewo', null, '297e1e874f83129d014f8334e98e0288', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '782', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e12806ae', '茄子河区', 'pub', '230904', 'ukewo', null, '297e1e874f83129d014f8334e98e0288', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '783', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e13a06af', '勃利县', 'pub', '230921', 'ukewo', null, '297e1e874f83129d014f8334e98e0288', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '784', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e16606b0', '市辖区', 'pub', '231001', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '785', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e17306b1', '东安区', 'pub', '231002', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '786', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e18306b2', '阳明区', 'pub', '231003', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '787', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e19206b3', '爱民区', 'pub', '231004', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '788', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e1a306b4', '西安区', 'pub', '231005', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '789', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e1b406b5', '东宁县', 'pub', '231024', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '790', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e1c106b6', '林口县', 'pub', '231025', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '791', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e1d606b8', '绥芬河市', 'pub', '231081', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', '0', '792', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e30f06b9', '海林市', 'pub', '231083', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '793', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e31d06ba', '宁安市', 'pub', '231084', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '794', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e33406bb', '穆棱市', 'pub', '231085', 'ukewo', null, '297e1e874f83129d014f8334e99a0289', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '795', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e36006bc', '市辖区', 'pub', '231101', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '796', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e36e06bd', '爱辉区', 'pub', '231102', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '797', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e37b06be', '嫩江县', 'pub', '231121', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '798', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e38906bf', '逊克县', 'pub', '231123', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '799', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e39906c0', '孙吴县', 'pub', '231124', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '800', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e3a806c1', '北安市', 'pub', '231181', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '801', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e3b706c2', '五大连池市', 'pub', '231182', 'ukewo', null, '297e1e874f83129d014f8334e9a8028a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '802', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e50a06c3', '市辖区', 'pub', '231201', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '803', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e51806c4', '北林区', 'pub', '231202', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '804', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e52606c5', '望奎县', 'pub', '231221', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '805', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e53806c6', '兰西县', 'pub', '231222', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '806', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e54706c7', '青冈县', 'pub', '231223', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '807', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e55406c8', '庆安县', 'pub', '231224', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '808', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e56306c9', '明水县', 'pub', '231225', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '809', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e57306ca', '绥棱县', 'pub', '231226', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '810', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e58006cb', '安达市', 'pub', '231281', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '811', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e58d06cc', '肇东市', 'pub', '231282', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '812', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e59b06cd', '海伦市', 'pub', '231283', 'ukewo', null, '297e1e874f83129d014f8334e9b5028b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '813', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e5c306ce', '呼玛县', 'pub', '232721', 'ukewo', null, '297e1e874f83129d014f8334e9c4028c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', '0', '814', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e70106cf', '塔河县', 'pub', '232722', 'ukewo', null, '297e1e874f83129d014f8334e9c4028c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '815', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e70f06d0', '漠河县', 'pub', '232723', 'ukewo', null, '297e1e874f83129d014f8334e9c4028c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '816', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e73c06d1', '黄浦区', 'pub', '310101', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '817', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e74d06d2', '卢湾区', 'pub', '310103', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '818', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e75b06d3', '徐汇区', 'pub', '310104', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '819', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e76906d4', '长宁区', 'pub', '310105', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '820', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e77806d5', '静安区', 'pub', '310106', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '821', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e78606d6', '普陀区', 'pub', '310107', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '822', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e79506d7', '闸北区', 'pub', '310108', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '823', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7a506d8', '虹口区', 'pub', '310109', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '824', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7b306d9', '杨浦区', 'pub', '310110', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '825', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7c106da', '闵行区', 'pub', '310112', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '826', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7cf06db', '宝山区', 'pub', '310113', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '827', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7df06dc', '嘉定区', 'pub', '310114', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '828', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7ed06dd', '浦东新区', 'pub', '310115', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '829', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e7fe06de', '金山区', 'pub', '310116', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '830', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e93a06df', '松江区', 'pub', '310117', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '831', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e94d06e0', '青浦区', 'pub', '310118', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '832', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e95b06e1', '南汇区', 'pub', '310119', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '833', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e96b06e2', '奉贤区', 'pub', '310120', 'ukewo', null, '297e1e874f83129d014f8334e9e5028d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '834', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e99506e3', '崇明县', 'pub', '310230', 'ukewo', null, '297e1e874f83129d014f8334e9f3028e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '835', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e9c206e4', '市辖区', 'pub', '320101', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '836', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e9d106e5', '玄武区', 'pub', '320102', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '837', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e9de06e6', '白下区', 'pub', '320103', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '838', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e9eb06e7', '秦淮区', 'pub', '320104', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '839', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337e9f706e8', '建邺区', 'pub', '320105', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '840', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ea0506e9', '鼓楼区', 'pub', '320106', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', '0', '841', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb3f06ea', '下关区', 'pub', '320107', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '842', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb4d06eb', '浦口区', 'pub', '320111', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '843', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb5906ec', '栖霞区', 'pub', '320113', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '844', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb6506ed', '雨花台区', 'pub', '320114', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '845', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb7206ee', '江宁区', 'pub', '320115', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '846', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb8006ef', '六合区', 'pub', '320116', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '847', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb8f06f0', '溧水县', 'pub', '320124', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '848', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eb9b06f1', '高淳县', 'pub', '320125', 'ukewo', null, '297e1e874f83129d014f8334ea23028f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '849', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ebc406f2', '市辖区', 'pub', '320201', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '850', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ebd206f3', '崇安区', 'pub', '320202', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '851', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ebdf06f4', '南长区', 'pub', '320203', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '852', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ebeb06f5', '北塘区', 'pub', '320204', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '853', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ebf906f6', '锡山区', 'pub', '320205', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '854', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed3106f7', '惠山区', 'pub', '320206', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '855', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed4306f8', '滨湖区', 'pub', '320211', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '856', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed5806f9', '江阴市', 'pub', '320281', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '857', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed6606fa', '宜兴市', 'pub', '320282', 'ukewo', null, '297e1e874f83129d014f8334ea320290', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '858', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed8f06fb', '市辖区', 'pub', '320301', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '859', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ed9c06fc', '鼓楼区', 'pub', '320302', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '860', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eda906fd', '云龙区', 'pub', '320303', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '861', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337edb506fe', '九里区', 'pub', '320304', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '862', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337edc506ff', '贾汪区', 'pub', '320305', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '863', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337edd30700', '泉山区', 'pub', '320311', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '864', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ede10701', '丰　县', 'pub', '320321', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '865', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337edee0702', '沛　县', 'pub', '320322', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '866', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337edfb0703', '铜山县', 'pub', '320323', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', '0', '867', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ef3d0704', '睢宁县', 'pub', '320324', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '868', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ef4d0705', '新沂市', 'pub', '320381', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '869', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ef5a0706', '邳州市', 'pub', '320382', 'ukewo', null, '297e1e874f83129d014f8334ea430291', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '870', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ef840707', '市辖区', 'pub', '320401', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '871', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ef910708', '天宁区', 'pub', '320402', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '872', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337efa10709', '钟楼区', 'pub', '320404', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '873', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337efaf070a', '戚墅堰区', 'pub', '320405', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '874', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337efc3070b', '新北区', 'pub', '320411', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '875', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337efd3070c', '武进区', 'pub', '320412', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '876', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337efe1070d', '溧阳市', 'pub', '320481', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '877', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337eff1070e', '金坛市', 'pub', '320482', 'ukewo', null, '297e1e874f83129d014f8334ea510292', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '878', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f01c070f', '市辖区', 'pub', '320501', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '879', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f0280710', '沧浪区', 'pub', '320502', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '880', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f03e0711', '平江区', 'pub', '320503', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '881', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f17a0712', '金阊区', 'pub', '320504', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '882', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1890713', '虎丘区', 'pub', '320505', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '883', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1960714', '吴中区', 'pub', '320506', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '884', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1a50715', '相城区', 'pub', '320507', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '885', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1b40716', '常熟市', 'pub', '320581', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '886', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1c20717', '张家港市', 'pub', '320582', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '887', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1d20718', '昆山市', 'pub', '320583', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '888', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1df0719', '吴江市', 'pub', '320584', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '889', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f1ee071a', '太仓市', 'pub', '320585', 'ukewo', null, '297e1e874f83129d014f8334ea5e0293', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '890', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f21a071b', '市辖区', 'pub', '320601', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '891', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f227071c', '崇川区', 'pub', '320602', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '892', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f236071d', '港闸区', 'pub', '320611', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '893', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f24b071e', '海安县', 'pub', '320621', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', '0', '894', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f385071f', '如东县', 'pub', '320623', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '895', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3920720', '启东市', 'pub', '320681', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '896', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3a00721', '如皋市', 'pub', '320682', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '897', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3b40722', '通州市', 'pub', '320683', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '898', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3c20723', '海门市', 'pub', '320684', 'ukewo', null, '297e1e874f83129d014f8334ea6d0294', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '899', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3ec0724', '市辖区', 'pub', '320701', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '900', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f3fa0725', '连云区', 'pub', '320703', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '901', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f4070726', '新浦区', 'pub', '320705', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '902', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f4150727', '海州区', 'pub', '320706', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '903', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f4260728', '赣榆县', 'pub', '320721', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '904', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f4340729', '东海县', 'pub', '320722', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '905', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f445072a', '灌云县', 'pub', '320723', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '906', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f453072b', '灌南县', 'pub', '320724', 'ukewo', null, '297e1e874f83129d014f8334ea790295', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '907', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f483072c', '市辖区', 'pub', '320801', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '908', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f5bf072e', '清河区', 'pub', '320802', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '909', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f5d4072f', '楚州区', 'pub', '320803', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '910', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f5e30730', '淮阴区', 'pub', '320804', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '911', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f5ef0731', '清浦区', 'pub', '320811', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '912', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f5fe0732', '涟水县', 'pub', '320826', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '913', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f60d0733', '洪泽县', 'pub', '320829', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '914', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f61b0734', '盱眙县', 'pub', '320830', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '915', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f6290735', '金湖县', 'pub', '320831', 'ukewo', null, '297e1e874f83129d014f8334ea850296', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '916', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f6520736', '市辖区', 'pub', '320901', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', '0', '917', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f65f0737', '亭湖区', 'pub', '320902', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '918', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f66d0738', '盐都区', 'pub', '320903', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '919', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7a70739', '响水县', 'pub', '320921', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '920', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7b6073a', '滨海县', 'pub', '320922', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '921', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7c7073b', '阜宁县', 'pub', '320923', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '922', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7d7073c', '射阳县', 'pub', '320924', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '923', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7e4073d', '建湖县', 'pub', '320925', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '924', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f7fe073e', '东台市', 'pub', '320981', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '925', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f80c073f', '大丰市', 'pub', '320982', 'ukewo', null, '297e1e874f83129d014f8334ea940297', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '926', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f8380740', '市辖区', 'pub', '321001', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '927', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f8460741', '广陵区', 'pub', '321002', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '928', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f8550742', '邗江区', 'pub', '321003', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '929', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f8610743', '郊　区', 'pub', '321011', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '930', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f86f0744', '宝应县', 'pub', '321023', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '931', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f8800745', '仪征市', 'pub', '321081', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '932', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f9bb0746', '高邮市', 'pub', '321084', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '933', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f9ca0747', '江都市', 'pub', '321088', 'ukewo', null, '297e1e874f83129d014f8334eab00298', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '934', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337f9f70748', '市辖区', 'pub', '321101', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '935', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa090749', '京口区', 'pub', '321102', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '936', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa1d074a', '润州区', 'pub', '321111', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '937', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa2b074b', '丹徒区', 'pub', '321112', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '938', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa39074c', '丹阳市', 'pub', '321181', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', '0', '939', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa46074d', '扬中市', 'pub', '321182', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '940', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa54074e', '句容市', 'pub', '321183', 'ukewo', null, '297e1e874f83129d014f8334eaca0299', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '941', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa82074f', '市辖区', 'pub', '321201', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '942', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fa940750', '海陵区', 'pub', '321202', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '943', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337faa10751', '高港区', 'pub', '321203', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '944', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fab00752', '兴化市', 'pub', '321281', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '945', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fabe0753', '靖江市', 'pub', '321282', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '946', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fbfb0754', '泰兴市', 'pub', '321283', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '947', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc080755', '姜堰市', 'pub', '321284', 'ukewo', null, '297e1e874f83129d014f8334eaed029a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '948', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc370756', '市辖区', 'pub', '321301', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '949', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc450757', '宿城区', 'pub', '321302', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '950', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc550758', '宿豫区', 'pub', '321311', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '951', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc640759', '沭阳县', 'pub', '321322', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '952', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc73075a', '泗阳县', 'pub', '321323', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '953', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fc80075b', '泗洪县', 'pub', '321324', 'ukewo', null, '297e1e874f83129d014f8334eb01029b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '954', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fcb3075c', '市辖区', 'pub', '330101', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '955', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fcc4075d', '上城区', 'pub', '330102', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '956', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fcd1075e', '下城区', 'pub', '330103', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '957', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe0e075f', '江干区', 'pub', '330104', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '958', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe1c0760', '拱墅区', 'pub', '330105', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', '0', '959', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe330761', '西湖区', 'pub', '330106', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '960', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe480762', '滨江区', 'pub', '330108', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '961', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe580763', '萧山区', 'pub', '330109', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '962', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe660764', '余杭区', 'pub', '330110', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '963', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe760765', '桐庐县', 'pub', '330122', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '964', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe860766', '淳安县', 'pub', '330127', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '965', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fe990767', '建德市', 'pub', '330182', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '966', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fead0768', '富阳市', 'pub', '330183', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '967', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337febc0769', '临安市', 'pub', '330185', 'ukewo', null, '297e1e874f83129d014f8334eb38029c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '968', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fee3076a', '市辖区', 'pub', '330201', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '969', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337fef4076b', '海曙区', 'pub', '330203', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '970', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ff0c076c', '江东区', 'pub', '330204', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '971', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ff1a076d', '江北区', 'pub', '330205', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '972', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8337ff2e076e', '北仑区', 'pub', '330206', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '973', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380078076f', '镇海区', 'pub', '330211', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '974', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833800860770', '鄞州区', 'pub', '330212', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '975', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338009b0771', '象山县', 'pub', '330225', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '976', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833800a90772', '宁海县', 'pub', '330226', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '977', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833800ba0773', '余姚市', 'pub', '330281', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '978', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833800c90774', '慈溪市', 'pub', '330282', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '979', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833800de0775', '奉化市', 'pub', '330283', 'ukewo', null, '297e1e874f83129d014f8334eb45029d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '980', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338010d0776', '市辖区', 'pub', '330301', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '981', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338011d0777', '鹿城区', 'pub', '330302', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '982', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338012c0778', '龙湾区', 'pub', '330303', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '983', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833801390779', '瓯海区', 'pub', '330304', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '984', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380149077a', '洞头县', 'pub', '330322', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '985', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338015e077b', '永嘉县', 'pub', '330324', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '986', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338016e077c', '平阳县', 'pub', '330326', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '987', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380186077d', '苍南县', 'pub', '330327', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '988', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833801a1077e', '文成县', 'pub', '330328', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '989', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833801ce077f', '泰顺县', 'pub', '330329', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '990', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802050780', '瑞安市', 'pub', '330381', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', '0', '991', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802260781', '乐清市', 'pub', '330382', 'ukewo', null, '297e1e874f83129d014f8334eb53029e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '992', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338026f0782', '市辖区', 'pub', '330401', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '993', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802950783', '秀城区', 'pub', '330402', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '994', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802a70784', '秀洲区', 'pub', '330411', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '995', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802b90785', '嘉善县', 'pub', '330421', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '996', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802ce0786', '海盐县', 'pub', '330424', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '997', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802df0787', '海宁市', 'pub', '330481', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '998', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833802ef0788', '平湖市', 'pub', '330482', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '999', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338042d0789', '桐乡市', 'pub', '330483', 'ukewo', null, '297e1e874f83129d014f8334eb60029f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1000', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380475078a', '市辖区', 'pub', '330501', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1001', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380484078b', '吴兴区', 'pub', '330502', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1002', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380495078c', '南浔区', 'pub', '330503', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1003', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833804a8078d', '德清县', 'pub', '330521', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1004', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833804b9078e', '长兴县', 'pub', '330522', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1005', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833804c7078f', '安吉县', 'pub', '330523', 'ukewo', null, '297e1e874f83129d014f8334eb6e02a0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1006', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805080790', '市辖区', 'pub', '330601', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1007', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805170791', '越城区', 'pub', '330602', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1008', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805260792', '绍兴县', 'pub', '330621', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1009', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805350793', '新昌县', 'pub', '330624', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1010', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805430794', '诸暨市', 'pub', '330681', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1011', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805510795', '上虞市', 'pub', '330682', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1012', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833805600796', '嵊州市', 'pub', '330683', 'ukewo', null, '297e1e874f83129d014f8334eb7d02a1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', '0', '1013', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833806c00797', '市辖区', 'pub', '330701', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1014', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833806d30798', '婺城区', 'pub', '330702', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1015', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833806eb0799', '金东区', 'pub', '330703', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1016', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833806f8079a', '武义县', 'pub', '330723', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1017', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380706079b', '浦江县', 'pub', '330726', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1018', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380715079c', '磐安县', 'pub', '330727', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1019', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380723079d', '兰溪市', 'pub', '330781', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1020', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380733079e', '义乌市', 'pub', '330782', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1021', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338074a079f', '东阳市', 'pub', '330783', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1022', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338075b07a0', '永康市', 'pub', '330784', 'ukewo', null, '297e1e874f83129d014f8334eb8902a2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1023', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338078b07a1', '市辖区', 'pub', '330801', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1024', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338079a07a2', '柯城区', 'pub', '330802', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1025', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833807ac07a3', '衢江区', 'pub', '330803', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1026', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833808ec07a5', '常山县', 'pub', '330822', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1027', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833808fd07a6', '开化县', 'pub', '330824', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1028', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338090b07a7', '龙游县', 'pub', '330825', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1029', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338091a07a8', '江山市', 'pub', '330881', 'ukewo', null, '297e1e874f83129d014f8334eb9902a3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1030', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338094907a9', '市辖区', 'pub', '330901', 'ukewo', null, '297e1e874f83129d014f8334eba502a4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1031', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338095d07aa', '定海区', 'pub', '330902', 'ukewo', null, '297e1e874f83129d014f8334eba502a4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1032', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338096b07ab', '普陀区', 'pub', '330903', 'ukewo', null, '297e1e874f83129d014f8334eba502a4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1033', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338097807ac', '岱山县', 'pub', '330921', 'ukewo', null, '297e1e874f83129d014f8334eba502a4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1034', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338098707ad', '嵊泗县', 'pub', '330922', 'ukewo', null, '297e1e874f83129d014f8334eba502a4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1035', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833809b507ae', '市辖区', 'pub', '331001', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', '0', '1036', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380af407af', '椒江区', 'pub', '331002', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1037', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b0207b0', '黄岩区', 'pub', '331003', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1038', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b1207b1', '路桥区', 'pub', '331004', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1039', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b2107b2', '玉环县', 'pub', '331021', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1040', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b3607b3', '三门县', 'pub', '331022', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1041', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b4507b4', '天台县', 'pub', '331023', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1042', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b5307b5', '仙居县', 'pub', '331024', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1043', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b6307b6', '温岭市', 'pub', '331081', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1044', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380b7107b7', '临海市', 'pub', '331082', 'ukewo', null, '297e1e874f83129d014f8334ebb202a5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1045', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380ba807b8', '市辖区', 'pub', '331101', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1046', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380bb607b9', '莲都区', 'pub', '331102', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1047', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380bcb07ba', '青田县', 'pub', '331121', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1048', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380bdc07bb', '缙云县', 'pub', '331122', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1049', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380beb07bc', '遂昌县', 'pub', '331123', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1050', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380bfa07bd', '松阳县', 'pub', '331124', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1051', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380d3607be', '云和县', 'pub', '331125', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1052', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380d5507bf', '庆元县', 'pub', '331126', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1053', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380d6707c0', '景宁畲族自治县', 'pub', '331127', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1054', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380d7707c1', '龙泉市', 'pub', '331181', 'ukewo', null, '297e1e874f83129d014f8334ebbe02a6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1055', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380dbe07c2', '市辖区', 'pub', '340101', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', '0', '1056', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380dd207c3', '瑶海区', 'pub', '340102', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1057', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380de107c4', '庐阳区', 'pub', '340103', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1058', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380df307c5', '蜀山区', 'pub', '340104', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1059', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e0307c6', '包河区', 'pub', '340111', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1060', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e1307c7', '长丰县', 'pub', '340121', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1061', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e2207c8', '肥东县', 'pub', '340122', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1062', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e3207c9', '肥西县', 'pub', '340123', 'ukewo', null, '297e1e874f83129d014f8334ebe802a7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1063', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e6507ca', '市辖区', 'pub', '340201', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1064', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e7607cb', '镜湖区', 'pub', '340202', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1065', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e8407cc', '马塘区', 'pub', '340203', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1066', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380e9307cd', '新芜区', 'pub', '340204', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1067', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380ea207ce', '鸠江区', 'pub', '340207', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1068', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380fdd07cf', '芜湖县', 'pub', '340221', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1069', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380fea07d0', '繁昌县', 'pub', '340222', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1070', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83380ff807d1', '南陵县', 'pub', '340223', 'ukewo', null, '297e1e874f83129d014f8334ebf602a8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1071', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338102007d2', '市辖区', 'pub', '340301', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1072', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338102d07d3', '龙子湖区', 'pub', '340302', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1073', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338103b07d4', '蚌山区', 'pub', '340303', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1074', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338105507d5', '禹会区', 'pub', '340304', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1075', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338106a07d6', '淮上区', 'pub', '340311', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1076', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338107907d7', '怀远县', 'pub', '340321', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1077', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338108607d8', '五河县', 'pub', '340322', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1078', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338109507d9', '固镇县', 'pub', '340323', 'ukewo', null, '297e1e874f83129d014f8334ed2f02a9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', '0', '1079', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833811ec07da', '市辖区', 'pub', '340401', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1080', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833811f907db', '大通区', 'pub', '340402', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1081', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338120707dc', '田家庵区', 'pub', '340403', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1082', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338121507dd', '谢家集区', 'pub', '340404', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1083', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338122907de', '八公山区', 'pub', '340405', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1084', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338123807df', '潘集区', 'pub', '340406', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1085', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338124607e0', '凤台县', 'pub', '340421', 'ukewo', null, '297e1e874f83129d014f8334ed4302aa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1086', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338127407e1', '市辖区', 'pub', '340501', 'ukewo', null, '297e1e874f83129d014f8334ed5202ab', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1087', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338128207e2', '金家庄区', 'pub', '340502', 'ukewo', null, '297e1e874f83129d014f8334ed5202ab', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1088', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338129107e3', '花山区', 'pub', '340503', 'ukewo', null, '297e1e874f83129d014f8334ed5202ab', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1089', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833812a307e4', '雨山区', 'pub', '340504', 'ukewo', null, '297e1e874f83129d014f8334ed5202ab', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1090', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833812b007e5', '当涂县', 'pub', '340521', 'ukewo', null, '297e1e874f83129d014f8334ed5202ab', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1091', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833812d807e6', '市辖区', 'pub', '340601', 'ukewo', null, '297e1e874f83129d014f8334ed6202ac', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1092', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833812e707e7', '杜集区', 'pub', '340602', 'ukewo', null, '297e1e874f83129d014f8334ed6202ac', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1093', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338142407e8', '相山区', 'pub', '340603', 'ukewo', null, '297e1e874f83129d014f8334ed6202ac', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1094', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338143307e9', '烈山区', 'pub', '340604', 'ukewo', null, '297e1e874f83129d014f8334ed6202ac', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1095', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338144107ea', '濉溪县', 'pub', '340621', 'ukewo', null, '297e1e874f83129d014f8334ed6202ac', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1096', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338146a07eb', '市辖区', 'pub', '340701', 'ukewo', null, '297e1e874f83129d014f8334ed6e02ad', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1097', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338147807ec', '铜官山区', 'pub', '340702', 'ukewo', null, '297e1e874f83129d014f8334ed6e02ad', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1098', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338148607ed', '狮子山区', 'pub', '340703', 'ukewo', null, '297e1e874f83129d014f8334ed6e02ad', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1099', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338149707ee', '郊　区', 'pub', '340711', 'ukewo', null, '297e1e874f83129d014f8334ed6e02ad', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1100', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833814a707ef', '铜陵县', 'pub', '340721', 'ukewo', null, '297e1e874f83129d014f8334ed6e02ad', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1101', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833814d607f0', '市辖区', 'pub', '340801', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1102', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833814e907f1', '迎江区', 'pub', '340802', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1103', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833814f507f2', '大观区', 'pub', '340803', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', '0', '1104', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338163007f3', '郊　区', 'pub', '340811', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1105', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338164007f4', '怀宁县', 'pub', '340822', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1106', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338164e07f5', '枞阳县', 'pub', '340823', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1107', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338165d07f6', '潜山县', 'pub', '340824', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1108', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338166c07f7', '太湖县', 'pub', '340825', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1109', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338167a07f8', '宿松县', 'pub', '340826', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1110', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338168c07f9', '望江县', 'pub', '340827', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1111', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338169c07fa', '岳西县', 'pub', '340828', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1112', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833816ab07fb', '桐城市', 'pub', '340881', 'ukewo', null, '297e1e874f83129d014f8334ed7b02ae', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1113', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833816db07fc', '市辖区', 'pub', '341001', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1114', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833816eb07fd', '屯溪区', 'pub', '341002', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1115', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833816f907fe', '黄山区', 'pub', '341003', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1116', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338170607ff', '徽州区', 'pub', '341004', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1117', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833817160800', '歙　县', 'pub', '341021', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1118', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833817240801', '休宁县', 'pub', '341022', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1119', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833817320802', '黟　县', 'pub', '341023', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1120', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818740803', '祁门县', 'pub', '341024', 'ukewo', null, '297e1e874f83129d014f8334ed8802af', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1121', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818b50804', '市辖区', 'pub', '341101', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1122', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818c30805', '琅琊区', 'pub', '341102', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1123', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818d10806', '南谯区', 'pub', '341103', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1124', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818e10807', '来安县', 'pub', '341122', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1125', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818ee0808', '全椒县', 'pub', '341124', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1126', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833818fe0809', '定远县', 'pub', '341125', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1127', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338190b080a', '凤阳县', 'pub', '341126', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1128', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381919080b', '天长市', 'pub', '341181', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1129', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381928080c', '明光市', 'pub', '341182', 'ukewo', null, '297e1e874f83129d014f8334ed9602b0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', '0', '1130', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381a82080d', '市辖区', 'pub', '341201', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1131', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381a91080e', '颍州区', 'pub', '341202', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1132', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381a9f080f', '颍东区', 'pub', '341203', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1133', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381aad0810', '颍泉区', 'pub', '341204', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1134', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381abd0811', '临泉县', 'pub', '341221', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1135', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ace0812', '太和县', 'pub', '341222', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1136', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381adb0813', '阜南县', 'pub', '341225', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1137', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381aeb0814', '颍上县', 'pub', '341226', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1138', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381af80815', '界首市', 'pub', '341282', 'ukewo', null, '297e1e874f83129d014f8334eda302b1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1139', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381b280816', '市辖区', 'pub', '341301', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1140', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381b3c0817', '墉桥区', 'pub', '341302', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1141', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381b490818', '砀山县', 'pub', '341321', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1142', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381c83081a', '萧　县', 'pub', '341322', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1143', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381c92081b', '灵璧县', 'pub', '341323', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1144', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ca8081c', '泗　县', 'pub', '341324', 'ukewo', null, '297e1e874f83129d014f8334edb402b2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1145', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381cd2081d', '市辖区', 'pub', '341401', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1146', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ce6081e', '居巢区', 'pub', '341402', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1147', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381cf8081f', '庐江县', 'pub', '341421', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1148', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381d0d0820', '无为县', 'pub', '341422', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1149', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381d1f0821', '含山县', 'pub', '341423', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1150', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381d310822', '和　县', 'pub', '341424', 'ukewo', null, '297e1e874f83129d014f8334edc002b3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', '0', '1151', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381e870823', '市辖区', 'pub', '341501', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1152', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381e950824', '金安区', 'pub', '341502', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1153', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ea20825', '裕安区', 'pub', '341503', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1154', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381eb00826', '寿　县', 'pub', '341521', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1155', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ec00827', '霍邱县', 'pub', '341522', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1156', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381ecd0828', '舒城县', 'pub', '341523', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1157', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381edc0829', '金寨县', 'pub', '341524', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1158', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381eea082a', '霍山县', 'pub', '341525', 'ukewo', null, '297e1e874f83129d014f8334edcf02b4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1159', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f1d082b', '市辖区', 'pub', '341601', 'ukewo', null, '297e1e874f83129d014f8334eddb02b5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1160', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f2a082c', '谯城区', 'pub', '341602', 'ukewo', null, '297e1e874f83129d014f8334eddb02b5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1161', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f38082d', '涡阳县', 'pub', '341621', 'ukewo', null, '297e1e874f83129d014f8334eddb02b5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1162', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f47082e', '蒙城县', 'pub', '341622', 'ukewo', null, '297e1e874f83129d014f8334eddb02b5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1163', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f57082f', '利辛县', 'pub', '341623', 'ukewo', null, '297e1e874f83129d014f8334eddb02b5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1164', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83381f840830', '市辖区', 'pub', '341701', 'ukewo', null, '297e1e874f83129d014f8334edee02b6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1165', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833820c70831', '贵池区', 'pub', '341702', 'ukewo', null, '297e1e874f83129d014f8334edee02b6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1166', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833820e30832', '东至县', 'pub', '341721', 'ukewo', null, '297e1e874f83129d014f8334edee02b6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1167', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833820fd0833', '石台县', 'pub', '341722', 'ukewo', null, '297e1e874f83129d014f8334edee02b6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1168', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821170834', '青阳县', 'pub', '341723', 'ukewo', null, '297e1e874f83129d014f8334edee02b6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', '0', '1169', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821590835', '市辖区', 'pub', '341801', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1170', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821700836', '宣州区', 'pub', '341802', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1171', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821840837', '郎溪县', 'pub', '341821', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1172', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821a20838', '广德县', 'pub', '341822', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1173', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821bb0839', '泾　县', 'pub', '341823', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1174', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821d4083a', '绩溪县', 'pub', '341824', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1175', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821ec083b', '旌德县', 'pub', '341825', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1176', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833821fb083c', '宁国市', 'pub', '341881', 'ukewo', null, '297e1e874f83129d014f8334edfb02b7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1177', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382238083d', '市辖区', 'pub', '350101', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1178', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382245083e', '鼓楼区', 'pub', '350102', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1179', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382253083f', '台江区', 'pub', '350103', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1180', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833822640840', '仓山区', 'pub', '350104', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1181', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833822710841', '马尾区', 'pub', '350105', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1182', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833822800842', '晋安区', 'pub', '350111', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1183', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833822930843', '闽侯县', 'pub', '350121', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1184', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833822a10844', '连江县', 'pub', '350122', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1185', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833823dd0845', '罗源县', 'pub', '350123', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1186', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833823ec0846', '闽清县', 'pub', '350124', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1187', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833823fb0847', '永泰县', 'pub', '350125', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1188', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833824080848', '平潭县', 'pub', '350128', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1189', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338241a0849', '福清市', 'pub', '350181', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1190', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382428084a', '长乐市', 'pub', '350182', 'ukewo', null, '297e1e874f83129d014f8334ef4d02b8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1191', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338245d084b', '市辖区', 'pub', '350201', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1192', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338246d084c', '思明区', 'pub', '350203', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1193', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382482084d', '海沧区', 'pub', '350205', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1194', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382492084e', '湖里区', 'pub', '350206', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1195', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833824a5084f', '集美区', 'pub', '350211', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1196', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833824b40850', '同安区', 'pub', '350212', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1197', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833824c30851', '翔安区', 'pub', '350213', 'ukewo', null, '297e1e874f83129d014f8334ef5e02b9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1198', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833824f80852', '市辖区', 'pub', '350301', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', '0', '1199', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826410853', '城厢区', 'pub', '350302', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1200', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826530854', '涵江区', 'pub', '350303', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1201', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826620855', '荔城区', 'pub', '350304', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1202', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826710856', '秀屿区', 'pub', '350305', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1203', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826870857', '仙游县', 'pub', '350322', 'ukewo', null, '297e1e874f83129d014f8334ef6902ba', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1204', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826b80858', '市辖区', 'pub', '350401', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1205', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826c50859', '梅列区', 'pub', '350402', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1206', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826e5085a', '三元区', 'pub', '350403', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1207', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833826f9085b', '明溪县', 'pub', '350421', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1208', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338272c085c', '清流县', 'pub', '350423', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1209', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338273c085d', '宁化县', 'pub', '350424', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1210', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338274d085e', '大田县', 'pub', '350425', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1211', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338275d085f', '尤溪县', 'pub', '350426', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1212', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833827760860', '沙　县', 'pub', '350427', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1213', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338278c0861', '将乐县', 'pub', '350428', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1214', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833827a30862', '泰宁县', 'pub', '350429', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1215', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833827be0863', '建宁县', 'pub', '350430', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1216', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833827d70864', '永安市', 'pub', '350481', 'ukewo', null, '297e1e874f83129d014f8334ef7602bb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1217', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833828270865', '市辖区', 'pub', '350501', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1218', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833828460866', '鲤城区', 'pub', '350502', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1219', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833828780867', '丰泽区', 'pub', '350503', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1220', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338289c0868', '洛江区', 'pub', '350504', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1221', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833828c80869', '泉港区', 'pub', '350505', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1222', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833828ec086a', '惠安县', 'pub', '350521', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1223', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382911086b', '安溪县', 'pub', '350524', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', '0', '1224', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338292b086c', '永春县', 'pub', '350525', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1225', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338293c086d', '德化县', 'pub', '350526', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1226', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338294e086e', '金门县', 'pub', '350527', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1227', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382962086f', '石狮市', 'pub', '350581', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1228', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833829730870', '晋江市', 'pub', '350582', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1229', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833829840871', '南安市', 'pub', '350583', 'ukewo', null, '297e1e874f83129d014f8334ef8202bc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1230', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382ae90872', '市辖区', 'pub', '350601', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1231', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382afe0873', '芗城区', 'pub', '350602', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1232', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b0e0874', '龙文区', 'pub', '350603', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1233', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b260875', '云霄县', 'pub', '350622', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1234', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b3a0876', '漳浦县', 'pub', '350623', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1235', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b490877', '诏安县', 'pub', '350624', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1236', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b590878', '长泰县', 'pub', '350625', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1237', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b680879', '东山县', 'pub', '350626', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1238', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b76087a', '南靖县', 'pub', '350627', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1239', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b85087b', '平和县', 'pub', '350628', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1240', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382b95087c', '华安县', 'pub', '350629', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1241', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382ba6087d', '龙海市', 'pub', '350681', 'ukewo', null, '297e1e874f83129d014f8334ef9002bd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1242', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382bd5087e', '市辖区', 'pub', '350701', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1243', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382be6087f', '延平区', 'pub', '350702', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1244', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382bf50880', '顺昌县', 'pub', '350721', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', '0', '1245', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d330881', '浦城县', 'pub', '350722', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1246', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d470882', '光泽县', 'pub', '350723', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1247', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d590883', '松溪县', 'pub', '350724', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1248', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d660884', '政和县', 'pub', '350725', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1249', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d760885', '邵武市', 'pub', '350781', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1250', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d850886', '武夷山市', 'pub', '350782', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1251', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382d960887', '建瓯市', 'pub', '350783', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1252', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382da40888', '建阳市', 'pub', '350784', 'ukewo', null, '297e1e874f83129d014f8334ef9d02be', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1253', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382dcf0889', '市辖区', 'pub', '350801', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1254', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382de0088a', '新罗区', 'pub', '350802', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1255', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382df7088b', '长汀县', 'pub', '350821', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1256', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382e06088c', '永定县', 'pub', '350822', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1257', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382e14088d', '上杭县', 'pub', '350823', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1258', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382e22088e', '武平县', 'pub', '350824', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1259', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382e30088f', '连城县', 'pub', '350825', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1260', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382e3e0890', '漳平市', 'pub', '350881', 'ukewo', null, '297e1e874f83129d014f8334efa902bf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1261', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382f950891', '市辖区', 'pub', '350901', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1262', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382fa70892', '蕉城区', 'pub', '350902', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1263', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382fb60893', '霞浦县', 'pub', '350921', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1264', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382fc30894', '古田县', 'pub', '350922', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1265', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382fd50895', '屏南县', 'pub', '350923', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1266', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83382fe50896', '寿宁县', 'pub', '350924', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1267', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833830000898', '周宁县', 'pub', '350925', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', '0', '1268', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338313b0899', '柘荣县', 'pub', '350926', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1269', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338314b089a', '福安市', 'pub', '350981', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1270', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338315c089b', '福鼎市', 'pub', '350982', 'ukewo', null, '297e1e874f83129d014f8334efb702c0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1271', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383190089c', '市辖区', 'pub', '360101', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1272', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338319f089d', '东湖区', 'pub', '360102', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1273', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833831b3089e', '西湖区', 'pub', '360103', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1274', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833831c1089f', '青云谱区', 'pub', '360104', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1275', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833831d008a0', '湾里区', 'pub', '360105', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1276', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833831e308a1', '青山湖区', 'pub', '360111', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1277', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833831f208a2', '南昌县', 'pub', '360121', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1278', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338320408a3', '新建县', 'pub', '360122', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1279', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338321208a4', '安义县', 'pub', '360123', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1280', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338322008a5', '进贤县', 'pub', '360124', 'ukewo', null, '297e1e874f83129d014f8334efde02c1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1281', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338324908a6', '市辖区', 'pub', '360201', 'ukewo', null, '297e1e874f83129d014f8334f11902c2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1282', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338338608a7', '昌江区', 'pub', '360202', 'ukewo', null, '297e1e874f83129d014f8334f11902c2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1283', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338339608a8', '珠山区', 'pub', '360203', 'ukewo', null, '297e1e874f83129d014f8334f11902c2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1284', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833833a708a9', '浮梁县', 'pub', '360222', 'ukewo', null, '297e1e874f83129d014f8334f11902c2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1285', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833833b708aa', '乐平市', 'pub', '360281', 'ukewo', null, '297e1e874f83129d014f8334f11902c2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1286', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833833e208ab', '市辖区', 'pub', '360301', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1287', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833833f008ac', '安源区', 'pub', '360302', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1288', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833833fc08ad', '湘东区', 'pub', '360313', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1289', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338340a08ae', '莲花县', 'pub', '360321', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1290', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338341a08af', '上栗县', 'pub', '360322', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1291', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338342a08b0', '芦溪县', 'pub', '360323', 'ukewo', null, '297e1e874f83129d014f8334f12702c3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1292', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833834a408b1', '市辖区', 'pub', '360401', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1293', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833834b308b2', '庐山区', 'pub', '360402', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1294', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833834c308b3', '浔阳区', 'pub', '360403', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1295', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833834d508b4', '九江县', 'pub', '360421', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', '0', '1296', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833834ee08b5', '武宁县', 'pub', '360423', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1297', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338350108b6', '修水县', 'pub', '360424', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1298', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338350e08b7', '永修县', 'pub', '360425', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1299', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338364a08b8', '德安县', 'pub', '360426', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1300', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338365c08b9', '星子县', 'pub', '360427', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1301', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338366d08ba', '都昌县', 'pub', '360428', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1302', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338367b08bb', '湖口县', 'pub', '360429', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1303', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338368c08bc', '彭泽县', 'pub', '360430', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1304', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338369c08bd', '瑞昌市', 'pub', '360481', 'ukewo', null, '297e1e874f83129d014f8334f13602c4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1305', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833836cb08be', '市辖区', 'pub', '360501', 'ukewo', null, '297e1e874f83129d014f8334f14c02c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1306', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833836da08bf', '渝水区', 'pub', '360502', 'ukewo', null, '297e1e874f83129d014f8334f14c02c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1307', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833836e708c0', '分宜县', 'pub', '360521', 'ukewo', null, '297e1e874f83129d014f8334f14c02c5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1308', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338376e08c1', '市辖区', 'pub', '360601', 'ukewo', null, '297e1e874f83129d014f8334f15b02c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1309', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338379608c2', '月湖区', 'pub', '360602', 'ukewo', null, '297e1e874f83129d014f8334f15b02c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1310', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833837a208c3', '余江县', 'pub', '360622', 'ukewo', null, '297e1e874f83129d014f8334f15b02c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1311', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833837b608c4', '贵溪市', 'pub', '360681', 'ukewo', null, '297e1e874f83129d014f8334f15b02c6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1312', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833837dd08c5', '市辖区', 'pub', '360701', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1313', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833837ea08c6', '章贡区', 'pub', '360702', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1314', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338380308c7', '赣　县', 'pub', '360721', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1315', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338381208c8', '信丰县', 'pub', '360722', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1316', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338382008c9', '大余县', 'pub', '360723', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', '0', '1317', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338395d08ca', '上犹县', 'pub', '360724', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1318', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338396c08cb', '崇义县', 'pub', '360725', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1319', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338397f08cc', '安远县', 'pub', '360726', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1320', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338398f08cd', '龙南县', 'pub', '360727', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1321', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338399e08ce', '定南县', 'pub', '360728', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1322', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839ab08cf', '全南县', 'pub', '360729', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1323', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839b808d0', '宁都县', 'pub', '360730', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1324', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839c608d1', '于都县', 'pub', '360731', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1325', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839d308d2', '兴国县', 'pub', '360732', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1326', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839e108d3', '会昌县', 'pub', '360733', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1327', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839ef08d4', '寻乌县', 'pub', '360734', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1328', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833839fe08d5', '石城县', 'pub', '360735', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1329', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383a0b08d6', '瑞金市', 'pub', '360781', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1330', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383a1a08d7', '南康市', 'pub', '360782', 'ukewo', null, '297e1e874f83129d014f8334f16c02c7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1331', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383b7308d8', '市辖区', 'pub', '360801', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1332', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383b8608d9', '吉州区', 'pub', '360802', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1333', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383b9608da', '青原区', 'pub', '360803', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1334', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383bc008db', '吉安县', 'pub', '360821', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1335', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383bcf08dc', '吉水县', 'pub', '360822', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1336', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383bdb08dd', '峡江县', 'pub', '360823', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1337', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383be808de', '新干县', 'pub', '360824', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1338', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383bf508df', '永丰县', 'pub', '360825', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1339', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c0508e0', '泰和县', 'pub', '360826', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1340', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c1308e1', '遂川县', 'pub', '360827', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1341', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c2608e2', '万安县', 'pub', '360828', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1342', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c3608e3', '安福县', 'pub', '360829', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1343', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c4608e4', '永新县', 'pub', '360830', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1344', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c5708e5', '井冈山市', 'pub', '360881', 'ukewo', null, '297e1e874f83129d014f8334f18502c8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1345', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c8608e6', '市辖区', 'pub', '360901', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1346', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383c9708e7', '袁州区', 'pub', '360902', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1347', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383ca408e8', '奉新县', 'pub', '360921', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', '0', '1348', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383cb208e9', '万载县', 'pub', '360922', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1349', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383de908ea', '上高县', 'pub', '360923', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1350', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383df508eb', '宜丰县', 'pub', '360924', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1351', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e0708ec', '靖安县', 'pub', '360925', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1352', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e2108ed', '铜鼓县', 'pub', '360926', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1353', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e2f08ee', '丰城市', 'pub', '360981', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1354', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e3c08ef', '樟树市', 'pub', '360982', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1355', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e4808f0', '高安市', 'pub', '360983', 'ukewo', null, '297e1e874f83129d014f8334f19402c9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1356', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e7208f1', '市辖区', 'pub', '361001', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1357', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e8108f2', '临川区', 'pub', '361002', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1358', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383e8d08f3', '南城县', 'pub', '361021', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1359', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383ea608f4', '黎川县', 'pub', '361022', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1360', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383eef08f5', '南丰县', 'pub', '361023', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1361', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383f0308f6', '崇仁县', 'pub', '361024', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1362', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383f0f08f7', '乐安县', 'pub', '361025', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1363', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383f1b08f8', '宜黄县', 'pub', '361026', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1364', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83383f3208f9', '金溪县', 'pub', '361027', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1365', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338406c08fa', '资溪县', 'pub', '361028', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1366', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338407808fb', '东乡县', 'pub', '361029', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1367', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338408408fc', '广昌县', 'pub', '361030', 'ukewo', null, '297e1e874f83129d014f8334f1a302ca', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', '0', '1368', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840aa08fd', '市辖区', 'pub', '361101', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1369', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840ba08fe', '信州区', 'pub', '361102', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1370', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840c608ff', '上饶县', 'pub', '361121', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1371', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840d10900', '广丰县', 'pub', '361122', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1372', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840de0901', '玉山县', 'pub', '361123', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1373', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840eb0902', '铅山县', 'pub', '361124', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1374', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833840f70903', '横峰县', 'pub', '361125', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1375', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833841030904', '弋阳县', 'pub', '361126', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1376', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338410f0905', '余干县', 'pub', '361127', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1377', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338411c0906', '鄱阳县', 'pub', '361128', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1378', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842550907', '万年县', 'pub', '361129', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1379', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842610908', '婺源县', 'pub', '361130', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1380', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842710909', '德兴市', 'pub', '361181', 'ukewo', null, '297e1e874f83129d014f8334f1b202cb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1381', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384299090a', '市辖区', 'pub', '370101', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1382', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842a7090b', '历下区', 'pub', '370102', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1383', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842b5090c', '市中区', 'pub', '370103', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1384', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842c8090d', '槐荫区', 'pub', '370104', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1385', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842d6090e', '天桥区', 'pub', '370105', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1386', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842e5090f', '历城区', 'pub', '370112', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1387', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842f30910', '长清区', 'pub', '370113', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1388', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833842ff0911', '平阴县', 'pub', '370124', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1389', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338430d0912', '济阳县', 'pub', '370125', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1390', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338431b0913', '商河县', 'pub', '370126', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1391', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844580915', '章丘市', 'pub', '370181', 'ukewo', null, '297e1e874f83129d014f8334f1da02cc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', '0', '1392', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844820916', '市辖区', 'pub', '370201', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1393', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844910917', '市南区', 'pub', '370202', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1394', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844ac0918', '市北区', 'pub', '370203', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1395', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844bc0919', '四方区', 'pub', '370205', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1396', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844c8091a', '黄岛区', 'pub', '370211', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1397', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833844d8091b', '崂山区', 'pub', '370212', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1398', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384533091c', '李沧区', 'pub', '370213', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1399', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384542091d', '城阳区', 'pub', '370214', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1400', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384554091e', '胶州市', 'pub', '370281', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1401', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384564091f', '即墨市', 'pub', '370282', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1402', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833845780920', '平度市', 'pub', '370283', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1403', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833845880921', '胶南市', 'pub', '370284', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1404', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833845a40922', '莱西市', 'pub', '370285', 'ukewo', null, '297e1e874f83129d014f8334f1e902cd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1405', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833845da0923', '市辖区', 'pub', '370301', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1406', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847130924', '淄川区', 'pub', '370302', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1407', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338471f0925', '张店区', 'pub', '370303', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1408', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338472d0926', '博山区', 'pub', '370304', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1409', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847390927', '临淄区', 'pub', '370305', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1410', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847450928', '周村区', 'pub', '370306', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1411', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847530929', '桓台县', 'pub', '370321', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1412', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384761092a', '高青县', 'pub', '370322', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1413', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384773092b', '沂源县', 'pub', '370323', 'ukewo', null, '297e1e874f83129d014f8334f20c02ce', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1414', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338479e092c', '市辖区', 'pub', '370401', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1415', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847ae092d', '市中区', 'pub', '370402', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1416', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847be092e', '薛城区', 'pub', '370403', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1417', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833847cc092f', '峄城区', 'pub', '370404', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', '0', '1418', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338495c0930', '台儿庄区', 'pub', '370405', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1419', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833849920931', '山亭区', 'pub', '370406', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1420', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833849a60932', '滕州市', 'pub', '370481', 'ukewo', null, '297e1e874f83129d014f8334f21e02cf', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1421', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833849d30933', '市辖区', 'pub', '370501', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1422', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833849df0934', '东营区', 'pub', '370502', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1423', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833849f10935', '河口区', 'pub', '370503', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1424', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a020936', '垦利县', 'pub', '370521', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1425', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a110937', '利津县', 'pub', '370522', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1426', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a210938', '广饶县', 'pub', '370523', 'ukewo', null, '297e1e874f83129d014f8334f22d02d0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1427', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a530939', '市辖区', 'pub', '370601', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1428', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a63093a', '芝罘区', 'pub', '370602', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1429', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a73093b', '福山区', 'pub', '370611', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1430', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a80093c', '牟平区', 'pub', '370612', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1431', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a8c093d', '莱山区', 'pub', '370613', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1432', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384a9b093e', '长岛县', 'pub', '370634', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1433', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384aa9093f', '龙口市', 'pub', '370681', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1434', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384ab80940', '莱阳市', 'pub', '370682', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1435', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384ac40941', '莱州市', 'pub', '370683', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1436', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384acf0942', '蓬莱市', 'pub', '370684', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1437', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384ada0943', '招远市', 'pub', '370685', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1438', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c150944', '栖霞市', 'pub', '370686', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1439', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c260945', '海阳市', 'pub', '370687', 'ukewo', null, '297e1e874f83129d014f8334f23d02d1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', '0', '1440', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c640946', '市辖区', 'pub', '370701', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1441', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c740947', '潍城区', 'pub', '370702', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1442', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c8c0948', '寒亭区', 'pub', '370703', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1443', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384c9e0949', '坊子区', 'pub', '370704', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1444', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384cad094a', '奎文区', 'pub', '370705', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1445', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384cc4094b', '临朐县', 'pub', '370724', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1446', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384ce7094c', '昌乐县', 'pub', '370725', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1447', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384cf5094d', '青州市', 'pub', '370781', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1448', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384d1d094e', '诸城市', 'pub', '370782', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1449', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384d2c094f', '寿光市', 'pub', '370783', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1450', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384d3d0950', '安丘市', 'pub', '370784', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1451', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384d4e0951', '高密市', 'pub', '370785', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1452', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384d630952', '昌邑市', 'pub', '370786', 'ukewo', null, '297e1e874f83129d014f8334f37702d2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1453', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384da30953', '市辖区', 'pub', '370801', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1454', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384dc10954', '市中区', 'pub', '370802', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1455', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384ddc0955', '任城区', 'pub', '370811', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1456', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384df90956', '微山县', 'pub', '370826', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1457', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384e1a0957', '鱼台县', 'pub', '370827', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1458', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384e4d0958', '金乡县', 'pub', '370828', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1459', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384e5c0959', '嘉祥县', 'pub', '370829', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1460', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384e6c095a', '汶上县', 'pub', '370830', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1461', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384fa4095b', '泗水县', 'pub', '370831', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1462', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384fb5095c', '梁山县', 'pub', '370832', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1463', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384fc2095d', '曲阜市', 'pub', '370881', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1464', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384fd3095e', '兖州市', 'pub', '370882', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1465', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83384fe5095f', '邹城市', 'pub', '370883', 'ukewo', null, '297e1e874f83129d014f8334f38a02d3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1466', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338500f0960', '市辖区', 'pub', '370901', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1467', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338501c0961', '泰山区', 'pub', '370902', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1468', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850280962', '岱岳区', 'pub', '370903', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', '0', '1469', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850340963', '宁阳县', 'pub', '370921', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1470', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850400964', '东平县', 'pub', '370923', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1471', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850510965', '新泰市', 'pub', '370982', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1472', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850600966', '肥城市', 'pub', '370983', 'ukewo', null, '297e1e874f83129d014f8334f39602d4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1473', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833850910967', '市辖区', 'pub', '371001', 'ukewo', null, '297e1e874f83129d014f8334f3a202d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1474', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338509e0968', '环翠区', 'pub', '371002', 'ukewo', null, '297e1e874f83129d014f8334f3a202d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1475', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833851d70969', '文登市', 'pub', '371081', 'ukewo', null, '297e1e874f83129d014f8334f3a202d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1476', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833851e2096a', '荣成市', 'pub', '371082', 'ukewo', null, '297e1e874f83129d014f8334f3a202d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1477', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833851ee096b', '乳山市', 'pub', '371083', 'ukewo', null, '297e1e874f83129d014f8334f3a202d5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1478', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385214096c', '市辖区', 'pub', '371101', 'ukewo', null, '297e1e874f83129d014f8334f3b002d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1479', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338522c096d', '东港区', 'pub', '371102', 'ukewo', null, '297e1e874f83129d014f8334f3b002d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1480', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338523b096e', '岚山区', 'pub', '371103', 'ukewo', null, '297e1e874f83129d014f8334f3b002d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1481', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385249096f', '五莲县', 'pub', '371121', 'ukewo', null, '297e1e874f83129d014f8334f3b002d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1482', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833852570970', '莒　县', 'pub', '371122', 'ukewo', null, '297e1e874f83129d014f8334f3b002d6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1483', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833852830971', '市辖区', 'pub', '371201', 'ukewo', null, '297e1e874f83129d014f8334f3c302d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1484', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833852940972', '莱城区', 'pub', '371202', 'ukewo', null, '297e1e874f83129d014f8334f3c302d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1485', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833852ae0973', '钢城区', 'pub', '371203', 'ukewo', null, '297e1e874f83129d014f8334f3c302d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1486', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338540b0974', '市辖区', 'pub', '371301', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', '0', '1487', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338541a0975', '兰山区', 'pub', '371302', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1488', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338542a0976', '罗庄区', 'pub', '371311', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1489', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854380977', '河东区', 'pub', '371312', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1490', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854470978', '沂南县', 'pub', '371321', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1491', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854550979', '郯城县', 'pub', '371322', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1492', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385462097a', '沂水县', 'pub', '371323', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1493', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385473097b', '苍山县', 'pub', '371324', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1494', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385481097c', '费　县', 'pub', '371325', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1495', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385490097d', '平邑县', 'pub', '371326', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1496', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854a1097e', '莒南县', 'pub', '371327', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1497', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854b0097f', '蒙阴县', 'pub', '371328', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1498', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854be0980', '临沭县', 'pub', '371329', 'ukewo', null, '297e1e874f83129d014f8334f3d202d8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1499', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833854eb0981', '市辖区', 'pub', '371401', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1500', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856400982', '德城区', 'pub', '371402', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1501', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856510983', '陵　县', 'pub', '371421', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1502', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338565d0984', '宁津县', 'pub', '371422', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1503', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856850985', '庆云县', 'pub', '371423', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1504', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856be0986', '临邑县', 'pub', '371424', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1505', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856cc0987', '齐河县', 'pub', '371425', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1506', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856db0988', '平原县', 'pub', '371426', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1507', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856e80989', '夏津县', 'pub', '371427', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1508', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833856fa098a', '武城县', 'pub', '371428', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1509', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385708098c', '乐陵市', 'pub', '371481', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1510', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385714098d', '禹城市', 'pub', '371482', 'ukewo', null, '297e1e874f83129d014f8334f3dd02d9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1511', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338573f098e', '市辖区', 'pub', '371501', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1512', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385750098f', '东昌府区', 'pub', '371502', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1513', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338575d0990', '阳谷县', 'pub', '371521', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', '0', '1514', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338589c0991', '莘　县', 'pub', '371522', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1515', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833858aa0992', '茌平县', 'pub', '371523', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1516', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833858b90993', '东阿县', 'pub', '371524', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1517', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833858c80994', '冠　县', 'pub', '371525', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1518', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833858d70995', '高唐县', 'pub', '371526', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1519', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833858ec0996', '临清市', 'pub', '371581', 'ukewo', null, '297e1e874f83129d014f8334f3ec02da', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1520', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859230997', '市辖区', 'pub', '371601', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1521', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859410998', '滨城区', 'pub', '371602', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1522', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859600999', '惠民县', 'pub', '371621', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1523', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385993099a', '阳信县', 'pub', '371622', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1524', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859b3099b', '无棣县', 'pub', '371623', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1525', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859cd099c', '沾化县', 'pub', '371624', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1526', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859e8099d', '博兴县', 'pub', '371625', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1527', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833859fa099e', '邹平县', 'pub', '371626', 'ukewo', null, '297e1e874f83129d014f8334f3fb02db', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1528', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a2f099f', '市辖区', 'pub', '371701', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1529', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a3c09a0', '牡丹区', 'pub', '371702', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1530', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a4a09a1', '曹　县', 'pub', '371721', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1531', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a5609a2', '单　县', 'pub', '371722', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1532', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a6609a3', '成武县', 'pub', '371723', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1533', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385a7409a4', '巨野县', 'pub', '371724', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1534', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385bb309a5', '郓城县', 'pub', '371725', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1535', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385bc109a6', '鄄城县', 'pub', '371726', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1536', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385bd209a7', '定陶县', 'pub', '371727', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1537', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385be709a8', '东明县', 'pub', '371728', 'ukewo', null, '297e1e874f83129d014f8334f40802dc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', '0', '1538', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385c1209a9', '市辖区', 'pub', '410101', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1539', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385c1f09aa', '中原区', 'pub', '410102', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1540', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385c2e09ab', '二七区', 'pub', '410103', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1541', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385c3b09ac', '管城回族区', 'pub', '410104', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1542', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385c4c09ad', '金水区', 'pub', '410105', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1543', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385cb009ae', '上街区', 'pub', '410106', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1544', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385cd909af', '邙山区', 'pub', '410108', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1545', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385cf909b0', '中牟县', 'pub', '410122', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1546', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d0709b1', '巩义市', 'pub', '410181', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1547', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d1409b2', '荥阳市', 'pub', '410182', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1548', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d2109b3', '新密市', 'pub', '410183', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1549', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d2e09b4', '新郑市', 'pub', '410184', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1550', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d4309b5', '登封市', 'pub', '410185', 'ukewo', null, '297e1e874f83129d014f8334f43002dd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1551', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d6909b6', '市辖区', 'pub', '410201', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1552', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d7709b7', '龙亭区', 'pub', '410202', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1553', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385d8309b8', '顺河回族区', 'pub', '410203', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1554', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385ebb09b9', '鼓楼区', 'pub', '410204', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1555', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385ec709ba', '南关区', 'pub', '410205', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1556', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385ed409bb', '郊　区', 'pub', '410211', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1557', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385ee409bc', '杞　县', 'pub', '410221', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1558', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385f1009bd', '通许县', 'pub', '410222', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1559', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385f1f09be', '尉氏县', 'pub', '410223', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1560', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385f2d09bf', '开封县', 'pub', '410224', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1561', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385f3a09c0', '兰考县', 'pub', '410225', 'ukewo', null, '297e1e874f83129d014f8334f56b02de', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1562', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385f6c09c1', '市辖区', 'pub', '410301', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1563', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385fcc09c2', '老城区', 'pub', '410302', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', '0', '1564', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385fda09c3', '西工区', 'pub', '410303', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1565', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385fe709c4', '廛河回族区', 'pub', '410304', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1566', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83385ffa09c5', '涧西区', 'pub', '410305', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1567', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338600b09c6', '吉利区', 'pub', '410306', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1568', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338601b09c7', '洛龙区', 'pub', '410307', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1569', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338602a09c8', '孟津县', 'pub', '410322', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1570', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338603809c9', '新安县', 'pub', '410323', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1571', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338604809ca', '栾川县', 'pub', '410324', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1572', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338605609cb', '嵩　县', 'pub', '410325', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1573', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338619009cc', '汝阳县', 'pub', '410326', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1574', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338619d09cd', '宜阳县', 'pub', '410327', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1575', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833861a909ce', '洛宁县', 'pub', '410328', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1576', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833861b509cf', '伊川县', 'pub', '410329', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1577', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833861c209d0', '偃师市', 'pub', '410381', 'ukewo', null, '297e1e874f83129d014f8334f57a02df', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1578', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833861e809d1', '市辖区', 'pub', '410401', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1579', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833861f609d2', '新华区', 'pub', '410402', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1580', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338620209d3', '卫东区', 'pub', '410403', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1581', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338620f09d4', '石龙区', 'pub', '410404', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1582', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338621d09d5', '湛河区', 'pub', '410411', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1583', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338622e09d6', '宝丰县', 'pub', '410421', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1584', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338624009d7', '叶　县', 'pub', '410422', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1585', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338626509d8', '鲁山县', 'pub', '410423', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1586', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833863a209d9', '郏　县', 'pub', '410425', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1587', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833863af09da', '舞钢市', 'pub', '410481', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', '0', '1588', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833863c009db', '汝州市', 'pub', '410482', 'ukewo', null, '297e1e874f83129d014f8334f59902e0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1589', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833863e909dc', '市辖区', 'pub', '410501', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1590', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833863f509dd', '文峰区', 'pub', '410502', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1591', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338640209de', '北关区', 'pub', '410503', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1592', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338640f09df', '殷都区', 'pub', '410505', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1593', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338641d09e0', '龙安区', 'pub', '410506', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1594', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338642c09e1', '安阳县', 'pub', '410522', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1595', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338643e09e2', '汤阴县', 'pub', '410523', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1596', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338645009e3', '滑　县', 'pub', '410526', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1597', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338645c09e4', '内黄县', 'pub', '410527', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1598', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338646809e5', '林州市', 'pub', '410581', 'ukewo', null, '297e1e874f83129d014f8334f5a902e1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1599', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338649b09e6', '市辖区', 'pub', '410601', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1600', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833865d609e7', '鹤山区', 'pub', '410602', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1601', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338661109e8', '山城区', 'pub', '410603', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1602', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338663d09e9', '淇滨区', 'pub', '410611', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1603', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338664b09ea', '浚　县', 'pub', '410621', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1604', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338665a09eb', '淇　县', 'pub', '410622', 'ukewo', null, '297e1e874f83129d014f8334f5b602e2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1605', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338668309ec', '市辖区', 'pub', '410701', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1606', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338668f09ed', '红旗区', 'pub', '410702', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1607', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338669c09ee', '卫滨区', 'pub', '410703', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1608', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866a809ef', '凤泉区', 'pub', '410704', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1609', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866b409f0', '牧野区', 'pub', '410711', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1610', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866c109f1', '新乡县', 'pub', '410721', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1611', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866d109f2', '获嘉县', 'pub', '410724', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1612', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866de09f3', '原阳县', 'pub', '410725', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1613', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866e909f4', '延津县', 'pub', '410726', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1614', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833866f709f5', '封丘县', 'pub', '410727', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1615', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338670209f6', '长垣县', 'pub', '410728', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', '0', '1616', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338683b09f7', '卫辉市', 'pub', '410781', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1617', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338684709f8', '辉县市', 'pub', '410782', 'ukewo', null, '297e1e874f83129d014f8334f5c602e3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1618', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338686c09f9', '市辖区', 'pub', '410801', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1619', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338687809fa', '解放区', 'pub', '410802', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1620', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338688509fb', '中站区', 'pub', '410803', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1621', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338689609fc', '马村区', 'pub', '410804', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1622', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833869d209fd', '山阳区', 'pub', '410811', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1623', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833869df09fe', '修武县', 'pub', '410821', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1624', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833869ee09ff', '博爱县', 'pub', '410822', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1625', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833869fb0a00', '武陟县', 'pub', '410823', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1626', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a070a01', '温　县', 'pub', '410825', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1627', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a150a02', '济源市', 'pub', '410881', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1628', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a270a03', '沁阳市', 'pub', '410882', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1629', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a3a0a04', '孟州市', 'pub', '410883', 'ukewo', null, '297e1e874f83129d014f8334f5d202e4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1630', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a620a05', '市辖区', 'pub', '410901', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1631', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a730a06', '华龙区', 'pub', '410902', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1632', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386a820a08', '清丰县', 'pub', '410922', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', '0', '1633', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386bc60a09', '南乐县', 'pub', '410923', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1634', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386bd60a0a', '范　县', 'pub', '410926', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1635', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386be60a0b', '台前县', 'pub', '410927', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1636', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386bf50a0c', '濮阳县', 'pub', '410928', 'ukewo', null, '297e1e874f83129d014f8334f5e202e5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1637', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386c350a0d', '市辖区', 'pub', '411001', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1638', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386c680a0e', '魏都区', 'pub', '411002', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1639', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386c810a0f', '许昌县', 'pub', '411023', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1640', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386c9c0a10', '鄢陵县', 'pub', '411024', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1641', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386cac0a11', '襄城县', 'pub', '411025', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1642', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386cc40a12', '禹州市', 'pub', '411081', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1643', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386cd90a13', '长葛市', 'pub', '411082', 'ukewo', null, '297e1e874f83129d014f8334f5ef02e6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1644', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d040a14', '市辖区', 'pub', '411101', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1645', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d130a15', '源汇区', 'pub', '411102', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1646', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d1f0a16', '郾城区', 'pub', '411103', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1647', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d310a17', '召陵区', 'pub', '411104', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1648', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d400a18', '舞阳县', 'pub', '411121', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1649', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386d510a19', '临颍县', 'pub', '411122', 'ukewo', null, '297e1e874f83129d014f8334f5fb02e7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1650', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386ea70a1a', '市辖区', 'pub', '411201', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1651', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386ebc0a1b', '湖滨区', 'pub', '411202', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1652', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386ec80a1c', '渑池县', 'pub', '411221', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1653', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386edb0a1d', '陕　县', 'pub', '411222', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1654', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386eeb0a1e', '卢氏县', 'pub', '411224', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1655', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386ef80a1f', '义马市', 'pub', '411281', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1656', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f100a20', '灵宝市', 'pub', '411282', 'ukewo', null, '297e1e874f83129d014f8334f60902e8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1657', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f390a21', '市辖区', 'pub', '411301', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1658', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f5a0a22', '宛城区', 'pub', '411302', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1659', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f690a23', '卧龙区', 'pub', '411303', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', '0', '1660', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f770a24', '南召县', 'pub', '411321', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1661', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f870a25', '方城县', 'pub', '411322', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1662', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386f950a26', '西峡县', 'pub', '411323', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1663', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83386fc10a27', '镇平县', 'pub', '411324', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1664', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870150a28', '内乡县', 'pub', '411325', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1665', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870310a29', '淅川县', 'pub', '411326', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1666', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870430a2a', '社旗县', 'pub', '411327', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1667', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870520a2b', '唐河县', 'pub', '411328', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1668', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870630a2c', '新野县', 'pub', '411329', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1669', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833870720a2d', '桐柏县', 'pub', '411330', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1670', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833871ab0a2e', '邓州市', 'pub', '411381', 'ukewo', null, '297e1e874f83129d014f8334f61802e9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1671', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833871d70a2f', '市辖区', 'pub', '411401', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1672', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833871e80a30', '梁园区', 'pub', '411402', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1673', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833871f60a31', '睢阳区', 'pub', '411403', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1674', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872090a32', '民权县', 'pub', '411421', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1675', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872290a33', '睢　县', 'pub', '411422', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1676', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872390a34', '宁陵县', 'pub', '411423', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1677', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338724b0a35', '柘城县', 'pub', '411424', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1678', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338725b0a36', '虞城县', 'pub', '411425', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1679', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872690a37', '夏邑县', 'pub', '411426', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1680', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338727b0a38', '永城市', 'pub', '411481', 'ukewo', null, '297e1e874f83129d014f8334f62802ea', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1681', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872a80a39', '市辖区', 'pub', '411501', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1682', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872bd0a3a', '师河区', 'pub', '411502', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1683', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833872cb0a3b', '平桥区', 'pub', '411503', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', '0', '1684', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874100a3c', '罗山县', 'pub', '411521', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1685', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874200a3d', '光山县', 'pub', '411522', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1686', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874410a3e', '新　县', 'pub', '411523', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1687', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874520a3f', '商城县', 'pub', '411524', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1688', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338746a0a40', '固始县', 'pub', '411525', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1689', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874830a41', '潢川县', 'pub', '411526', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1690', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874930a42', '淮滨县', 'pub', '411527', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1691', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338749f0a43', '息　县', 'pub', '411528', 'ukewo', null, '297e1e874f83129d014f8334f63402eb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1692', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874c60a44', '市辖区', 'pub', '411601', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1693', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874dd0a45', '川汇区', 'pub', '411602', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1694', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874ee0a46', '扶沟县', 'pub', '411621', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1695', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833874fb0a47', '西华县', 'pub', '411622', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1696', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833875120a48', '商水县', 'pub', '411623', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1697', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833875210a49', '沈丘县', 'pub', '411624', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1698', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338752e0a4a', '郸城县', 'pub', '411625', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1699', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833875400a4b', '淮阳县', 'pub', '411626', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1700', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833875570a4c', '太康县', 'pub', '411627', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1701', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338756c0a4d', '鹿邑县', 'pub', '411628', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1702', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833875800a4e', '项城市', 'pub', '411681', 'ukewo', null, '297e1e874f83129d014f8334f64202ec', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1703', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833876d70a4f', '市辖区', 'pub', '411701', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1704', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833876e80a50', '驿城区', 'pub', '411702', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1705', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833876f50a51', '西平县', 'pub', '411721', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1706', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877010a52', '上蔡县', 'pub', '411722', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1707', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877120a53', '平舆县', 'pub', '411723', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1708', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877240a54', '正阳县', 'pub', '411724', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1709', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877330a55', '确山县', 'pub', '411725', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', '0', '1710', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877410a56', '泌阳县', 'pub', '411726', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1711', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338774f0a57', '汝南县', 'pub', '411727', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1712', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338775c0a58', '遂平县', 'pub', '411728', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1713', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338776a0a59', '新蔡县', 'pub', '411729', 'ukewo', null, '297e1e874f83129d014f8334f65102ed', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1714', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877920a5a', '市辖区', 'pub', '420101', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1715', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338779d0a5b', '江岸区', 'pub', '420102', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1716', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833877a90a5c', '江汉区', 'pub', '420103', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1717', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833878e90a5d', '乔口区', 'pub', '420104', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1718', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833878f70a5e', '汉阳区', 'pub', '420105', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1719', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879080a5f', '武昌区', 'pub', '420106', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1720', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879130a60', '青山区', 'pub', '420107', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1721', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338791f0a61', '洪山区', 'pub', '420111', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1722', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338792b0a62', '东西湖区', 'pub', '420112', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1723', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879390a63', '汉南区', 'pub', '420113', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1724', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879490a64', '蔡甸区', 'pub', '420114', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1725', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879590a65', '江夏区', 'pub', '420115', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1726', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879670a66', '黄陂区', 'pub', '420116', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1727', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879740a67', '新洲区', 'pub', '420117', 'ukewo', null, '297e1e874f83129d014f8334f7a802ee', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1728', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338799a0a68', '市辖区', 'pub', '420201', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1729', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833879a70a69', '黄石港区', 'pub', '420202', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1730', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387ae70a6a', '西塞山区', 'pub', '420203', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1731', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387af30a6b', '下陆区', 'pub', '420204', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1732', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387afe0a6c', '铁山区', 'pub', '420205', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1733', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b0e0a6d', '阳新县', 'pub', '420222', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1734', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b1a0a6e', '大冶市', 'pub', '420281', 'ukewo', null, '297e1e874f83129d014f8334f7c902ef', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', '0', '1735', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b4e0a6f', '市辖区', 'pub', '420301', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1736', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b5d0a70', '茅箭区', 'pub', '420302', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1737', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b6a0a71', '张湾区', 'pub', '420303', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1738', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b760a72', '郧　县', 'pub', '420321', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1739', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b840a73', '郧西县', 'pub', '420322', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1740', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b920a74', '竹山县', 'pub', '420323', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1741', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387b9e0a75', '竹溪县', 'pub', '420324', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1742', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387baf0a76', '房　县', 'pub', '420325', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1743', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387ce70a77', '丹江口市', 'pub', '420381', 'ukewo', null, '297e1e874f83129d014f8334f7ee02f0', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1744', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d0d0a78', '市辖区', 'pub', '420501', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1745', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d190a79', '西陵区', 'pub', '420502', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1746', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d250a7a', '伍家岗区', 'pub', '420503', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1747', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d330a7b', '点军区', 'pub', '420504', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1748', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d3f0a7c', '猇亭区', 'pub', '420505', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1749', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d4e0a7d', '夷陵区', 'pub', '420506', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1750', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d5c0a7e', '远安县', 'pub', '420525', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1751', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d6c0a7f', '兴山县', 'pub', '420526', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1752', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d780a80', '秭归县', 'pub', '420527', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1753', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d830a81', '长阳土家族自治县', 'pub', '420528', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1754', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387d8f0a82', '五峰土家族自治县', 'pub', '420529', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1755', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387da00a83', '宜都市', 'pub', '420581', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1756', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387eda0a85', '当阳市', 'pub', '420582', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1757', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387eeb0a86', '枝江市', 'pub', '420583', 'ukewo', null, '297e1e874f83129d014f8334f7fd02f1', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', '0', '1758', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387f110a87', '市辖区', 'pub', '420601', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1759', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387f1d0a88', '襄城区', 'pub', '420602', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1760', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387f2a0a89', '樊城区', 'pub', '420606', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1761', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387f380a8a', '襄阳区', 'pub', '420607', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1762', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83387f440a8b', '南漳县', 'pub', '420624', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1763', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880820a8c', '谷城县', 'pub', '420625', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1764', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338808f0a8d', '保康县', 'pub', '420626', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1765', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338809b0a8e', '老河口市', 'pub', '420682', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1766', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880a80a8f', '枣阳市', 'pub', '420683', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1767', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880b30a90', '宜城市', 'pub', '420684', 'ukewo', null, '297e1e874f83129d014f8334f80b02f2', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1768', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880dc0a91', '市辖区', 'pub', '420701', 'ukewo', null, '297e1e874f83129d014f8334f81a02f3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1769', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880ec0a92', '梁子湖区', 'pub', '420702', 'ukewo', null, '297e1e874f83129d014f8334f81a02f3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1770', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833880f90a93', '华容区', 'pub', '420703', 'ukewo', null, '297e1e874f83129d014f8334f81a02f3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1771', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833881060a94', '鄂城区', 'pub', '420704', 'ukewo', null, '297e1e874f83129d014f8334f81a02f3', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1772', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833881320a95', '市辖区', 'pub', '420801', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1773', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338813f0a96', '东宝区', 'pub', '420802', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1774', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882780a97', '掇刀区', 'pub', '420804', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1775', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882840a98', '京山县', 'pub', '420821', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1776', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882910a99', '沙洋县', 'pub', '420822', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1777', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338829c0a9a', '钟祥市', 'pub', '420881', 'ukewo', null, '297e1e874f83129d014f8334f82702f4', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1778', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882cb0a9b', '市辖区', 'pub', '420901', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1779', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882db0a9c', '孝南区', 'pub', '420902', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1780', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882eb0a9d', '孝昌县', 'pub', '420921', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1781', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833882f70a9e', '大悟县', 'pub', '420922', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', '0', '1782', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833883050a9f', '云梦县', 'pub', '420923', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1783', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833883130aa0', '应城市', 'pub', '420981', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1784', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833883260aa1', '安陆市', 'pub', '420982', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1785', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833883360aa2', '汉川市', 'pub', '420984', 'ukewo', null, '297e1e874f83129d014f8334f83502f5', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1786', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338835d0aa3', '市辖区', 'pub', '421001', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1787', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338836b0aa4', '沙市区', 'pub', '421002', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1788', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884a30aa5', '荆州区', 'pub', '421003', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1789', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884b00aa6', '公安县', 'pub', '421022', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1790', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884bb0aa7', '监利县', 'pub', '421023', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1791', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884c60aa8', '江陵县', 'pub', '421024', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1792', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884d10aa9', '石首市', 'pub', '421081', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1793', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884dd0aaa', '洪湖市', 'pub', '421083', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1794', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833884eb0aab', '松滋市', 'pub', '421087', 'ukewo', null, '297e1e874f83129d014f8334f84302f6', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1795', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833885110aac', '市辖区', 'pub', '421101', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1796', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338851c0aad', '黄州区', 'pub', '421102', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1797', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833885280aae', '团风县', 'pub', '421121', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1798', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886600aaf', '红安县', 'pub', '421122', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1799', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338866c0ab0', '罗田县', 'pub', '421123', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1800', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886790ab1', '英山县', 'pub', '421124', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1801', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886850ab2', '浠水县', 'pub', '421125', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1802', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886920ab3', '蕲春县', 'pub', '421126', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1803', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338869e0ab4', '黄梅县', 'pub', '421127', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1804', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886a90ab5', '麻城市', 'pub', '421181', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1805', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886b40ab6', '武穴市', 'pub', '421182', 'ukewo', null, '297e1e874f83129d014f8334f85b02f7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1806', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886dc0ab7', '市辖区', 'pub', '421201', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', '0', '1807', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886e60ab8', '咸安区', 'pub', '421202', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1808', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833886f20ab9', '嘉鱼县', 'pub', '421221', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1809', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833887000aba', '通城县', 'pub', '421222', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1810', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338870f0abb', '崇阳县', 'pub', '421223', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1811', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888480abc', '通山县', 'pub', '421224', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1812', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888530abd', '赤壁市', 'pub', '421281', 'ukewo', null, '297e1e874f83129d014f8334f87102f8', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1813', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888790abe', '市辖区', 'pub', '421301', 'ukewo', null, '297e1e874f83129d014f8334f88002f9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1814', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888850abf', '曾都区', 'pub', '421302', 'ukewo', null, '297e1e874f83129d014f8334f88002f9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1815', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888920ac0', '广水市', 'pub', '421381', 'ukewo', null, '297e1e874f83129d014f8334f88002f9', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1816', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888b90ac1', '恩施市', 'pub', '422801', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1817', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888c40ac2', '利川市', 'pub', '422802', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1818', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888cf0ac3', '建始县', 'pub', '422822', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1819', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888da0ac4', '巴东县', 'pub', '422823', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1820', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888e60ac5', '宣恩县', 'pub', '422825', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1821', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833888f30ac6', '咸丰县', 'pub', '422826', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1822', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a2e0ac7', '来凤县', 'pub', '422827', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1823', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a3a0ac8', '鹤峰县', 'pub', '422828', 'ukewo', null, '297e1e874f83129d014f8334f89202fa', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1824', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a5f0ac9', '仙桃市', 'pub', '429004', 'ukewo', null, '297e1e874f83129d014f8334f89f02fb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1825', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a6a0aca', '潜江市', 'pub', '429005', 'ukewo', null, '297e1e874f83129d014f8334f89f02fb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1826', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a760acb', '天门市', 'pub', '429006', 'ukewo', null, '297e1e874f83129d014f8334f89f02fb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1827', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388a830acc', '神农架林区', 'pub', '429021', 'ukewo', null, '297e1e874f83129d014f8334f89f02fb', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1828', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388aa70acd', '市辖区', 'pub', '430101', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1829', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388ab20ace', '芙蓉区', 'pub', '430102', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1830', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388abd0acf', '天心区', 'pub', '430103', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1831', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388ac70ad0', '岳麓区', 'pub', '430104', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', '0', '1832', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388ad20ad1', '开福区', 'pub', '430105', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1833', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c0b0ad2', '雨花区', 'pub', '430111', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1834', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c160ad3', '长沙县', 'pub', '430121', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1835', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c250ad4', '望城县', 'pub', '430122', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1836', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c320ad5', '宁乡县', 'pub', '430124', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1837', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c3e0ad6', '浏阳市', 'pub', '430181', 'ukewo', null, '297e1e874f83129d014f8334f8d802fc', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1838', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c660ad7', '市辖区', 'pub', '430201', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1839', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c740ad8', '荷塘区', 'pub', '430202', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1840', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c830ad9', '芦淞区', 'pub', '430203', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1841', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c900ada', '石峰区', 'pub', '430204', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1842', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388c9c0adb', '天元区', 'pub', '430211', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1843', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388caa0adc', '株洲县', 'pub', '430221', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1844', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388cb50add', '攸　县', 'pub', '430223', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1845', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388cc20ade', '茶陵县', 'pub', '430224', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1846', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388dfa0adf', '炎陵县', 'pub', '430225', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1847', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e090ae0', '醴陵市', 'pub', '430281', 'ukewo', null, '297e1e874f83129d014f8334f8f902fd', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1848', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e2b0ae1', '市辖区', 'pub', '430301', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1849', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e360ae2', '雨湖区', 'pub', '430302', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1850', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e410ae3', '岳塘区', 'pub', '430304', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1851', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e4d0ae4', '湘潭县', 'pub', '430321', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1852', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e570ae5', '湘乡市', 'pub', '430381', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1853', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388e640ae6', '韶山市', 'pub', '430382', 'ukewo', null, '297e1e874f83129d014f8334fa3e02fe', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', '0', '1854', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fb50ae7', '市辖区', 'pub', '430401', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1855', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fc00ae8', '珠晖区', 'pub', '430405', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1856', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fcd0ae9', '雁峰区', 'pub', '430406', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1857', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fda0aea', '石鼓区', 'pub', '430407', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1858', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fe60aeb', '蒸湘区', 'pub', '430408', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1859', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388ff30aec', '南岳区', 'pub', '430412', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1860', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83388fff0aed', '衡阳县', 'pub', '430421', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1861', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338900d0aee', '衡南县', 'pub', '430422', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1862', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338901a0aef', '衡山县', 'pub', '430423', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1863', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833890260af0', '衡东县', 'pub', '430424', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1864', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833890370af1', '祁东县', 'pub', '430426', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1865', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833890430af2', '耒阳市', 'pub', '430481', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1866', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338904e0af3', '常宁市', 'pub', '430482', 'ukewo', null, '297e1e874f83129d014f8334fa5b02ff', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1867', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891a20af5', '市辖区', 'pub', '430501', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1868', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891ae0af6', '双清区', 'pub', '430502', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1869', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891c30af7', '大祥区', 'pub', '430503', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1870', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891d10af8', '北塔区', 'pub', '430511', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1871', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891e10af9', '邵东县', 'pub', '430521', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1872', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891f00afa', '新邵县', 'pub', '430522', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1873', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833891fb0afb', '邵阳县', 'pub', '430523', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1874', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833892070afc', '隆回县', 'pub', '430524', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1875', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833892130afd', '洞口县', 'pub', '430525', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1876', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833892200afe', '绥宁县', 'pub', '430527', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1877', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833892310aff', '新宁县', 'pub', '430528', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1878', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338923d0b00', '城步苗族自治县', 'pub', '430529', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', '0', '1879', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893760b01', '武冈市', 'pub', '430581', 'ukewo', null, '297e1e874f83129d014f8334fa6c0300', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1880', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338939e0b02', '市辖区', 'pub', '430601', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1881', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893aa0b03', '岳阳楼区', 'pub', '430602', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1882', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893ba0b04', '云溪区', 'pub', '430603', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1883', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893c70b05', '君山区', 'pub', '430611', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1884', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893d80b06', '岳阳县', 'pub', '430621', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1885', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893e40b07', '华容县', 'pub', '430623', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1886', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893ef0b08', '湘阴县', 'pub', '430624', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1887', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833893fb0b09', '平江县', 'pub', '430626', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1888', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833894080b0a', '汨罗市', 'pub', '430681', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1889', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833894150b0b', '临湘市', 'pub', '430682', 'ukewo', null, '297e1e874f83129d014f8334fa840301', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1890', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338956d0b0c', '市辖区', 'pub', '430701', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1891', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895780b0d', '武陵区', 'pub', '430702', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1892', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895860b0e', '鼎城区', 'pub', '430703', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1893', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895930b0f', '安乡县', 'pub', '430721', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1894', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895a10b10', '汉寿县', 'pub', '430722', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1895', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895ae0b11', '澧　县', 'pub', '430723', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1896', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895b90b12', '临澧县', 'pub', '430724', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1897', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895c70b13', '桃源县', 'pub', '430725', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1898', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895d70b14', '石门县', 'pub', '430726', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1899', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833895e20b15', '津市市', 'pub', '430781', 'ukewo', null, '297e1e874f83129d014f8334fa950302', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1900', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833896090b16', '市辖区', 'pub', '430801', 'ukewo', null, '297e1e874f83129d014f8334fac00303', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1901', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833896160b17', '永定区', 'pub', '430802', 'ukewo', null, '297e1e874f83129d014f8334fac00303', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1902', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833896250b18', '武陵源区', 'pub', '430811', 'ukewo', null, '297e1e874f83129d014f8334fac00303', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', '0', '1903', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338975e0b19', '慈利县', 'pub', '430821', 'ukewo', null, '297e1e874f83129d014f8334fac00303', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1904', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897690b1a', '桑植县', 'pub', '430822', 'ukewo', null, '297e1e874f83129d014f8334fac00303', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1905', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338978f0b1b', '市辖区', 'pub', '430901', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1906', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338979b0b1c', '资阳区', 'pub', '430902', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1907', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897a60b1d', '赫山区', 'pub', '430903', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1908', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897b40b1e', '南　县', 'pub', '430921', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1909', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897bf0b1f', '桃江县', 'pub', '430922', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1910', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897cb0b20', '安化县', 'pub', '430923', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1911', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833897d60b21', '沅江市', 'pub', '430981', 'ukewo', null, '297e1e874f83129d014f8334fafb0304', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1912', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899280b22', '市辖区', 'pub', '431001', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1913', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899370b23', '北湖区', 'pub', '431002', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1914', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899430b24', '苏仙区', 'pub', '431003', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1915', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899530b25', '桂阳县', 'pub', '431021', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1916', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899600b26', '宜章县', 'pub', '431022', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1917', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338996e0b27', '永兴县', 'pub', '431023', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1918', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338997c0b28', '嘉禾县', 'pub', '431024', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1919', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899870b29', '临武县', 'pub', '431025', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1920', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899950b2a', '汝城县', 'pub', '431026', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1921', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899a10b2b', '桂东县', 'pub', '431027', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1922', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899ae0b2c', '安仁县', 'pub', '431028', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1923', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833899bf0b2d', '资兴市', 'pub', '431081', 'ukewo', null, '297e1e874f83129d014f8334fb1b0305', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', '0', '1924', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b1b0b2e', '市辖区', 'pub', '431101', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1925', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b280b2f', '芝山区', 'pub', '431102', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1926', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b390b30', '冷水滩区', 'pub', '431103', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1927', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b450b31', '祁阳县', 'pub', '431121', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1928', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b530b32', '东安县', 'pub', '431122', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1929', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b670b33', '双牌县', 'pub', '431123', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1930', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b800b34', '道　县', 'pub', '431124', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1931', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389b8f0b35', '江永县', 'pub', '431125', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1932', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389ba40b36', '宁远县', 'pub', '431126', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1933', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389bb90b37', '蓝山县', 'pub', '431127', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1934', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389bc80b38', '新田县', 'pub', '431128', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1935', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389bd70b39', '江华瑶族自治县', 'pub', '431129', 'ukewo', null, '297e1e874f83129d014f8334fb3d0306', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1936', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389bff0b3a', '市辖区', 'pub', '431201', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1937', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389c0e0b3b', '鹤城区', 'pub', '431202', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1938', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389c1d0b3c', '中方县', 'pub', '431221', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1939', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389c2c0b3d', '沅陵县', 'pub', '431222', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1940', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389d640b3e', '辰溪县', 'pub', '431223', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1941', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389d710b3f', '溆浦县', 'pub', '431224', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1942', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389d7d0b40', '会同县', 'pub', '431225', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1943', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389d890b41', '麻阳苗族自治县', 'pub', '431226', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1944', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389d9c0b42', '新晃侗族自治县', 'pub', '431227', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1945', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389daa0b43', '芷江侗族自治县', 'pub', '431228', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1946', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389db90b44', '靖州苗族侗族自治县', 'pub', '431229', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1947', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389dc60b45', '通道侗族自治县', 'pub', '431230', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1948', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389dd20b46', '洪江市', 'pub', '431281', 'ukewo', null, '297e1e874f83129d014f8334fb5d0307', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1949', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389dfc0b47', '市辖区', 'pub', '431301', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1950', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389e0d0b48', '娄星区', 'pub', '431302', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1951', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389e1a0b49', '双峰县', 'pub', '431321', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1952', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389e260b4a', '新化县', 'pub', '431322', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', '0', '1953', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389f7a0b4b', '冷水江市', 'pub', '431381', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1954', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389f880b4c', '涟源市', 'pub', '431382', 'ukewo', null, '297e1e874f83129d014f8334fb800308', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1955', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389fb40b4d', '吉首市', 'pub', '433101', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1956', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389fc10b4e', '泸溪县', 'pub', '433122', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1957', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389fcd0b4f', '凤凰县', 'pub', '433123', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1958', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389fdb0b50', '花垣县', 'pub', '433124', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1959', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389fe80b51', '保靖县', 'pub', '433125', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1960', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83389ff50b52', '古丈县', 'pub', '433126', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1961', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a0020b53', '永顺县', 'pub', '433127', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1962', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a00e0b54', '龙山县', 'pub', '433130', 'ukewo', null, '297e1e874f83129d014f8334fb9f030a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1963', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a0380b55', '市辖区', 'pub', '440101', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1964', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a0440b56', '东山区', 'pub', '440102', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1965', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a0500b57', '荔湾区', 'pub', '440103', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1966', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a05c0b58', '越秀区', 'pub', '440104', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1967', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1980b59', '海珠区', 'pub', '440105', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1968', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1a40b5a', '天河区', 'pub', '440106', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1969', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1b30b5b', '芳村区', 'pub', '440107', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1970', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1c30b5c', '白云区', 'pub', '440111', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1971', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1cf0b5d', '黄埔区', 'pub', '440112', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1972', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1da0b5e', '番禺区', 'pub', '440113', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1973', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1e60b5f', '花都区', 'pub', '440114', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1974', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a1f40b60', '增城市', 'pub', '440183', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1975', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a2050b61', '从化市', 'pub', '440184', 'ukewo', null, '297e1e874f83129d014f8334fbf4030b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', '0', '1976', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a2380b62', '市辖区', 'pub', '440201', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1977', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a24c0b63', '武江区', 'pub', '440203', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1978', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a25a0b64', '浈江区', 'pub', '440204', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1979', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a2670b65', '曲江区', 'pub', '440205', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1980', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a39f0b66', '始兴县', 'pub', '440222', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1981', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3ab0b67', '仁化县', 'pub', '440224', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1982', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3ba0b68', '翁源县', 'pub', '440229', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1983', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3c80b69', '乳源瑶族自治县', 'pub', '440232', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1984', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3d50b6a', '新丰县', 'pub', '440233', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1985', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3e30b6b', '乐昌市', 'pub', '440281', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1986', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a3f20b6c', '南雄市', 'pub', '440282', 'ukewo', null, '297e1e874f83129d014f8334fc0d030c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1987', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a41f0b6d', '市辖区', 'pub', '440301', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1988', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a42d0b6e', '罗湖区', 'pub', '440303', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1989', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a43e0b6f', '福田区', 'pub', '440304', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1990', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a44d0b70', '南山区', 'pub', '440305', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1991', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a45c0b71', '宝安区', 'pub', '440306', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1992', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a5960b73', '龙岗区', 'pub', '440307', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1993', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a5a60b74', '盐田区', 'pub', '440308', 'ukewo', null, '297e1e874f83129d014f8334fc35030d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1994', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a5d50b75', '市辖区', 'pub', '440401', 'ukewo', null, '297e1e874f83129d014f8334fc4d030e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1995', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a5e80b76', '香洲区', 'pub', '440402', 'ukewo', null, '297e1e874f83129d014f8334fc4d030e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1996', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a5f50b77', '斗门区', 'pub', '440403', 'ukewo', null, '297e1e874f83129d014f8334fc4d030e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1997', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a6090b78', '金湾区', 'pub', '440404', 'ukewo', null, '297e1e874f83129d014f8334fc4d030e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', '0', '1998', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a6360b79', '市辖区', 'pub', '440501', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '1999', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a6430b7a', '龙湖区', 'pub', '440507', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2000', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a6550b7b', '金平区', 'pub', '440511', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2001', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a7910b7c', '濠江区', 'pub', '440512', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2002', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a79f0b7d', '潮阳区', 'pub', '440513', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2003', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a7ad0b7e', '潮南区', 'pub', '440514', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2004', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a7be0b7f', '澄海区', 'pub', '440515', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2005', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a7cc0b80', '南澳县', 'pub', '440523', 'ukewo', null, '297e1e874f83129d014f8334fc64030f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2006', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a7f50b81', '市辖区', 'pub', '440601', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2007', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a8060b82', '禅城区', 'pub', '440604', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2008', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a8140b83', '南海区', 'pub', '440605', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2009', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a8230b84', '顺德区', 'pub', '440606', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2010', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a8300b85', '三水区', 'pub', '440607', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2011', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a8420b86', '高明区', 'pub', '440608', 'ukewo', null, '297e1e874f83129d014f8334fc830310', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2012', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a86e0b87', '市辖区', 'pub', '440701', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2013', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a87e0b88', '蓬江区', 'pub', '440703', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2014', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a88b0b89', '江海区', 'pub', '440704', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2015', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a9c40b8a', '新会区', 'pub', '440705', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2016', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a9d20b8b', '台山市', 'pub', '440781', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2017', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a9df0b8c', '开平市', 'pub', '440783', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2018', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a9ec0b8d', '鹤山市', 'pub', '440784', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2019', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338a9f90b8e', '恩平市', 'pub', '440785', 'ukewo', null, '297e1e874f83129d014f8334fca40311', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', '0', '2020', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa1c0b8f', '市辖区', 'pub', '440801', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2021', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa290b90', '赤坎区', 'pub', '440802', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2022', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa350b91', '霞山区', 'pub', '440803', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2023', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa470b92', '坡头区', 'pub', '440804', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2024', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa540b93', '麻章区', 'pub', '440811', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2025', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa650b94', '遂溪县', 'pub', '440823', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2026', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa740b95', '徐闻县', 'pub', '440825', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2027', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aa840b96', '廉江市', 'pub', '440881', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2028', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338abc10b97', '雷州市', 'pub', '440882', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2029', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338abcd0b98', '吴川市', 'pub', '440883', 'ukewo', null, '297e1e874f83129d014f8334fcc10312', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2030', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac400b99', '市辖区', 'pub', '440901', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2031', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac4f0b9a', '茂南区', 'pub', '440902', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2032', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac5e0b9b', '茂港区', 'pub', '440903', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2033', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac6b0b9c', '电白县', 'pub', '440923', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2034', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac7a0b9d', '高州市', 'pub', '440981', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2035', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac8c0b9e', '化州市', 'pub', '440982', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2036', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ac980b9f', '信宜市', 'pub', '440983', 'ukewo', null, '297e1e874f83129d014f8334fcdb0313', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2037', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338acbd0ba0', '市辖区', 'pub', '441201', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2038', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338acc90ba1', '端州区', 'pub', '441202', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2039', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338acd50ba2', '鼎湖区', 'pub', '441203', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2040', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ace10ba3', '广宁县', 'pub', '441223', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2041', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338acf00ba4', '怀集县', 'pub', '441224', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', '0', '2042', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae290ba5', '封开县', 'pub', '441225', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2043', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae350ba6', '德庆县', 'pub', '441226', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2044', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae410ba7', '高要市', 'pub', '441283', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2045', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae4e0ba8', '四会市', 'pub', '441284', 'ukewo', null, '297e1e874f83129d014f8334fceb0314', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2046', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae760ba9', '市辖区', 'pub', '441301', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2047', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae830baa', '惠城区', 'pub', '441302', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2048', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae900bab', '惠阳区', 'pub', '441303', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2049', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ae9b0bac', '博罗县', 'pub', '441322', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2050', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aeaa0bad', '惠东县', 'pub', '441323', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2051', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aeb90bae', '龙门县', 'pub', '441324', 'ukewo', null, '297e1e874f83129d014f8334fd140315', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2052', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338aee00baf', '市辖区', 'pub', '441401', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2053', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b01a0bb0', '梅江区', 'pub', '441402', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2054', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0270bb1', '梅　县', 'pub', '441421', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2055', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0340bb2', '大埔县', 'pub', '441422', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2056', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0440bb3', '丰顺县', 'pub', '441423', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2057', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0510bb4', '五华县', 'pub', '441424', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2058', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b05f0bb5', '平远县', 'pub', '441426', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2059', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b06c0bb6', '蕉岭县', 'pub', '441427', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2060', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0780bb7', '兴宁市', 'pub', '441481', 'ukewo', null, '297e1e874f83129d014f8334fd2f0316', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2061', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b09f0bb8', '市辖区', 'pub', '441501', 'ukewo', null, '297e1e874f83129d014f8334fd4d0317', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2062', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0af0bb9', '城　区', 'pub', '441502', 'ukewo', null, '297e1e874f83129d014f8334fd4d0317', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2063', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0bc0bba', '海丰县', 'pub', '441521', 'ukewo', null, '297e1e874f83129d014f8334fd4d0317', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2064', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0ce0bbb', '陆河县', 'pub', '441523', 'ukewo', null, '297e1e874f83129d014f8334fd4d0317', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2065', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b0dc0bbc', '陆丰市', 'pub', '441581', 'ukewo', null, '297e1e874f83129d014f8334fd4d0317', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', '0', '2066', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b22e0bbd', '市辖区', 'pub', '441601', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2067', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b23c0bbe', '源城区', 'pub', '441602', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2068', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2490bbf', '紫金县', 'pub', '441621', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2069', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2560bc0', '龙川县', 'pub', '441622', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2070', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2620bc1', '连平县', 'pub', '441623', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2071', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2700bc2', '和平县', 'pub', '441624', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2072', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b27c0bc3', '东源县', 'pub', '441625', 'ukewo', null, '297e1e874f83129d014f8334fd650318', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2073', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2a90bc4', '市辖区', 'pub', '441701', 'ukewo', null, '297e1e874f83129d014f8334fd7b0319', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2074', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2b50bc5', '江城区', 'pub', '441702', 'ukewo', null, '297e1e874f83129d014f8334fd7b0319', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2075', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2c20bc6', '阳西县', 'pub', '441721', 'ukewo', null, '297e1e874f83129d014f8334fd7b0319', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2076', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b2ce0bc7', '阳东县', 'pub', '441723', 'ukewo', null, '297e1e874f83129d014f8334fd7b0319', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2077', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4070bc8', '阳春市', 'pub', '441781', 'ukewo', null, '297e1e874f83129d014f8334fd7b0319', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2078', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4320bc9', '市辖区', 'pub', '441801', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2079', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b43e0bca', '清城区', 'pub', '441802', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2080', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b44f0bcb', '佛冈县', 'pub', '441821', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2081', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b45b0bcc', '阳山县', 'pub', '441823', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2082', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4690bcd', '连山壮族瑶族自治县', 'pub', '441825', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2083', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4750bce', '连南瑶族自治县', 'pub', '441826', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2084', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4810bcf', '清新县', 'pub', '441827', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2085', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b48d0bd0', '英德市', 'pub', '441881', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2086', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b49a0bd1', '连州市', 'pub', '441882', 'ukewo', null, '297e1e874f83129d014f8334fda2031a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2087', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b4c00bd2', '市辖区', 'pub', '445101', 'ukewo', null, '297e1e874f83129d014f8334fde1031d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', '0', '2088', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b5f90bd3', '湘桥区', 'pub', '445102', 'ukewo', null, '297e1e874f83129d014f8334fde1031d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2089', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6050bd4', '潮安县', 'pub', '445121', 'ukewo', null, '297e1e874f83129d014f8334fde1031d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2090', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6130bd5', '饶平县', 'pub', '445122', 'ukewo', null, '297e1e874f83129d014f8334fde1031d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2091', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b63b0bd6', '市辖区', 'pub', '445201', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2092', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6470bd7', '榕城区', 'pub', '445202', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2093', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6540bd8', '揭东县', 'pub', '445221', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2094', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6600bd9', '揭西县', 'pub', '445222', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2095', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b66e0bda', '惠来县', 'pub', '445224', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2096', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6790bdb', '普宁市', 'pub', '445281', 'ukewo', null, '297e1e874f83129d014f8334fdf3031e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2097', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b69d0bdc', '市辖区', 'pub', '445301', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2098', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b6aa0bdd', '云城区', 'pub', '445302', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2099', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b7e60bde', '新兴县', 'pub', '445321', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2100', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b7f30bdf', '郁南县', 'pub', '445322', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2101', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8010be0', '云安县', 'pub', '445323', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2102', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b80f0be1', '罗定市', 'pub', '445381', 'ukewo', null, '297e1e874f83129d014f8334fe01031f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2103', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8370be2', '市辖区', 'pub', '450101', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2104', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b84d0be3', '兴宁区', 'pub', '450102', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2105', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b85b0be4', '青秀区', 'pub', '450103', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2106', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8700be5', '江南区', 'pub', '450105', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2107', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8800be6', '西乡塘区', 'pub', '450107', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2108', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8910be7', '良庆区', 'pub', '450108', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2109', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b8a00be9', '邕宁区', 'pub', '450109', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', '0', '2110', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b9de0bea', '武鸣县', 'pub', '450122', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2111', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b9eb0beb', '隆安县', 'pub', '450123', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2112', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338b9fb0bec', '马山县', 'pub', '450124', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2113', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba080bed', '上林县', 'pub', '450125', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2114', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba160bee', '宾阳县', 'pub', '450126', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2115', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba240bef', '横　县', 'pub', '450127', 'ukewo', null, '297e1e874f83129d014f8334ff530320', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2116', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba4d0bf0', '市辖区', 'pub', '450201', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2117', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba5b0bf1', '城中区', 'pub', '450202', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2118', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba6d0bf2', '鱼峰区', 'pub', '450203', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2119', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba790bf3', '柳南区', 'pub', '450204', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2120', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba860bf4', '柳北区', 'pub', '450205', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2121', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ba960bf5', '柳江县', 'pub', '450221', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2122', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338baa40bf6', '柳城县', 'pub', '450222', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2123', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bbe70bf7', '鹿寨县', 'pub', '450223', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2124', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bbf40bf8', '融安县', 'pub', '450224', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2125', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc010bf9', '融水苗族自治县', 'pub', '450225', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2126', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc0d0bfa', '三江侗族自治县', 'pub', '450226', 'ukewo', null, '297e1e874f83129d014f8334ff630321', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2127', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc320bfb', '市辖区', 'pub', '450301', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2128', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc3f0bfc', '秀峰区', 'pub', '450302', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2129', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc500bfd', '叠彩区', 'pub', '450303', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2130', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc5c0bfe', '象山区', 'pub', '450304', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2131', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc690bff', '七星区', 'pub', '450305', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2132', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc780c00', '雁山区', 'pub', '450311', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2133', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc840c01', '阳朔县', 'pub', '450321', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2134', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bc920c02', '临桂县', 'pub', '450322', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2135', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bca00c03', '灵川县', 'pub', '450323', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', '0', '2136', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bdda0c04', '全州县', 'pub', '450324', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2137', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bdec0c05', '兴安县', 'pub', '450325', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2138', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bdf80c06', '永福县', 'pub', '450326', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2139', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be040c07', '灌阳县', 'pub', '450327', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2140', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be140c08', '龙胜各族自治县', 'pub', '450328', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2141', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be210c09', '资源县', 'pub', '450329', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2142', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be310c0a', '平乐县', 'pub', '450330', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2143', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be3d0c0b', '荔蒲县', 'pub', '450331', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2144', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be530c0c', '恭城瑶族自治县', 'pub', '450332', 'ukewo', null, '297e1e874f83129d014f8334ff6f0322', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2145', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be7a0c0d', '市辖区', 'pub', '450401', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2146', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be8a0c0e', '万秀区', 'pub', '450403', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2147', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338be980c0f', '蝶山区', 'pub', '450404', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2148', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bea40c10', '长洲区', 'pub', '450405', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2149', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338beb00c11', '苍梧县', 'pub', '450421', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2150', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bebf0c12', '藤　县', 'pub', '450422', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2151', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338bece0c13', '蒙山县', 'pub', '450423', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2152', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0080c14', '岑溪市', 'pub', '450481', 'ukewo', null, '297e1e874f83129d014f8334ff7c0323', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2153', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0300c15', '市辖区', 'pub', '450501', 'ukewo', null, '297e1e874f83129d014f8334ff890324', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2154', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c03c0c16', '海城区', 'pub', '450502', 'ukewo', null, '297e1e874f83129d014f8334ff890324', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2155', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0490c17', '银海区', 'pub', '450503', 'ukewo', null, '297e1e874f83129d014f8334ff890324', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2156', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0550c18', '铁山港区', 'pub', '450512', 'ukewo', null, '297e1e874f83129d014f8334ff890324', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2157', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0650c19', '合浦县', 'pub', '450521', 'ukewo', null, '297e1e874f83129d014f8334ff890324', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2158', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0920c1a', '市辖区', 'pub', '450601', 'ukewo', null, '297e1e874f83129d014f8334ff970325', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2159', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c09f0c1b', '港口区', 'pub', '450602', 'ukewo', null, '297e1e874f83129d014f8334ff970325', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2160', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0ac0c1c', '防城区', 'pub', '450603', 'ukewo', null, '297e1e874f83129d014f8334ff970325', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2161', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0bd0c1d', '上思县', 'pub', '450621', 'ukewo', null, '297e1e874f83129d014f8334ff970325', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2162', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c0cf0c1e', '东兴市', 'pub', '450681', 'ukewo', null, '297e1e874f83129d014f8334ff970325', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', '0', '2163', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2290c1f', '市辖区', 'pub', '450701', 'ukewo', null, '297e1e874f83129d014f8334ffa50326', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2164', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c23e0c20', '钦南区', 'pub', '450702', 'ukewo', null, '297e1e874f83129d014f8334ffa50326', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2165', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c24b0c21', '钦北区', 'pub', '450703', 'ukewo', null, '297e1e874f83129d014f8334ffa50326', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2166', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c25b0c22', '灵山县', 'pub', '450721', 'ukewo', null, '297e1e874f83129d014f8334ffa50326', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2167', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c26c0c23', '浦北县', 'pub', '450722', 'ukewo', null, '297e1e874f83129d014f8334ffa50326', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2168', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2950c24', '市辖区', 'pub', '450801', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2169', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2a30c25', '港北区', 'pub', '450802', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2170', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2b10c26', '港南区', 'pub', '450803', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2171', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2c50c27', '覃塘区', 'pub', '450804', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2172', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2d70c28', '平南县', 'pub', '450821', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2173', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c2e80c29', '桂平市', 'pub', '450881', 'ukewo', null, '297e1e874f83129d014f8334ffb30327', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2174', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c31b0c2a', '市辖区', 'pub', '450901', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2175', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c45c0c2b', '玉州区', 'pub', '450902', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2176', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c46b0c2c', '容　县', 'pub', '450921', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2177', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4880c2d', '陆川县', 'pub', '450922', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2178', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4980c2e', '博白县', 'pub', '450923', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2179', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4ab0c2f', '兴业县', 'pub', '450924', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2180', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4b90c30', '北流市', 'pub', '450981', 'ukewo', null, '297e1e874f83129d014f8334ffbf0328', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2181', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4ea0c31', '市辖区', 'pub', '451001', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2182', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c4fe0c32', '右江区', 'pub', '451002', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2183', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c5100c33', '田阳县', 'pub', '451021', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2184', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c51f0c34', '田东县', 'pub', '451022', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2185', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c52e0c35', '平果县', 'pub', '451023', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2186', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c53e0c36', '德保县', 'pub', '451024', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2187', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c54e0c37', '靖西县', 'pub', '451025', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2188', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c55e0c38', '那坡县', 'pub', '451026', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', '0', '2189', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c56f0c39', '凌云县', 'pub', '451027', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2190', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c57b0c3a', '乐业县', 'pub', '451028', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2191', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c6b50c3b', '田林县', 'pub', '451029', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2192', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c6c60c3c', '西林县', 'pub', '451030', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2193', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c6d70c3d', '隆林各族自治县', 'pub', '451031', 'ukewo', null, '297e1e874f83129d014f8334ffce0329', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2194', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7050c3e', '市辖区', 'pub', '451101', 'ukewo', null, '297e1e874f83129d014f8334ffda032a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2195', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7160c3f', '八步区', 'pub', '451102', 'ukewo', null, '297e1e874f83129d014f8334ffda032a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2196', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7280c40', '昭平县', 'pub', '451121', 'ukewo', null, '297e1e874f83129d014f8334ffda032a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2197', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7340c41', '钟山县', 'pub', '451122', 'ukewo', null, '297e1e874f83129d014f8334ffda032a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2198', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7470c42', '富川瑶族自治县', 'pub', '451123', 'ukewo', null, '297e1e874f83129d014f8334ffda032a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2199', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c76e0c43', '市辖区', 'pub', '451201', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2200', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7800c44', '金城江区', 'pub', '451202', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2201', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c7950c45', '南丹县', 'pub', '451221', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2202', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c8d40c46', '天峨县', 'pub', '451222', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2203', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c8e70c47', '凤山县', 'pub', '451223', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2204', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c8f40c48', '东兰县', 'pub', '451224', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2205', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9060c49', '罗城仫佬族自治县', 'pub', '451225', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2206', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c91e0c4a', '环江毛南族自治县', 'pub', '451226', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2207', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c92e0c4b', '巴马瑶族自治县', 'pub', '451227', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2208', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c93d0c4c', '都安瑶族自治县', 'pub', '451228', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', '0', '2209', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9520c4d', '大化瑶族自治县', 'pub', '451229', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2210', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9670c4e', '宜州市', 'pub', '451281', 'ukewo', null, '297e1e874f83129d014f8334ffe8032b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2211', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9910c4f', '市辖区', 'pub', '451301', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2212', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c99d0c50', '兴宾区', 'pub', '451302', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2213', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9aa0c51', '忻城县', 'pub', '451321', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2214', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9bb0c52', '象州县', 'pub', '451322', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2215', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9ce0c53', '武宣县', 'pub', '451323', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2216', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338c9db0c54', '金秀瑶族自治县', 'pub', '451324', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2217', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb190c55', '合山市', 'pub', '451381', 'ukewo', null, '297e1e874f83129d014f8334fff6032c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2218', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb480c56', '市辖区', 'pub', '451401', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2219', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb5f0c57', '江洲区', 'pub', '451402', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2220', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb6d0c58', '扶绥县', 'pub', '451421', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2221', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb7b0c59', '宁明县', 'pub', '451422', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2222', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cb920c5a', '龙州县', 'pub', '451423', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2223', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cba10c5b', '大新县', 'pub', '451424', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2224', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cbb00c5c', '天等县', 'pub', '451425', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2225', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cbc70c5d', '凭祥市', 'pub', '451481', 'ukewo', null, '297e1e874f83129d014f83350136032d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2226', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cbf40c5e', '市辖区', 'pub', '460101', 'ukewo', null, '297e1e874f83129d014f8335015b032e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2227', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cc040c5f', '秀英区', 'pub', '460105', 'ukewo', null, '297e1e874f83129d014f8335015b032e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2228', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cc140c60', '龙华区', 'pub', '460106', 'ukewo', null, '297e1e874f83129d014f8335015b032e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2229', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cc260c61', '琼山区', 'pub', '460107', 'ukewo', null, '297e1e874f83129d014f8335015b032e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2230', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cc370c63', '美兰区', 'pub', '460108', 'ukewo', null, '297e1e874f83129d014f8335015b032e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', '0', '2231', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cd950c64', '市辖区', 'pub', '460201', 'ukewo', null, '297e1e874f83129d014f83350167032f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2232', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cdc70c65', '五指山市', 'pub', '469001', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2233', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cdd70c66', '琼海市', 'pub', '469002', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2234', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cdef0c67', '儋州市', 'pub', '469003', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2235', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce000c68', '文昌市', 'pub', '469005', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2236', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce0e0c69', '万宁市', 'pub', '469006', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2237', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce230c6a', '东方市', 'pub', '469007', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2238', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce3c0c6b', '定安县', 'pub', '469025', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2239', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce4b0c6c', '屯昌县', 'pub', '469026', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2240', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce5b0c6d', '澄迈县', 'pub', '469027', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2241', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce6e0c6e', '临高县', 'pub', '469028', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2242', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ce7c0c6f', '白沙黎族自治县', 'pub', '469030', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2243', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cfbb0c70', '昌江黎族自治县', 'pub', '469031', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2244', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cfcc0c71', '乐东黎族自治县', 'pub', '469033', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2245', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cfdb0c72', '陵水黎族自治县', 'pub', '469034', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2246', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cfeb0c73', '保亭黎族苗族自治县', 'pub', '469035', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2247', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338cffe0c74', '琼中黎族苗族自治县', 'pub', '469036', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2248', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0160c75', '西沙群岛', 'pub', '469037', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2249', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0250c76', '南沙群岛', 'pub', '469038', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2250', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0360c77', '中沙群岛的岛礁及其海域', 'pub', '469039', 'ukewo', null, '297e1e874f83129d014f833501740330', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2251', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0640c78', '万州区', 'pub', '500101', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2252', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0710c79', '涪陵区', 'pub', '500102', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2253', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0800c7a', '渝中区', 'pub', '500103', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2254', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d08f0c7b', '大渡口区', 'pub', '500104', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2255', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d09d0c7c', '江北区', 'pub', '500105', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2256', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0ac0c7d', '沙坪坝区', 'pub', '500106', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2257', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0be0c7e', '九龙坡区', 'pub', '500107', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2258', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d0cd0c7f', '南岸区', 'pub', '500108', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', '0', '2259', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d20a0c80', '北碚区', 'pub', '500109', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2260', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d21c0c81', '万盛区', 'pub', '500110', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2261', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2330c82', '双桥区', 'pub', '500111', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2262', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2400c83', '渝北区', 'pub', '500112', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2263', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d24d0c84', '巴南区', 'pub', '500113', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2264', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d25c0c85', '黔江区', 'pub', '500114', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2265', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2710c86', '长寿区', 'pub', '500115', 'ukewo', null, '297e1e874f83129d014f833501a30331', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2266', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2a70c87', '綦江县', 'pub', '500222', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2267', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2b80c88', '潼南县', 'pub', '500223', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2268', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2c80c89', '铜梁县', 'pub', '500224', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2269', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2d60c8a', '大足县', 'pub', '500225', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2270', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2e80c8b', '荣昌县', 'pub', '500226', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2271', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d2fa0c8c', '璧山县', 'pub', '500227', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2272', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d3080c8d', '梁平县', 'pub', '500228', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2273', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d3140c8e', '城口县', 'pub', '500229', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2274', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d3200c8f', '丰都县', 'pub', '500230', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2275', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4580c90', '垫江县', 'pub', '500231', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2276', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4640c91', '武隆县', 'pub', '500232', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2277', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4700c92', '忠　县', 'pub', '500233', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2278', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d47e0c93', '开　县', 'pub', '500234', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2279', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d48d0c94', '云阳县', 'pub', '500235', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2280', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d49b0c95', '奉节县', 'pub', '500236', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2281', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4b90c96', '巫山县', 'pub', '500237', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2282', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4ca0c97', '巫溪县', 'pub', '500238', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2283', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4db0c98', '石柱土家族自治县', 'pub', '500240', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2284', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4e80c99', '秀山土家族苗族自治县', 'pub', '500241', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2285', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d4f60c9a', '酉阳土家族苗族自治县', 'pub', '500242', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', '0', '2286', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d5030c9b', '彭水苗族土家族自治县', 'pub', '500243', 'ukewo', null, '297e1e874f83129d014f833501b20332', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2287', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d52b0c9c', '江津市', 'pub', '500381', 'ukewo', null, '297e1e874f83129d014f833501c00333', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2288', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6690c9d', '合川市', 'pub', '500382', 'ukewo', null, '297e1e874f83129d014f833501c00333', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2289', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6770c9e', '永川市', 'pub', '500383', 'ukewo', null, '297e1e874f83129d014f833501c00333', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2290', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6850c9f', '南川市', 'pub', '500384', 'ukewo', null, '297e1e874f83129d014f833501c00333', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2291', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6b20ca0', '市辖区', 'pub', '510101', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2292', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6c20ca1', '锦江区', 'pub', '510104', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2293', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6d00ca2', '青羊区', 'pub', '510105', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2294', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6dd0ca3', '金牛区', 'pub', '510106', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2295', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6ec0ca4', '武侯区', 'pub', '510107', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2296', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d6f80ca5', '成华区', 'pub', '510108', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2297', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d7060ca6', '龙泉驿区', 'pub', '510112', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2298', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d7140ca7', '青白江区', 'pub', '510113', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2299', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d7210ca8', '新都区', 'pub', '510114', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2300', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d7340ca9', '温江县', 'pub', '510115', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2301', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d86e0caa', '金堂县', 'pub', '510121', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2302', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d87c0cab', '双流县', 'pub', '510122', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2303', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d88e0cac', '郫　县', 'pub', '510124', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2304', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d89b0cad', '大邑县', 'pub', '510129', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2305', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8a70cae', '蒲江县', 'pub', '510131', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2306', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8b40caf', '新津县', 'pub', '510132', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2307', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8bf0cb0', '都江堰市', 'pub', '510181', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2308', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8cc0cb1', '彭州市', 'pub', '510182', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2309', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8db0cb2', '邛崃市', 'pub', '510183', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', '0', '2310', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d8ea0cb3', '崇州市', 'pub', '510184', 'ukewo', null, '297e1e874f83129d014f833503160334', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2311', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d9120cb4', '市辖区', 'pub', '510301', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2312', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338d9200cb5', '自流井区', 'pub', '510302', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2313', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338da5b0cb6', '贡井区', 'pub', '510303', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2314', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338da670cb7', '大安区', 'pub', '510304', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2315', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338da740cb8', '沿滩区', 'pub', '510311', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2316', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338da840cb9', '荣　县', 'pub', '510321', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2317', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338da920cba', '富顺县', 'pub', '510322', 'ukewo', null, '297e1e874f83129d014f8335032b0335', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2318', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dab90cbb', '市辖区', 'pub', '510401', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2319', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dac50cbc', '东　区', 'pub', '510402', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2320', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dad10cbd', '西　区', 'pub', '510403', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2321', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dadd0cbe', '仁和区', 'pub', '510411', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2322', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dae80cbf', '米易县', 'pub', '510421', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2323', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338daf50cc0', '盐边县', 'pub', '510422', 'ukewo', null, '297e1e874f83129d014f8335033a0336', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2324', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338db1b0cc1', '市辖区', 'pub', '510501', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2325', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dc560cc2', '江阳区', 'pub', '510502', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2326', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dc660cc3', '纳溪区', 'pub', '510503', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2327', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dc750cc4', '龙马潭区', 'pub', '510504', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2328', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dc870cc5', '泸　县', 'pub', '510521', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2329', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dc950cc6', '合江县', 'pub', '510522', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2330', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dca30cc7', '叙永县', 'pub', '510524', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2331', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dcb10cc8', '古蔺县', 'pub', '510525', 'ukewo', null, '297e1e874f83129d014f833503490337', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', '0', '2332', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dcdc0cc9', '市辖区', 'pub', '510601', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2333', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dcf80cca', '旌阳区', 'pub', '510603', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2334', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dd070ccb', '中江县', 'pub', '510623', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2335', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dd140ccc', '罗江县', 'pub', '510626', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2336', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dd210ccd', '广汉市', 'pub', '510681', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2337', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dd2f0cce', '什邡市', 'pub', '510682', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2338', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dd3e0ccf', '绵竹市', 'pub', '510683', 'ukewo', null, '297e1e874f83129d014f833503570338', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2339', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338de9c0cd0', '市辖区', 'pub', '510701', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2340', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338deaa0cd1', '涪城区', 'pub', '510703', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2341', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338deb80cd2', '游仙区', 'pub', '510704', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2342', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dec60cd3', '三台县', 'pub', '510722', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2343', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ded30cd4', '盐亭县', 'pub', '510723', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2344', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dee40cd5', '安　县', 'pub', '510724', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2345', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338def20cd6', '梓潼县', 'pub', '510725', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2346', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df020cd7', '北川羌族自治县', 'pub', '510726', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2347', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df0f0cd8', '平武县', 'pub', '510727', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2348', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df1c0cd9', '江油市', 'pub', '510781', 'ukewo', null, '297e1e874f83129d014f833503650339', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2349', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df460cda', '市辖区', 'pub', '510801', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2350', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df530cdb', '市中区', 'pub', '510802', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2351', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df6f0cdc', '元坝区', 'pub', '510811', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2352', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df7e0cdd', '朝天区', 'pub', '510812', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2353', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338df930cde', '旺苍县', 'pub', '510821', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2354', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338dfb50ce0', '青川县', 'pub', '510822', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', '0', '2355', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e0f50ce1', '剑阁县', 'pub', '510823', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2356', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1030ce2', '苍溪县', 'pub', '510824', 'ukewo', null, '297e1e874f83129d014f83350373033a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2357', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1320ce3', '市辖区', 'pub', '510901', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2358', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1430ce4', '船山区', 'pub', '510903', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2359', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1520ce5', '安居区', 'pub', '510904', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2360', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1600ce6', '蓬溪县', 'pub', '510921', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2361', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e16e0ce7', '射洪县', 'pub', '510922', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2362', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e17c0ce8', '大英县', 'pub', '510923', 'ukewo', null, '297e1e874f83129d014f8335037f033b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2363', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1a50ce9', '市辖区', 'pub', '511001', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2364', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1b40cea', '市中区', 'pub', '511002', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2365', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e1c00ceb', '东兴区', 'pub', '511011', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2366', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e2fb0cec', '威远县', 'pub', '511024', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2367', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3080ced', '资中县', 'pub', '511025', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2368', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3150cee', '隆昌县', 'pub', '511028', 'ukewo', null, '297e1e874f83129d014f83350393033c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2369', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3400cef', '市辖区', 'pub', '511101', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2370', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e34f0cf0', '市中区', 'pub', '511102', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2371', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e35c0cf1', '沙湾区', 'pub', '511111', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2372', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e36a0cf2', '五通桥区', 'pub', '511112', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2373', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3790cf3', '金口河区', 'pub', '511113', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2374', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3850cf4', '犍为县', 'pub', '511123', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2375', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e3930cf5', '井研县', 'pub', '511124', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', '0', '2376', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e4cd0cf6', '夹江县', 'pub', '511126', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2377', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e4db0cf7', '沐川县', 'pub', '511129', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2378', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e4ee0cf8', '峨边彝族自治县', 'pub', '511132', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2379', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e4fb0cf9', '马边彝族自治县', 'pub', '511133', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2380', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5090cfa', '峨眉山市', 'pub', '511181', 'ukewo', null, '297e1e874f83129d014f833503b0033d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2381', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e53e0cfb', '市辖区', 'pub', '511301', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2382', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5510cfc', '顺庆区', 'pub', '511302', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2383', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e55f0cfd', '高坪区', 'pub', '511303', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2384', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5700cfe', '嘉陵区', 'pub', '511304', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2385', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e57e0cff', '南部县', 'pub', '511321', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2386', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e58d0d00', '营山县', 'pub', '511322', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2387', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e59b0d01', '蓬安县', 'pub', '511323', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2388', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5aa0d02', '仪陇县', 'pub', '511324', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2389', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5bd0d03', '西充县', 'pub', '511325', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2390', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e5d10d04', '阆中市', 'pub', '511381', 'ukewo', null, '297e1e874f83129d014f833503bf033e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2391', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e72f0d05', '市辖区', 'pub', '511401', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2392', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e73f0d06', '东坡区', 'pub', '511402', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2393', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e74f0d07', '仁寿县', 'pub', '511421', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2394', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7600d08', '彭山县', 'pub', '511422', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2395', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7700d09', '洪雅县', 'pub', '511423', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2396', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7800d0a', '丹棱县', 'pub', '511424', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2397', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7910d0b', '青神县', 'pub', '511425', 'ukewo', null, '297e1e874f83129d014f833503cf033f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2398', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7bc0d0c', '市辖区', 'pub', '511501', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2399', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7ca0d0d', '翠屏区', 'pub', '511502', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2400', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7d80d0e', '宜宾县', 'pub', '511521', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2401', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7e80d0f', '南溪县', 'pub', '511522', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2402', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e7f80d10', '江安县', 'pub', '511523', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', '0', '2403', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9390d11', '长宁县', 'pub', '511524', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2404', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9490d12', '高　县', 'pub', '511525', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2405', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9580d13', '珙　县', 'pub', '511526', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2406', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9660d14', '筠连县', 'pub', '511527', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2407', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9770d15', '兴文县', 'pub', '511528', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2408', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9900d16', '屏山县', 'pub', '511529', 'ukewo', null, '297e1e874f83129d014f833503df0340', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2409', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9c00d17', '市辖区', 'pub', '511601', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2410', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9d30d18', '广安区', 'pub', '511602', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2411', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9ed0d19', '岳池县', 'pub', '511621', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2412', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338e9fd0d1a', '武胜县', 'pub', '511622', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2413', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea0c0d1b', '邻水县', 'pub', '511623', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2414', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea1b0d1c', '华莹市', 'pub', '511681', 'ukewo', null, '297e1e874f83129d014f833503f10341', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2415', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea4d0d1d', '市辖区', 'pub', '511701', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2416', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea600d1e', '通川区', 'pub', '511702', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2417', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea6e0d1f', '达　县', 'pub', '511721', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2418', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea7f0d20', '宣汉县', 'pub', '511722', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2419', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ea940d21', '开江县', 'pub', '511723', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2420', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ebcd0d22', '大竹县', 'pub', '511724', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2421', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ebda0d23', '渠　县', 'pub', '511725', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2422', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ebe80d24', '万源市', 'pub', '511781', 'ukewo', null, '297e1e874f83129d014f833504010342', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2423', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec150d25', '市辖区', 'pub', '511801', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2424', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec270d26', '雨城区', 'pub', '511802', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2425', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec350d27', '名山县', 'pub', '511821', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2426', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec420d28', '荥经县', 'pub', '511822', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2427', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec510d29', '汉源县', 'pub', '511823', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2428', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec5f0d2a', '石棉县', 'pub', '511824', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2429', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec6d0d2b', '天全县', 'pub', '511825', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', '0', '2430', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec7a0d2c', '芦山县', 'pub', '511826', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2431', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ec8b0d2d', '宝兴县', 'pub', '511827', 'ukewo', null, '297e1e874f83129d014f833504100343', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2432', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ede50d2e', '市辖区', 'pub', '511901', 'ukewo', null, '297e1e874f83129d014f833504230344', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2433', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338edf60d2f', '巴州区', 'pub', '511902', 'ukewo', null, '297e1e874f83129d014f833504230344', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2434', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee020d30', '通江县', 'pub', '511921', 'ukewo', null, '297e1e874f83129d014f833504230344', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2435', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee110d31', '南江县', 'pub', '511922', 'ukewo', null, '297e1e874f83129d014f833504230344', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2436', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee200d32', '平昌县', 'pub', '511923', 'ukewo', null, '297e1e874f83129d014f833504230344', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2437', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee510d33', '市辖区', 'pub', '512001', 'ukewo', null, '297e1e874f83129d014f833505600345', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2438', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee5f0d34', '雁江区', 'pub', '512002', 'ukewo', null, '297e1e874f83129d014f833505600345', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2439', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee700d35', '安岳县', 'pub', '512021', 'ukewo', null, '297e1e874f83129d014f833505600345', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2440', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee810d36', '乐至县', 'pub', '512022', 'ukewo', null, '297e1e874f83129d014f833505600345', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2441', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ee8d0d37', '简阳市', 'pub', '512081', 'ukewo', null, '297e1e874f83129d014f833505600345', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2442', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338eeba0d38', '汶川县', 'pub', '513221', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2443', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338eec80d39', '理　县', 'pub', '513222', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2444', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338eed50d3a', '茂　县', 'pub', '513223', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2445', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0100d3b', '松潘县', 'pub', '513224', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2446', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f01e0d3c', '九寨沟县', 'pub', '513225', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2447', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0310d3d', '金川县', 'pub', '513226', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2448', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f03e0d3e', '小金县', 'pub', '513227', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2449', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f04d0d3f', '黑水县', 'pub', '513228', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', '0', '2450', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0590d40', '马尔康县', 'pub', '513229', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2451', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0690d41', '壤塘县', 'pub', '513230', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2452', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0780d42', '阿坝县', 'pub', '513231', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2453', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0870d43', '若尔盖县', 'pub', '513232', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2454', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0960d44', '红原县', 'pub', '513233', 'ukewo', null, '297e1e874f83129d014f833505730346', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2455', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0c30d45', '康定县', 'pub', '513321', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2456', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0d10d46', '泸定县', 'pub', '513322', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2457', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f0e20d47', '丹巴县', 'pub', '513323', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2458', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f21c0d48', '九龙县', 'pub', '513324', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2459', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2290d49', '雅江县', 'pub', '513325', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2460', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2360d4a', '道孚县', 'pub', '513326', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2461', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2520d4b', '炉霍县', 'pub', '513327', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2462', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f25f0d4c', '甘孜县', 'pub', '513328', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2463', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f26d0d4d', '新龙县', 'pub', '513329', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2464', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2790d4e', '德格县', 'pub', '513330', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2465', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2890d4f', '白玉县', 'pub', '513331', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2466', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2970d50', '石渠县', 'pub', '513332', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2467', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2a70d51', '色达县', 'pub', '513333', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2468', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2b30d52', '理塘县', 'pub', '513334', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2469', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2c50d53', '巴塘县', 'pub', '513335', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2470', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2d40d54', '乡城县', 'pub', '513336', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2471', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2e40d55', '稻城县', 'pub', '513337', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2472', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f2f10d56', '得荣县', 'pub', '513338', 'ukewo', null, '297e1e874f83129d014f833505830347', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', '0', '2473', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4460d58', '西昌市', 'pub', '513401', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2474', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4530d59', '木里藏族自治县', 'pub', '513422', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2475', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4610d5a', '盐源县', 'pub', '513423', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2476', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4740d5b', '德昌县', 'pub', '513424', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2477', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4810d5c', '会理县', 'pub', '513425', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2478', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4910d5d', '会东县', 'pub', '513426', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2479', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4ac0d5e', '宁南县', 'pub', '513427', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2480', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4c00d5f', '普格县', 'pub', '513428', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2481', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4cf0d60', '布拖县', 'pub', '513429', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2482', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f4df0d61', '金阳县', 'pub', '513430', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2483', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f61b0d62', '昭觉县', 'pub', '513431', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2484', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6290d63', '喜德县', 'pub', '513432', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2485', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6380d64', '冕宁县', 'pub', '513433', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2486', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f64d0d65', '越西县', 'pub', '513434', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2487', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6620d66', '甘洛县', 'pub', '513435', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2488', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6760d67', '美姑县', 'pub', '513436', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2489', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6860d68', '雷波县', 'pub', '513437', 'ukewo', null, '297e1e874f83129d014f833505940348', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2490', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6b20d69', '市辖区', 'pub', '520101', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2491', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6c10d6a', '南明区', 'pub', '520102', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2492', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6d40d6b', '云岩区', 'pub', '520103', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2493', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6e30d6c', '花溪区', 'pub', '520111', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2494', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f6f40d6d', '乌当区', 'pub', '520112', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2495', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f7080d6e', '白云区', 'pub', '520113', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2496', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f7150d6f', '小河区', 'pub', '520114', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2497', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f7210d70', '开阳县', 'pub', '520121', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2498', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f7300d71', '息烽县', 'pub', '520122', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', '0', '2499', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f86a0d72', '修文县', 'pub', '520123', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2500', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8780d73', '清镇市', 'pub', '520181', 'ukewo', null, '297e1e874f83129d014f833505ca0349', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2501', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f89f0d74', '钟山区', 'pub', '520201', 'ukewo', null, '297e1e874f83129d014f833505d9034a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2502', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8ac0d75', '六枝特区', 'pub', '520203', 'ukewo', null, '297e1e874f83129d014f833505d9034a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2503', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8b80d76', '水城县', 'pub', '520221', 'ukewo', null, '297e1e874f83129d014f833505d9034a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2504', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8c40d77', '盘　县', 'pub', '520222', 'ukewo', null, '297e1e874f83129d014f833505d9034a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2505', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8ef0d78', '市辖区', 'pub', '520301', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2506', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f8fc0d79', '红花岗区', 'pub', '520302', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2507', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f9090d7a', '汇川区', 'pub', '520303', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2508', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f9160d7b', '遵义县', 'pub', '520321', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2509', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338f9220d7c', '桐梓县', 'pub', '520322', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2510', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa590d7d', '绥阳县', 'pub', '520323', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2511', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa650d7e', '正安县', 'pub', '520324', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2512', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa710d7f', '道真仡佬族苗族自治县', 'pub', '520325', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2513', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa7d0d80', '务川仡佬族苗族自治县', 'pub', '520326', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2514', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa8b0d81', '凤冈县', 'pub', '520327', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2515', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fa970d82', '湄潭县', 'pub', '520328', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2516', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338faa40d83', '余庆县', 'pub', '520329', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2517', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fab10d84', '习水县', 'pub', '520330', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2518', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fac20d85', '赤水市', 'pub', '520381', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2519', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338facf0d86', '仁怀市', 'pub', '520382', 'ukewo', null, '297e1e874f83129d014f833505ea034b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2520', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338faff0d87', '市辖区', 'pub', '520401', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2521', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fb0d0d88', '西秀区', 'pub', '520402', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2522', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fb190d89', '平坝县', 'pub', '520421', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', '0', '2523', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fc530d8a', '普定县', 'pub', '520422', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2524', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fc600d8b', '镇宁布依族苗族自治县', 'pub', '520423', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2525', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fc6d0d8c', '关岭布依族苗族自治县', 'pub', '520424', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2526', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fc790d8d', '紫云苗族布依族自治县', 'pub', '520425', 'ukewo', null, '297e1e874f83129d014f833505fb034c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2527', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fca60d8e', '铜仁市', 'pub', '522201', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2528', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fcb30d8f', '江口县', 'pub', '522222', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2529', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fcc00d90', '玉屏侗族自治县', 'pub', '522223', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2530', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fcce0d91', '石阡县', 'pub', '522224', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2531', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fcdd0d92', '思南县', 'pub', '522225', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2532', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fced0d93', '印江土家族苗族自治县', 'pub', '522226', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2533', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fcff0d94', '德江县', 'pub', '522227', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2534', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fd0c0d95', '沿河土家族自治县', 'pub', '522228', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2535', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fd1b0d96', '松桃苗族自治县', 'pub', '522229', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2536', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fd290d97', '万山特区', 'pub', '522230', 'ukewo', null, '297e1e874f83129d014f8335060c034d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2537', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fe820d98', '兴义市', 'pub', '522301', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2538', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fe910d99', '兴仁县', 'pub', '522322', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2539', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fe9d0d9a', '普安县', 'pub', '522323', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2540', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fea80d9b', '晴隆县', 'pub', '522324', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2541', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338feb40d9c', '贞丰县', 'pub', '522325', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2542', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338febf0d9d', '望谟县', 'pub', '522326', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2543', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fecb0d9e', '册亨县', 'pub', '522327', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2544', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338fed70d9f', '安龙县', 'pub', '522328', 'ukewo', null, '297e1e874f83129d014f8335061f034e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2545', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ff030da0', '毕节市', 'pub', '522401', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2546', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ff100da1', '大方县', 'pub', '522422', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2547', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ff1f0da2', '黔西县', 'pub', '522423', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2548', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ff2b0da3', '金沙县', 'pub', '522424', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2549', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8338ff370da4', '织金县', 'pub', '522425', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', '0', '2550', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900710da5', '纳雍县', 'pub', '522426', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2551', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900800da6', '威宁彝族回族苗族自治县', 'pub', '522427', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2552', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339008c0da7', '赫章县', 'pub', '522428', 'ukewo', null, '297e1e874f83129d014f8335062e034f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2553', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900b30da8', '凯里市', 'pub', '522601', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2554', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900c00da9', '黄平县', 'pub', '522622', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2555', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900cc0daa', '施秉县', 'pub', '522623', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2556', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900da0dab', '三穗县', 'pub', '522624', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2557', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900e70dac', '镇远县', 'pub', '522625', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2558', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833900f30dad', '岑巩县', 'pub', '522626', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2559', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339022c0dae', '天柱县', 'pub', '522627', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2560', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902400daf', '锦屏县', 'pub', '522628', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2561', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339024f0db0', '剑河县', 'pub', '522629', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2562', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339025d0db1', '台江县', 'pub', '522630', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2563', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902690db2', '黎平县', 'pub', '522631', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2564', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902750db3', '榕江县', 'pub', '522632', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2565', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902810db4', '从江县', 'pub', '522633', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2566', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902900db5', '雷山县', 'pub', '522634', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2567', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339029c0db6', '麻江县', 'pub', '522635', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2568', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902a80db7', '丹寨县', 'pub', '522636', 'ukewo', null, '297e1e874f83129d014f833506400350', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2569', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902ce0db8', '都匀市', 'pub', '522701', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2570', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902dd0db9', '福泉市', 'pub', '522702', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2571', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833902ea0dba', '荔波县', 'pub', '522722', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', '0', '2572', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904260dbb', '贵定县', 'pub', '522723', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2573', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904350dbc', '瓮安县', 'pub', '522725', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2574', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904420dbd', '独山县', 'pub', '522726', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2575', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339044e0dbe', '平塘县', 'pub', '522727', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2576', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339045b0dbf', '罗甸县', 'pub', '522728', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2577', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904680dc0', '长顺县', 'pub', '522729', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2578', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904750dc1', '龙里县', 'pub', '522730', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2579', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904830dc2', '惠水县', 'pub', '522731', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2580', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904920dc3', '三都水族自治县', 'pub', '522732', 'ukewo', null, '297e1e874f83129d014f833506500351', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2581', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904be0dc4', '市辖区', 'pub', '530101', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2582', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904cd0dc5', '五华区', 'pub', '530102', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2583', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904db0dc6', '盘龙区', 'pub', '530103', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2584', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833904e70dc7', '官渡区', 'pub', '530111', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2585', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906210dc8', '西山区', 'pub', '530112', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2586', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339062e0dc9', '东川区', 'pub', '530113', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2587', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339063f0dca', '呈贡县', 'pub', '530121', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2588', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339064c0dcb', '晋宁县', 'pub', '530122', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2589', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339065a0dcc', '富民县', 'pub', '530124', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2590', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906670dcd', '宜良县', 'pub', '530125', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2591', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906780dce', '石林彝族自治县', 'pub', '530126', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2592', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906850dcf', '嵩明县', 'pub', '530127', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2593', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906910dd0', '禄劝彝族苗族自治县', 'pub', '530128', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2594', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339069d0dd1', '寻甸回族彝族自治县', 'pub', '530129', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2595', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833906a80dd2', '安宁市', 'pub', '530181', 'ukewo', null, '297e1e874f83129d014f833506810352', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', '0', '2596', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833907fc0dd4', '市辖区', 'pub', '530301', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2597', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339080a0dd5', '麒麟区', 'pub', '530302', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2598', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908190dd6', '马龙县', 'pub', '530321', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2599', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908260dd7', '陆良县', 'pub', '530322', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2600', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908330dd8', '师宗县', 'pub', '530323', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2601', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339083f0dd9', '罗平县', 'pub', '530324', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2602', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339084c0dda', '富源县', 'pub', '530325', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2603', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339085c0ddb', '会泽县', 'pub', '530326', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2604', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908690ddc', '沾益县', 'pub', '530328', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2605', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908740ddd', '宣威市', 'pub', '530381', 'ukewo', null, '297e1e874f83129d014f833507bf0353', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2606', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339089c0dde', '市辖区', 'pub', '530401', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2607', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908a80ddf', '红塔区', 'pub', '530402', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2608', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833908b40de0', '江川县', 'pub', '530421', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2609', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833909ef0de1', '澄江县', 'pub', '530422', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2610', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833909fc0de2', '通海县', 'pub', '530423', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2611', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a080de3', '华宁县', 'pub', '530424', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2612', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a140de4', '易门县', 'pub', '530425', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2613', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a210de5', '峨山彝族自治县', 'pub', '530426', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2614', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a310de6', '新平彝族傣族自治县', 'pub', '530427', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2615', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a3d0de7', '元江哈尼族彝族傣族自治县', 'pub', '530428', 'ukewo', null, '297e1e874f83129d014f833507cd0354', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2616', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a660de8', '市辖区', 'pub', '530501', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2617', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a770de9', '隆阳区', 'pub', '530502', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2618', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a840dea', '施甸县', 'pub', '530521', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2619', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390a970deb', '腾冲县', 'pub', '530522', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2620', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390aa50dec', '龙陵县', 'pub', '530523', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', '0', '2621', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390bdf0ded', '昌宁县', 'pub', '530524', 'ukewo', null, '297e1e874f83129d014f833507e00355', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2622', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c090dee', '市辖区', 'pub', '530601', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2623', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c150def', '昭阳区', 'pub', '530602', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2624', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c260df0', '鲁甸县', 'pub', '530621', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2625', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c380df1', '巧家县', 'pub', '530622', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2626', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c460df2', '盐津县', 'pub', '530623', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2627', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c540df3', '大关县', 'pub', '530624', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2628', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c620df4', '永善县', 'pub', '530625', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2629', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c6e0df5', '绥江县', 'pub', '530626', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2630', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c7c0df6', '镇雄县', 'pub', '530627', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2631', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c8a0df7', '彝良县', 'pub', '530628', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2632', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390c9d0df8', '威信县', 'pub', '530629', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2633', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390ca90df9', '水富县', 'pub', '530630', 'ukewo', null, '297e1e874f83129d014f833507f60356', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2634', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e040dfa', '市辖区', 'pub', '530701', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2635', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e100dfb', '古城区', 'pub', '530702', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2636', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e1d0dfc', '玉龙纳西族自治县', 'pub', '530721', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2637', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e2a0dfd', '永胜县', 'pub', '530722', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2638', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e380dfe', '华坪县', 'pub', '530723', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2639', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e440dff', '宁蒗彝族自治县', 'pub', '530724', 'ukewo', null, '297e1e874f83129d014f833508050357', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2640', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e6a0e00', '市辖区', 'pub', '530801', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2641', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e780e01', '翠云区', 'pub', '530802', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2642', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e8c0e02', '普洱哈尼族彝族自治县', 'pub', '530821', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2643', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390e990e03', '墨江哈尼族自治县', 'pub', '530822', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', '0', '2644', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390fdd0e04', '景东彝族自治县', 'pub', '530823', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2645', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390fec0e05', '景谷傣族彝族自治县', 'pub', '530824', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2646', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83390ffc0e06', '镇沅彝族哈尼族拉祜族自治县', 'pub', '530825', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2647', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339100e0e07', '江城哈尼族彝族自治县', 'pub', '530826', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2648', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339101c0e08', '孟连傣族拉祜族佤族自治县', 'pub', '530827', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2649', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339102b0e09', '澜沧拉祜族自治县', 'pub', '530828', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2650', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339103d0e0a', '西盟佤族自治县', 'pub', '530829', 'ukewo', null, '297e1e874f83129d014f833508180358', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2651', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339106d0e0b', '市辖区', 'pub', '530901', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2652', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339107d0e0c', '临翔区', 'pub', '530902', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2653', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339108f0e0d', '凤庆县', 'pub', '530921', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2654', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339109e0e0e', '云　县', 'pub', '530922', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2655', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833910ac0e0f', '永德县', 'pub', '530923', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2656', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833910bf0e10', '镇康县', 'pub', '530924', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2657', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833910d00e11', '双江拉祜族佤族布朗族傣族自治县', 'pub', '530925', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2658', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833910dc0e12', '耿马傣族佤族自治县', 'pub', '530926', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2659', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339121e0e13', '沧源佤族自治县', 'pub', '530927', 'ukewo', null, '297e1e874f83129d014f833508270359', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2660', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912500e14', '楚雄市', 'pub', '532301', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2661', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912600e15', '双柏县', 'pub', '532322', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2662', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339126e0e16', '牟定县', 'pub', '532323', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2663', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912800e17', '南华县', 'pub', '532324', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2664', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912910e18', '姚安县', 'pub', '532325', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2665', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339129d0e19', '大姚县', 'pub', '532326', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2666', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912ae0e1a', '永仁县', 'pub', '532327', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2667', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912c20e1b', '元谋县', 'pub', '532328', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2668', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912d40e1c', '武定县', 'pub', '532329', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2669', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833912e30e1d', '禄丰县', 'pub', '532331', 'ukewo', null, '297e1e874f83129d014f8335083b035a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2670', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833913120e1e', '个旧市', 'pub', '532501', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2671', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833913210e1f', '开远市', 'pub', '532502', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2672', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339132f0e20', '蒙自县', 'pub', '532522', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', '0', '2673', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339146a0e21', '屏边苗族自治县', 'pub', '532523', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2674', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914770e22', '建水县', 'pub', '532524', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2675', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914840e23', '石屏县', 'pub', '532525', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2676', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914940e24', '弥勒县', 'pub', '532526', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2677', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914a10e25', '泸西县', 'pub', '532527', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2678', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914b10e26', '元阳县', 'pub', '532528', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2679', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914bd0e27', '红河县', 'pub', '532529', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2680', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914d20e28', '金平苗族瑶族傣族自治县', 'pub', '532530', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2681', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914e70e29', '绿春县', 'pub', '532531', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2682', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833914f40e2a', '河口瑶族自治县', 'pub', '532532', 'ukewo', null, '297e1e874f83129d014f8335084a035b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2683', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339151c0e2b', '文山县', 'pub', '532621', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2684', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339152a0e2c', '砚山县', 'pub', '532622', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2685', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833915390e2d', '西畴县', 'pub', '532623', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2686', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916750e2e', '麻栗坡县', 'pub', '532624', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2687', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916890e2f', '马关县', 'pub', '532625', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2688', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916970e30', '丘北县', 'pub', '532626', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2689', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916a70e31', '广南县', 'pub', '532627', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2690', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916bb0e32', '富宁县', 'pub', '532628', 'ukewo', null, '297e1e874f83129d014f8335085b035c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2691', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916e80e33', '景洪市', 'pub', '532801', 'ukewo', null, '297e1e874f83129d014f8335086c035d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2692', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833916f50e34', '勐海县', 'pub', '532822', 'ukewo', null, '297e1e874f83129d014f8335086c035d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2693', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917040e35', '勐腊县', 'pub', '532823', 'ukewo', null, '297e1e874f83129d014f8335086c035d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2694', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917350e36', '大理市', 'pub', '532901', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2695', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917420e37', '漾濞彝族自治县', 'pub', '532922', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2696', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917520e38', '祥云县', 'pub', '532923', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2697', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917620e39', '宾川县', 'pub', '532924', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', '0', '2698', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833917720e3a', '弥渡县', 'pub', '532925', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2699', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339177f0e3b', '南涧彝族自治县', 'pub', '532926', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2700', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918b80e3c', '巍山彝族回族自治县', 'pub', '532927', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2701', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918c30e3d', '永平县', 'pub', '532928', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2702', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918d20e3e', '云龙县', 'pub', '532929', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2703', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918de0e3f', '洱源县', 'pub', '532930', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2704', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918ed0e40', '剑川县', 'pub', '532931', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2705', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833918fb0e41', '鹤庆县', 'pub', '532932', 'ukewo', null, '297e1e874f83129d014f8335087a035e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2706', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833919270e42', '瑞丽市', 'pub', '533102', 'ukewo', null, '297e1e874f83129d014f8335088a035f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2707', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833919360e43', '潞西市', 'pub', '533103', 'ukewo', null, '297e1e874f83129d014f8335088a035f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2708', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833919470e44', '梁河县', 'pub', '533122', 'ukewo', null, '297e1e874f83129d014f8335088a035f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2709', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833919570e45', '盈江县', 'pub', '533123', 'ukewo', null, '297e1e874f83129d014f8335088a035f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2710', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833919650e46', '陇川县', 'pub', '533124', 'ukewo', null, '297e1e874f83129d014f8335088a035f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2711', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391abf0e48', '泸水县', 'pub', '533321', 'ukewo', null, '297e1e874f83129d014f8335089b0360', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2712', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391acc0e49', '福贡县', 'pub', '533323', 'ukewo', null, '297e1e874f83129d014f8335089b0360', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2713', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ada0e4a', '贡山独龙族怒族自治县', 'pub', '533324', 'ukewo', null, '297e1e874f83129d014f8335089b0360', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2714', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391aea0e4b', '兰坪白族普米族自治县', 'pub', '533325', 'ukewo', null, '297e1e874f83129d014f8335089b0360', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2715', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391b130e4c', '香格里拉县', 'pub', '533421', 'ukewo', null, '297e1e874f83129d014f833508b20361', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2716', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391b1f0e4d', '德钦县', 'pub', '533422', 'ukewo', null, '297e1e874f83129d014f833508b20361', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2717', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391b2b0e4e', '维西傈僳族自治县', 'pub', '533423', 'ukewo', null, '297e1e874f83129d014f833508b20361', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', '0', '2718', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391c850e4f', '市辖区', 'pub', '540101', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2719', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391c970e50', '城关区', 'pub', '540102', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2720', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ca50e51', '林周县', 'pub', '540121', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2721', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391cb10e52', '当雄县', 'pub', '540122', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2722', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391cc10e53', '尼木县', 'pub', '540123', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2723', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391cce0e54', '曲水县', 'pub', '540124', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2724', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391cdb0e55', '堆龙德庆县', 'pub', '540125', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2725', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391cf20e56', '达孜县', 'pub', '540126', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2726', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d000e57', '墨竹工卡县', 'pub', '540127', 'ukewo', null, '297e1e874f83129d014f833508e00362', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2727', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d2a0e58', '昌都县', 'pub', '542121', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2728', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d370e59', '江达县', 'pub', '542122', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2729', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d440e5a', '贡觉县', 'pub', '542123', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2730', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d500e5b', '类乌齐县', 'pub', '542124', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2731', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391d5b0e5c', '丁青县', 'pub', '542125', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2732', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391e960e5d', '察雅县', 'pub', '542126', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2733', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ea60e5e', '八宿县', 'pub', '542127', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2734', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391eb40e5f', '左贡县', 'pub', '542128', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2735', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ec30e60', '芒康县', 'pub', '542129', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2736', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ed00e61', '洛隆县', 'pub', '542132', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2737', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391ee00e62', '边坝县', 'pub', '542133', 'ukewo', null, '297e1e874f83129d014f83350a1c0363', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2738', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f060e63', '乃东县', 'pub', '542221', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2739', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f130e64', '扎囊县', 'pub', '542222', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2740', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f220e65', '贡嘎县', 'pub', '542223', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2741', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f2e0e66', '桑日县', 'pub', '542224', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', '0', '2742', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f3c0e67', '琼结县', 'pub', '542225', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2743', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f480e68', '曲松县', 'pub', '542226', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2744', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83391f590e69', '措美县', 'pub', '542227', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2745', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920940e6a', '洛扎县', 'pub', '542228', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2746', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920a00e6b', '加查县', 'pub', '542229', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2747', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920ac0e6c', '隆子县', 'pub', '542231', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2748', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920b70e6d', '错那县', 'pub', '542232', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2749', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920c20e6e', '浪卡子县', 'pub', '542233', 'ukewo', null, '297e1e874f83129d014f83350a2b0364', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2750', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920e80e6f', '日喀则市', 'pub', '542301', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2751', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833920f30e70', '南木林县', 'pub', '542322', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2752', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833921000e71', '江孜县', 'pub', '542323', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2753', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339210f0e72', '定日县', 'pub', '542324', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2754', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339211a0e73', '萨迦县', 'pub', '542325', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2755', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833921250e74', '拉孜县', 'pub', '542326', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2756', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833921310e75', '昂仁县', 'pub', '542327', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2757', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339213c0e76', '谢通门县', 'pub', '542328', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2758', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922770e77', '白朗县', 'pub', '542329', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2759', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922820e78', '仁布县', 'pub', '542330', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2760', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922900e79', '康马县', 'pub', '542331', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2761', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339229d0e7a', '定结县', 'pub', '542332', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2762', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922a90e7b', '仲巴县', 'pub', '542333', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2763', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922b40e7c', '亚东县', 'pub', '542334', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2764', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922bf0e7d', '吉隆县', 'pub', '542335', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2765', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922cc0e7e', '聂拉木县', 'pub', '542336', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2766', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922d90e7f', '萨嘎县', 'pub', '542337', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2767', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833922e80e80', '岗巴县', 'pub', '542338', 'ukewo', null, '297e1e874f83129d014f83350a3a0365', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2768', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833923140e81', '那曲县', 'pub', '542421', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2769', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833923200e82', '嘉黎县', 'pub', '542422', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', '0', '2770', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339232b0e83', '比如县', 'pub', '542423', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2771', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924630e84', '聂荣县', 'pub', '542424', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2772', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339246f0e85', '安多县', 'pub', '542425', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2773', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339247b0e86', '申扎县', 'pub', '542426', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2774', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924860e87', '索　县', 'pub', '542427', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2775', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924950e88', '班戈县', 'pub', '542428', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2776', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924a10e89', '巴青县', 'pub', '542429', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2777', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924ad0e8a', '尼玛县', 'pub', '542430', 'ukewo', null, '297e1e874f83129d014f83350a480366', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2778', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924d60e8b', '普兰县', 'pub', '542521', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2779', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924e40e8c', '札达县', 'pub', '542522', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2780', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833924f10e8d', '噶尔县', 'pub', '542523', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2781', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926290e8e', '日土县', 'pub', '542524', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2782', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926340e8f', '革吉县', 'pub', '542525', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2783', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926400e90', '改则县', 'pub', '542526', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2784', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339264b0e91', '措勤县', 'pub', '542527', 'ukewo', null, '297e1e874f83129d014f83350a560367', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2785', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926790e92', '林芝县', 'pub', '542621', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2786', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926850e93', '工布江达县', 'pub', '542622', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2787', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926910e94', '米林县', 'pub', '542623', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2788', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339269e0e95', '墨脱县', 'pub', '542624', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2789', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926aa0e96', '波密县', 'pub', '542625', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2790', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926b60e97', '察隅县', 'pub', '542626', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2791', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926c30e98', '朗　县', 'pub', '542627', 'ukewo', null, '297e1e874f83129d014f83350a650368', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2792', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926e90e99', '市辖区', 'pub', '610101', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2793', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926f40e9a', '新城区', 'pub', '610102', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2794', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833926ff0e9b', '碑林区', 'pub', '610103', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', '0', '2795', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928370e9c', '莲湖区', 'pub', '610104', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2796', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928440e9d', '灞桥区', 'pub', '610111', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2797', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928500e9e', '未央区', 'pub', '610112', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2798', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339285f0e9f', '雁塔区', 'pub', '610113', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2799', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339286a0ea0', '阎良区', 'pub', '610114', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2800', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928770ea1', '临潼区', 'pub', '610115', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2801', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928820ea2', '长安区', 'pub', '610116', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2802', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339288e0ea3', '蓝田县', 'pub', '610122', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2803', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339289b0ea4', '周至县', 'pub', '610124', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2804', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928a80ea5', '户　县', 'pub', '610125', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2805', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833928b40ea6', '高陵县', 'pub', '610126', 'ukewo', null, '297e1e874f83129d014f83350a8e0369', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2806', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a0c0ea7', '市辖区', 'pub', '610201', 'ukewo', null, '297e1e874f83129d014f83350aa1036a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2807', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a1a0ea8', '王益区', 'pub', '610202', 'ukewo', null, '297e1e874f83129d014f83350aa1036a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2808', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a270ea9', '印台区', 'pub', '610203', 'ukewo', null, '297e1e874f83129d014f83350aa1036a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2809', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a320eaa', '耀州区', 'pub', '610204', 'ukewo', null, '297e1e874f83129d014f83350aa1036a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2810', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a470eab', '宜君县', 'pub', '610222', 'ukewo', null, '297e1e874f83129d014f83350aa1036a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2811', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a6e0eac', '市辖区', 'pub', '610301', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2812', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a7a0ead', '渭滨区', 'pub', '610302', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2813', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a860eae', '金台区', 'pub', '610303', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2814', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392a940eaf', '陈仓区', 'pub', '610304', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2815', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392aa10eb0', '凤翔县', 'pub', '610322', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2816', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392aad0eb1', '岐山县', 'pub', '610323', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2817', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392aba0eb2', '扶风县', 'pub', '610324', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', '0', '2818', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392bf30eb3', '眉　县', 'pub', '610326', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2819', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392bff0eb4', '陇　县', 'pub', '610327', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2820', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c0a0eb5', '千阳县', 'pub', '610328', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2821', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c1b0eb6', '麟游县', 'pub', '610329', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2822', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c260eb7', '凤　县', 'pub', '610330', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2823', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c310eb8', '太白县', 'pub', '610331', 'ukewo', null, '297e1e874f83129d014f83350ab6036b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2824', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c590eb9', '市辖区', 'pub', '610401', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2825', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c640eba', '秦都区', 'pub', '610402', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2826', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c700ebb', '杨凌区', 'pub', '610403', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2827', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c7c0ebc', '渭城区', 'pub', '610404', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2828', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c8b0ebd', '三原县', 'pub', '610422', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2829', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392c970ebe', '泾阳县', 'pub', '610423', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2830', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392ca50ebf', '乾　县', 'pub', '610424', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2831', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392ddd0ec1', '礼泉县', 'pub', '610425', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2832', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392de80ec2', '永寿县', 'pub', '610426', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2833', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392df30ec3', '彬　县', 'pub', '610427', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2834', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392e020ec4', '长武县', 'pub', '610428', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2835', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392e0f0ec5', '旬邑县', 'pub', '610429', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2836', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392e1a0ec6', '淳化县', 'pub', '610430', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2837', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392e260ec7', '武功县', 'pub', '610431', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2838', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392e320ec8', '兴平市', 'pub', '610481', 'ukewo', null, '297e1e874f83129d014f83350ad3036c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', '0', '2839', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392f8a0ec9', '市辖区', 'pub', '610501', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2840', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392f990eca', '临渭区', 'pub', '610502', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2841', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392fa50ecb', '华　县', 'pub', '610521', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2842', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392fb40ecc', '潼关县', 'pub', '610522', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2843', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392fc20ecd', '大荔县', 'pub', '610523', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2844', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392fcd0ece', '合阳县', 'pub', '610524', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2845', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392fdf0ecf', '澄城县', 'pub', '610525', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2846', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392feb0ed0', '蒲城县', 'pub', '610526', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2847', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83392ffa0ed1', '白水县', 'pub', '610527', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2848', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833930060ed2', '富平县', 'pub', '610528', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2849', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833930130ed3', '韩城市', 'pub', '610581', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2850', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339301f0ed4', '华阴市', 'pub', '610582', 'ukewo', null, '297e1e874f83129d014f83350ae2036d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2851', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833930490ed5', '市辖区', 'pub', '610601', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2852', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833930570ed6', '宝塔区', 'pub', '610602', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2853', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833930630ed7', '延长县', 'pub', '610621', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2854', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339319f0ed8', '延川县', 'pub', '610622', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2855', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931aa0ed9', '子长县', 'pub', '610623', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2856', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931b70eda', '安塞县', 'pub', '610624', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2857', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931c20edb', '志丹县', 'pub', '610625', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2858', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931cd0edc', '吴旗县', 'pub', '610626', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2859', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931d90edd', '甘泉县', 'pub', '610627', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2860', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931e40ede', '富　县', 'pub', '610628', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2861', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931f20edf', '洛川县', 'pub', '610629', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2862', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833931fe0ee0', '宜川县', 'pub', '610630', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2863', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833932090ee1', '黄龙县', 'pub', '610631', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2864', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833932150ee2', '黄陵县', 'pub', '610632', 'ukewo', null, '297e1e874f83129d014f83350af0036e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', '0', '2865', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933760ee3', '市辖区', 'pub', '610701', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2866', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933820ee4', '汉台区', 'pub', '610702', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2867', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339338e0ee5', '南郑县', 'pub', '610721', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2868', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339339f0ee6', '城固县', 'pub', '610722', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2869', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933ae0ee7', '洋　县', 'pub', '610723', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2870', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933bc0ee8', '西乡县', 'pub', '610724', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2871', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933c70ee9', '勉　县', 'pub', '610725', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2872', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933d70eea', '宁强县', 'pub', '610726', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2873', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933e30eeb', '略阳县', 'pub', '610727', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2874', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933ee0eec', '镇巴县', 'pub', '610728', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2875', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833933f90eed', '留坝县', 'pub', '610729', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2876', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833934040eee', '佛坪县', 'pub', '610730', 'ukewo', null, '297e1e874f83129d014f83350afe036f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2877', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833934300eef', '市辖区', 'pub', '610801', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2878', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339343f0ef0', '榆阳区', 'pub', '610802', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2879', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339344b0ef1', '神木县', 'pub', '610821', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2880', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935830ef2', '府谷县', 'pub', '610822', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2881', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339358f0ef3', '横山县', 'pub', '610823', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2882', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339359c0ef4', '靖边县', 'pub', '610824', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2883', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935a80ef5', '定边县', 'pub', '610825', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2884', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935b40ef6', '绥德县', 'pub', '610826', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2885', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935bf0ef7', '米脂县', 'pub', '610827', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2886', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935ce0ef8', '佳　县', 'pub', '610828', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2887', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935d90ef9', '吴堡县', 'pub', '610829', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2888', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935e70efa', '清涧县', 'pub', '610830', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2889', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833935f20efb', '子洲县', 'pub', '610831', 'ukewo', null, '297e1e874f83129d014f83350b0b0370', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2890', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339361c0efc', '市辖区', 'pub', '610901', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', '0', '2891', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937620efd', '汉滨区', 'pub', '610902', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2892', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937740efe', '汉阴县', 'pub', '610921', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2893', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937820eff', '石泉县', 'pub', '610922', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2894', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339378f0f00', '宁陕县', 'pub', '610923', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2895', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339379b0f01', '紫阳县', 'pub', '610924', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2896', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937a70f02', '岚皋县', 'pub', '610925', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2897', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937b30f03', '平利县', 'pub', '610926', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2898', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937bf0f04', '镇坪县', 'pub', '610927', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2899', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937cd0f05', '旬阳县', 'pub', '610928', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2900', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833937d80f06', '白河县', 'pub', '610929', 'ukewo', null, '297e1e874f83129d014f83350b170371', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2901', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833938030f07', '市辖区', 'pub', '611001', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2902', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339381a0f08', '商州区', 'pub', '611002', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2903', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833938330f09', '洛南县', 'pub', '611021', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2904', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833938450f0a', '丹凤县', 'pub', '611022', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2905', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833938520f0b', '商南县', 'pub', '611023', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2906', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339398e0f0c', '山阳县', 'pub', '611024', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2907', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339399c0f0d', '镇安县', 'pub', '611025', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2908', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833939a90f0e', '柞水县', 'pub', '611026', 'ukewo', null, '297e1e874f83129d014f83350c540372', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2909', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833939d20f0f', '市辖区', 'pub', '620101', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2910', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833939de0f10', '城关区', 'pub', '620102', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2911', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833939ee0f11', '七里河区', 'pub', '620103', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2912', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833939fe0f12', '西固区', 'pub', '620104', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2913', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393a090f13', '安宁区', 'pub', '620105', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2914', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393a140f14', '红古区', 'pub', '620111', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2915', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393a210f15', '永登县', 'pub', '620121', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2916', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393a310f16', '皋兰县', 'pub', '620122', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2917', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393a3d0f17', '榆中县', 'pub', '620123', 'ukewo', null, '297e1e874f83129d014f83350c7b0373', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', '0', '2918', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393b930f18', '市辖区', 'pub', '620201', 'ukewo', null, '297e1e874f83129d014f83350c890374', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2919', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393bbf0f19', '市辖区', 'pub', '620301', 'ukewo', null, '297e1e874f83129d014f83350c960375', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2920', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393bcf0f1a', '金川区', 'pub', '620302', 'ukewo', null, '297e1e874f83129d014f83350c960375', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2921', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393bdc0f1b', '永昌县', 'pub', '620321', 'ukewo', null, '297e1e874f83129d014f83350c960375', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2922', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c030f1c', '市辖区', 'pub', '620401', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2923', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c0f0f1d', '白银区', 'pub', '620402', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2924', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c610f1e', '平川区', 'pub', '620403', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2925', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c710f1f', '靖远县', 'pub', '620421', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2926', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c840f20', '会宁县', 'pub', '620422', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2927', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393c900f21', '景泰县', 'pub', '620423', 'ukewo', null, '297e1e874f83129d014f83350ca40376', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2928', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393cb70f22', '市辖区', 'pub', '620501', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2929', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393df00f23', '秦城区', 'pub', '620502', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2930', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e030f24', '北道区', 'pub', '620503', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2931', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e130f25', '清水县', 'pub', '620521', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2932', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e1f0f26', '秦安县', 'pub', '620522', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2933', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e2c0f27', '甘谷县', 'pub', '620523', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2934', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e3c0f28', '武山县', 'pub', '620524', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2935', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e4a0f29', '张家川回族自治县', 'pub', '620525', 'ukewo', null, '297e1e874f83129d014f83350cb10377', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2936', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e720f2a', '市辖区', 'pub', '620601', 'ukewo', null, '297e1e874f83129d014f83350cc20378', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', '0', '2937', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e800f2b', '凉州区', 'pub', '620602', 'ukewo', null, '297e1e874f83129d014f83350cc20378', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2938', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e8c0f2c', '民勤县', 'pub', '620621', 'ukewo', null, '297e1e874f83129d014f83350cc20378', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2939', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393e990f2d', '古浪县', 'pub', '620622', 'ukewo', null, '297e1e874f83129d014f83350cc20378', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2940', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393ea60f2e', '天祝藏族自治县', 'pub', '620623', 'ukewo', null, '297e1e874f83129d014f83350cc20378', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2941', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83393ff70f2f', '市辖区', 'pub', '620701', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2942', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940030f30', '甘州区', 'pub', '620702', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2943', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339400e0f31', '肃南裕固族自治县', 'pub', '620721', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2944', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339401a0f32', '民乐县', 'pub', '620722', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2945', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940280f33', '临泽县', 'pub', '620723', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2946', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940330f34', '高台县', 'pub', '620724', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2947', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940440f35', '山丹县', 'pub', '620725', 'ukewo', null, '297e1e874f83129d014f83350cd10379', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2948', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339406b0f36', '市辖区', 'pub', '620801', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2949', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940790f37', '崆峒区', 'pub', '620802', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2950', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339408e0f38', '泾川县', 'pub', '620821', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2951', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339409a0f39', '灵台县', 'pub', '620822', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2952', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833940a70f3a', '崇信县', 'pub', '620823', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2953', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833941e00f3c', '华亭县', 'pub', '620824', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2954', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833941ec0f3d', '庄浪县', 'pub', '620825', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2955', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833941f80f3e', '静宁县', 'pub', '620826', 'ukewo', null, '297e1e874f83129d014f83350cde037a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2956', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833942210f3f', '市辖区', 'pub', '620901', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2957', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339422e0f40', '肃州区', 'pub', '620902', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2958', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339423b0f41', '金塔县', 'pub', '620921', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2959', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339424a0f42', '安西县', 'pub', '620922', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2960', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833942580f43', '肃北蒙古族自治县', 'pub', '620923', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', '0', '2961', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833942640f44', '阿克塞哈萨克族自治县', 'pub', '620924', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2962', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833942700f45', '玉门市', 'pub', '620981', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2963', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339427b0f46', '敦煌市', 'pub', '620982', 'ukewo', null, '297e1e874f83129d014f83350cec037b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2964', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833943cf0f47', '市辖区', 'pub', '621001', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2965', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833943db0f48', '西峰区', 'pub', '621002', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2966', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833943e70f49', '庆城县', 'pub', '621021', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2967', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833943f30f4a', '环　县', 'pub', '621022', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2968', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833943ff0f4b', '华池县', 'pub', '621023', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2969', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339440a0f4c', '合水县', 'pub', '621024', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2970', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339441c0f4d', '正宁县', 'pub', '621025', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2971', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339442c0f4e', '宁　县', 'pub', '621026', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2972', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833944390f4f', '镇原县', 'pub', '621027', 'ukewo', null, '297e1e874f83129d014f83350cf9037c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2973', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833944620f50', '市辖区', 'pub', '621101', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2974', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339446e0f51', '安定区', 'pub', '621102', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2975', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833945be0f52', '通渭县', 'pub', '621121', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2976', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833945e30f53', '陇西县', 'pub', '621122', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2977', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339460d0f54', '渭源县', 'pub', '621123', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2978', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339461b0f55', '临洮县', 'pub', '621124', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2979', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946270f56', '漳　县', 'pub', '621125', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2980', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946350f57', '岷　县', 'pub', '621126', 'ukewo', null, '297e1e874f83129d014f83350d09037d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', '0', '2981', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339465a0f58', '市辖区', 'pub', '621201', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2982', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946690f59', '武都区', 'pub', '621202', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2983', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946760f5a', '成　县', 'pub', '621221', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2984', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946820f5b', '文　县', 'pub', '621222', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2985', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339469a0f5c', '宕昌县', 'pub', '621223', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2986', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946aa0f5d', '康　县', 'pub', '621224', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2987', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946b80f5e', '西和县', 'pub', '621225', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2988', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946c60f5f', '礼　县', 'pub', '621226', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2989', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946d20f60', '徽　县', 'pub', '621227', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2990', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833946e00f61', '两当县', 'pub', '621228', 'ukewo', null, '297e1e874f83129d014f83350d19037e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2991', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948360f62', '临夏市', 'pub', '622901', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2992', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948470f63', '临夏县', 'pub', '622921', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2993', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948540f64', '康乐县', 'pub', '622922', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2994', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948600f65', '永靖县', 'pub', '622923', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2995', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339486d0f66', '广河县', 'pub', '622924', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2996', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339487a0f67', '和政县', 'pub', '622925', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2997', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948860f68', '东乡族自治县', 'pub', '622926', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2998', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948910f69', '积石山保安族东乡族撒拉族自治县', 'pub', '622927', 'ukewo', null, '297e1e874f83129d014f83350e53037f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '2999', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948be0f6a', '合作市', 'pub', '623001', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3000', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948ca0f6b', '临潭县', 'pub', '623021', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3001', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833948d40f6c', '卓尼县', 'pub', '623022', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3002', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a0c0f6d', '舟曲县', 'pub', '623023', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3003', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a1a0f6e', '迭部县', 'pub', '623024', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3004', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a280f6f', '玛曲县', 'pub', '623025', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', '0', '3005', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a330f70', '碌曲县', 'pub', '623026', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3006', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a400f71', '夏河县', 'pub', '623027', 'ukewo', null, '297e1e874f83129d014f83350e600380', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3007', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a660f72', '市辖区', 'pub', '630101', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3008', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a730f73', '城东区', 'pub', '630102', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3009', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a820f74', '城中区', 'pub', '630103', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3010', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a8e0f75', '城西区', 'pub', '630104', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3011', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394a9a0f76', '城北区', 'pub', '630105', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3012', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394aa60f77', '大通回族土族自治县', 'pub', '630121', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3013', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394ab50f78', '湟中县', 'pub', '630122', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3014', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394bee0f79', '湟源县', 'pub', '630123', 'ukewo', null, '297e1e874f83129d014f83350e890381', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3015', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c130f7a', '平安县', 'pub', '632121', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3016', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c1f0f7b', '民和回族土族自治县', 'pub', '632122', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3017', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c2b0f7c', '乐都县', 'pub', '632123', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3018', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c350f7d', '互助土族自治县', 'pub', '632126', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3019', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c440f7e', '化隆回族自治县', 'pub', '632127', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3020', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c4f0f7f', '循化撒拉族自治县', 'pub', '632128', 'ukewo', null, '297e1e874f83129d014f83350e990382', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3021', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c770f80', '门源回族自治县', 'pub', '632221', 'ukewo', null, '297e1e874f83129d014f83350ea80383', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3022', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c840f81', '祁连县', 'pub', '632222', 'ukewo', null, '297e1e874f83129d014f83350ea80383', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3023', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c8f0f82', '海晏县', 'pub', '632223', 'ukewo', null, '297e1e874f83129d014f83350ea80383', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3024', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394c9d0f83', '刚察县', 'pub', '632224', 'ukewo', null, '297e1e874f83129d014f83350ea80383', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3025', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394df30f84', '同仁县', 'pub', '632321', 'ukewo', null, '297e1e874f83129d014f83350eb90384', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3026', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394dff0f85', '尖扎县', 'pub', '632322', 'ukewo', null, '297e1e874f83129d014f83350eb90384', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3027', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e0a0f86', '泽库县', 'pub', '632323', 'ukewo', null, '297e1e874f83129d014f83350eb90384', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3028', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e160f87', '河南蒙古族自治县', 'pub', '632324', 'ukewo', null, '297e1e874f83129d014f83350eb90384', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', '0', '3029', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e410f88', '共和县', 'pub', '632521', 'ukewo', null, '297e1e874f83129d014f83350ec60385', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3030', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e4e0f89', '同德县', 'pub', '632522', 'ukewo', null, '297e1e874f83129d014f83350ec60385', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3031', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e5a0f8a', '贵德县', 'pub', '632523', 'ukewo', null, '297e1e874f83129d014f83350ec60385', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3032', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e660f8b', '兴海县', 'pub', '632524', 'ukewo', null, '297e1e874f83129d014f83350ec60385', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3033', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e720f8c', '贵南县', 'pub', '632525', 'ukewo', null, '297e1e874f83129d014f83350ec60385', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3034', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394e9d0f8d', '玛沁县', 'pub', '632621', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3035', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394fd70f8e', '班玛县', 'pub', '632622', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3036', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394fe10f8f', '甘德县', 'pub', '632623', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3037', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394fec0f90', '达日县', 'pub', '632624', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3038', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83394ff80f91', '久治县', 'pub', '632625', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3039', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833950030f92', '玛多县', 'pub', '632626', 'ukewo', null, '297e1e874f83129d014f83350ed80386', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3040', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339502e0f93', '玉树县', 'pub', '632721', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3041', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339503a0f94', '杂多县', 'pub', '632722', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3042', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833950460f95', '称多县', 'pub', '632723', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3043', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833950520f96', '治多县', 'pub', '632724', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3044', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339505f0f97', '囊谦县', 'pub', '632725', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3045', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339506f0f98', '曲麻莱县', 'pub', '632726', 'ukewo', null, '297e1e874f83129d014f83350ee90387', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3046', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833951db0f99', '格尔木市', 'pub', '632801', 'ukewo', null, '297e1e874f83129d014f83350efd0388', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3047', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833951e80f9a', '德令哈市', 'pub', '632802', 'ukewo', null, '297e1e874f83129d014f83350efd0388', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3048', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833951f50f9b', '乌兰县', 'pub', '632821', 'ukewo', null, '297e1e874f83129d014f83350efd0388', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', '0', '3049', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833952020f9c', '都兰县', 'pub', '632822', 'ukewo', null, '297e1e874f83129d014f83350efd0388', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3050', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339520e0f9d', '天峻县', 'pub', '632823', 'ukewo', null, '297e1e874f83129d014f83350efd0388', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3051', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833952400f9e', '市辖区', 'pub', '640101', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3052', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339524d0f9f', '兴庆区', 'pub', '640104', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3053', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339525a0fa0', '西夏区', 'pub', '640105', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3054', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833952660fa1', '金凤区', 'pub', '640106', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3055', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833952730fa2', '永宁县', 'pub', '640121', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3056', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833952820fa3', '贺兰县', 'pub', '640122', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3057', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339528f0fa4', '灵武市', 'pub', '640181', 'ukewo', null, '297e1e874f83129d014f83350f24038a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3058', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833953e30fa5', '市辖区', 'pub', '640201', 'ukewo', null, '297e1e874f83129d014f8335105f038b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3059', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833953f10fa6', '大武口区', 'pub', '640202', 'ukewo', null, '297e1e874f83129d014f8335105f038b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3060', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833953ff0fa7', '惠农区', 'pub', '640205', 'ukewo', null, '297e1e874f83129d014f8335105f038b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3061', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339540f0fa8', '平罗县', 'pub', '640221', 'ukewo', null, '297e1e874f83129d014f8335105f038b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3062', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339543f0fa9', '市辖区', 'pub', '640301', 'ukewo', null, '297e1e874f83129d014f8335106f038c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3063', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339544b0faa', '利通区', 'pub', '640302', 'ukewo', null, '297e1e874f83129d014f8335106f038c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3064', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954590fab', '盐池县', 'pub', '640323', 'ukewo', null, '297e1e874f83129d014f8335106f038c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3065', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954670fac', '同心县', 'pub', '640324', 'ukewo', null, '297e1e874f83129d014f8335106f038c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3066', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954740fad', '青铜峡市', 'pub', '640381', 'ukewo', null, '297e1e874f83129d014f8335106f038c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3067', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339549d0fae', '市辖区', 'pub', '640401', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3068', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954a80faf', '原州区', 'pub', '640402', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3069', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954b70fb0', '西吉县', 'pub', '640422', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3070', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833954c30fb1', '隆德县', 'pub', '640423', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', '0', '3071', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833955fc0fb3', '泾源县', 'pub', '640424', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3072', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833956080fb4', '彭阳县', 'pub', '640425', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3073', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833956370fb5', '市辖区', 'pub', '640501', 'ukewo', null, '297e1e874f83129d014f83351091038e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3074', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833956450fb6', '沙坡头区', 'pub', '640502', 'ukewo', null, '297e1e874f83129d014f83351091038e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3075', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833956540fb7', '中宁县', 'pub', '640521', 'ukewo', null, '297e1e874f83129d014f83351091038e', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3076', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833956810fb8', '海原县', 'pub', '640522', 'ukewo', null, '297e1e874f83129d014f83351081038d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3077', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833957de0fb9', '市辖区', 'pub', '650101', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3078', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833957eb0fba', '天山区', 'pub', '650102', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3079', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833957fb0fbb', '沙依巴克区', 'pub', '650103', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3080', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958090fbc', '新市区', 'pub', '650104', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3081', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958170fbd', '水磨沟区', 'pub', '650105', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3082', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958260fbe', '头屯河区', 'pub', '650106', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3083', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958360fbf', '达坂城区', 'pub', '650107', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3084', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958440fc0', '东山区', 'pub', '650108', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3085', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958520fc1', '乌鲁木齐县', 'pub', '650121', 'ukewo', null, '297e1e874f83129d014f833510c5038f', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3086', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958830fc2', '市辖区', 'pub', '650201', 'ukewo', null, '297e1e874f83129d014f833510d30390', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3087', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958910fc3', '独山子区', 'pub', '650202', 'ukewo', null, '297e1e874f83129d014f833510d30390', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3088', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958a20fc4', '克拉玛依区', 'pub', '650203', 'ukewo', null, '297e1e874f83129d014f833510d30390', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3089', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833958be0fc5', '白碱滩区', 'pub', '650204', 'ukewo', null, '297e1e874f83129d014f833510d30390', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', '0', '3090', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833959f70fc6', '乌尔禾区', 'pub', '650205', 'ukewo', null, '297e1e874f83129d014f833510d30390', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3091', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a280fc7', '吐鲁番市', 'pub', '652101', 'ukewo', null, '297e1e874f83129d014f833510e90391', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3092', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a350fc8', '鄯善县', 'pub', '652122', 'ukewo', null, '297e1e874f83129d014f833510e90391', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3093', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a420fc9', '托克逊县', 'pub', '652123', 'ukewo', null, '297e1e874f83129d014f833510e90391', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3094', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a6a0fca', '哈密市', 'pub', '652201', 'ukewo', null, '297e1e874f83129d014f833510fa0392', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3095', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a760fcb', '巴里坤哈萨克自治县', 'pub', '652222', 'ukewo', null, '297e1e874f83129d014f833510fa0392', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3096', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395a840fcc', '伊吾县', 'pub', '652223', 'ukewo', null, '297e1e874f83129d014f833510fa0392', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3097', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395ab30fcd', '昌吉市', 'pub', '652301', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3098', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395ac10fce', '阜康市', 'pub', '652302', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3099', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395bfa0fcf', '米泉市', 'pub', '652303', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3100', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395c070fd0', '呼图壁县', 'pub', '652323', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3101', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395c140fd1', '玛纳斯县', 'pub', '652324', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3102', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395c230fd2', '奇台县', 'pub', '652325', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3103', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395c300fd3', '吉木萨尔县', 'pub', '652327', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3104', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395c3f0fd4', '木垒哈萨克自治县', 'pub', '652328', 'ukewo', null, '297e1e874f83129d014f833511050393', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3105', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395d2e0fd5', '博乐市', 'pub', '652701', 'ukewo', null, '297e1e874f83129d014f8335111a0394', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3106', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395d3c0fd6', '精河县', 'pub', '652722', 'ukewo', null, '297e1e874f83129d014f8335111a0394', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3107', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395d4e0fd7', '温泉县', 'pub', '652723', 'ukewo', null, '297e1e874f83129d014f8335111a0394', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', '0', '3108', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395f570fd8', '库尔勒市', 'pub', '652801', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3109', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395f670fd9', '轮台县', 'pub', '652822', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3110', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395f7c0fda', '尉犁县', 'pub', '652823', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3111', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395f890fdb', '若羌县', 'pub', '652824', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3112', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395f990fdc', '且末县', 'pub', '652825', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3113', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395faa0fdd', '焉耆回族自治县', 'pub', '652826', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3114', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83395fb80fde', '和静县', 'pub', '652827', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3115', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833960d30fdf', '和硕县', 'pub', '652828', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3116', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833960e30fe0', '博湖县', 'pub', '652829', 'ukewo', null, '297e1e874f83129d014f833511280395', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', '0', '3117', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833962dc0fe1', '阿克苏市', 'pub', '652901', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3118', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833962eb0fe2', '温宿县', 'pub', '652922', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3119', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833962fd0fe3', '库车县', 'pub', '652923', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3120', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339630a0fe4', '沙雅县', 'pub', '652924', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3121', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833963190fe5', '新和县', 'pub', '652925', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3122', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339632b0fe6', '拜城县', 'pub', '652926', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3123', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339633d0fe7', '乌什县', 'pub', '652927', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3124', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339634f0fe8', '阿瓦提县', 'pub', '652928', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3125', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339646a0fe9', '柯坪县', 'pub', '652929', 'ukewo', null, '297e1e874f83129d014f833512b80396', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', '0', '3126', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339659f0fea', '阿图什市', 'pub', '653001', 'ukewo', null, '297e1e874f83129d014f833512c90397', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3127', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833965ac0feb', '阿克陶县', 'pub', '653022', 'ukewo', null, '297e1e874f83129d014f833512c90397', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3128', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833966d10fec', '阿合奇县', 'pub', '653023', 'ukewo', null, '297e1e874f83129d014f833512c90397', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3129', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833966df0fed', '乌恰县', 'pub', '653024', 'ukewo', null, '297e1e874f83129d014f833512c90397', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3130', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339681b0fee', '喀什市', 'pub', '653101', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3131', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833968dc0ff0', '疏附县', 'pub', '653121', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3132', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833968eb0ff1', '疏勒县', 'pub', '653122', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3133', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833968f90ff2', '英吉沙县', 'pub', '653123', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3134', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969090ff3', '泽普县', 'pub', '653124', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3135', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969190ff4', '莎车县', 'pub', '653125', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3136', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339692e0ff5', '叶城县', 'pub', '653126', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3137', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969400ff6', '麦盖提县', 'pub', '653127', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3138', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339694e0ff7', '岳普湖县', 'pub', '653128', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3139', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f8339695b0ff8', '伽师县', 'pub', '653129', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3140', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969690ff9', '巴楚县', 'pub', '653130', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', '0', '3141', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969760ffa', '塔什库尔干塔吉克自治县', 'pub', '653131', 'ukewo', null, '297e1e874f83129d014f833512e50398', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3142', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969a80ffb', '和田市', 'pub', '653201', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3143', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969b60ffc', '和田县', 'pub', '653221', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3144', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969c40ffd', '墨玉县', 'pub', '653222', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3145', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969d40ffe', '皮山县', 'pub', '653223', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3146', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969e00fff', '洛浦县', 'pub', '653224', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3147', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969ee1000', '策勒县', 'pub', '653225', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3148', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f833969fe1001', '于田县', 'pub', '653226', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3149', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a0b1002', '民丰县', 'pub', '653227', 'ukewo', null, '297e1e874f83129d014f833512f60399', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3150', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a3d1003', '伊宁市', 'pub', '654002', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3151', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a4a1004', '奎屯市', 'pub', '654003', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3152', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a581005', '伊宁县', 'pub', '654021', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3153', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a661006', '察布查尔锡伯自治县', 'pub', '654022', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3154', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a771007', '霍城县', 'pub', '654023', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3155', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a841008', '巩留县', 'pub', '654024', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3156', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396a951009', '新源县', 'pub', '654025', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3157', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396aa8100a', '昭苏县', 'pub', '654026', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3158', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396ab6100b', '特克斯县', 'pub', '654027', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3159', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396acc100c', '尼勒克县', 'pub', '654028', 'ukewo', null, '297e1e874f83129d014f8335130a039a', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3160', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396afc100d', '塔城市', 'pub', '654201', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3161', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b09100e', '乌苏市', 'pub', '654202', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3162', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b17100f', '额敏县', 'pub', '654221', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3163', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b261010', '沙湾县', 'pub', '654223', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3164', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b341011', '托里县', 'pub', '654224', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3165', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b491012', '裕民县', 'pub', '654225', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3166', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b591013', '和布克赛尔蒙古自治县', 'pub', '654226', 'ukewo', null, '297e1e874f83129d014f8335131d039b', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3167', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b851014', '阿勒泰市', 'pub', '654301', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3168', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396b941015', '布尔津县', 'pub', '654321', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3169', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396ba31016', '富蕴县', 'pub', '654322', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3170', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396bb31017', '福海县', 'pub', '654323', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3171', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396bc61018', '哈巴河县', 'pub', '654324', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3172', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396bd61019', '青河县', 'pub', '654325', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3173', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396be4101a', '吉木乃县', 'pub', '654326', 'ukewo', null, '297e1e874f83129d014f83351330039c', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3174', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396c13101b', '石河子市', 'pub', '659001', 'ukewo', null, '297e1e874f83129d014f83351347039d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3175', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396c20101c', '阿拉尔市', 'pub', '659002', 'ukewo', null, '297e1e874f83129d014f83351347039d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3176', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396c2e101d', '图木舒克市', 'pub', '659003', 'ukewo', null, '297e1e874f83129d014f83351347039d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3177', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e1e874f83129d014f83396c3d101e', '五家渠市', 'pub', '659004', 'ukewo', null, '297e1e874f83129d014f83351347039d', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', '0', '3178', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e63f05d1da6be015d1dae6de20002', '系统模板分类', 'pub', 'com.dic.system.template', null, 'resu', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-07-07 23:32:36', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('297e63f05d1da6be015d1daee82c0003', '麻将游戏', 'pub', 'majiang', 'ukewo', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-07-07 23:33:08', '2017-07-07 23:33:08', '0', '1', '297e63f05d1da6be015d1dae6de20002', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61df005e0161dffce40b0000', '商城商品分类', 'pub', 'com.dic.shop.warestype', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-01 13:15:48', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61df005e0161dffe1e800001', '金币', 'pub', 'goldcoins', 'beimi', 'hall', '4028811b61df005e0161dffce40b0000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-01 13:17:09', '2018-03-01 13:17:09', '0', '1', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61df005e0161dffe1e900002', '钻石', 'pub', 'diamonds', 'beimi', null, '4028811b61df005e0161dffce40b0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-01 13:17:09', '2018-03-01 13:17:09', '0', '2', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61df005e0161dffe1e9e0003', '道具', 'pub', 'prop', 'beimi', 'hall', '4028811b61df005e0161dffce40b0000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-01 13:17:09', '2018-03-01 13:17:09', '1', '3', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f43a25fc0000', '商品推荐类型', 'pub', 'com.dic.shop.recomtyped', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 11:35:07', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f43aa68c0001', '最新商品', 'pub', '01', 'beimi', null, '4028811b61f418a40161f43a25fc0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 11:35:40', '2018-03-05 11:35:40', '0', '1', '4028811b61f418a40161f43a25fc0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f43aa6a70002', '特价商品', 'pub', '02', 'beimi', null, '4028811b61f418a40161f43a25fc0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 11:35:40', '2018-03-05 11:35:40', '0', '2', '4028811b61f418a40161f43a25fc0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f43aa6b50003', '热卖商品', 'pub', '03', 'beimi', null, '4028811b61f418a40161f43a25fc0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 11:35:40', '2018-03-05 11:35:40', '0', '3', '4028811b61f418a40161f43a25fc0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f43aa6c20004', '推荐商品', 'pub', '04', 'beimi', null, '4028811b61f418a40161f43a25fc0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 11:35:40', '2018-03-05 11:35:40', '0', '4', '4028811b61f418a40161f43a25fc0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46d3b4b0005', '商品支付方式', 'pub', 'com.dic.shop.payment', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:30:55', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1f670006', '金币支付', 'pub', '01', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '1', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1f7b0007', '钻石支付', 'pub', '02', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '2', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1f890008', '货币支付', 'pub', '03', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '3', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1f960009', '房卡支付', 'pub', '04', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '4', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1fa0000a', '券支付', 'pub', '05', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '5', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f418a40161f46e1fb1000b', '其他支付', 'pub', '06', 'beimi', 'hall', '4028811b61f418a40161f46d3b4b0005', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 12:31:53', '2018-03-05 12:31:53', '0', '6', '4028811b61f418a40161f46d3b4b0005', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244860000', '一小堆金币', 'pub', 'g_01', 'beimi', 'hall', '4028811b61df005e0161dffe1e800001', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '1', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244ba0001', '一大堆金币', 'pub', 'g_02', 'beimi', 'hall', '4028811b61df005e0161dffe1e800001', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '2', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244ca0002', '一小袋金币', 'pub', 'g_03', 'beimi', 'hall', '4028811b61df005e0161dffe1e800001', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '3', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244d80003', '一大袋金币', 'pub', 'g_04', 'beimi', 'hall', '4028811b61df005e0161dffe1e800001', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '4', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244e50004', '两大袋金币', 'pub', 'g_05', 'beimi', 'hall', '4028811b61df005e0161dffe1e800001', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '5', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57244f80005', '一箱金币', 'pub', 'g_06', 'beimi', null, '4028811b61df005e0161dffe1e800001', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:16:02', '2018-03-05 17:16:02', '0', '6', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351ad0006', '一小堆钻石', 'pub', 'd_01', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '1', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351bc0007', '一大堆钻石', 'pub', 'd_02', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '2', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351c60008', '一小袋钻石', 'pub', 'd_03', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '3', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351d60009', '一大袋钻石', 'pub', 'd_04', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '4', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351e5000a', '两大袋钻石', 'pub', 'd_05', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '5', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b61f531d70161f57351f8000b', '一箱钻石', 'pub', 'd_06', 'beimi', null, '4028811b61df005e0161dffe1e900002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-05 17:17:11', '2018-03-05 17:17:11', '0', '6', '4028811b61df005e0161dffce40b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b6208f51d01620a1943610000', '福利类型', 'pub', 'com.dic.game.welfare.type', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2018-03-09 17:30:51', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b6208f51d01620a1a47000001', '每日幸运轮盘', 'pub', 'turn', 'beimi', 'hall', '4028811b6208f51d01620a1943610000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-09 17:31:57', '2018-03-09 17:31:57', '0', '1', '4028811b6208f51d01620a1943610000', '1', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b6208f51d01620a1a47180002', '每日救济金', 'pub', 'over', 'beimi', 'hall', '4028811b6208f51d01620a1943610000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-09 17:31:57', '2018-03-09 17:31:57', '0', '2', '4028811b6208f51d01620a1943610000', '1', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028811b6208f51d01620a1a47350004', '连续七天签到', 'pub', 'sign', 'beimi', 'hall', '4028811b6208f51d01620a1943610000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2018-03-09 17:31:57', '2018-03-09 17:31:57', '0', '4', '4028811b6208f51d01620a1943610000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972b6f10003', '玩家类型', 'pub', 'com.dic.contacts.entype', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:33', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d48d0004', '普通客户', 'pub', '01', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '1', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d4970005', 'VIP客户', 'pub', '02', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '2', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d49e0006', '老客户', 'pub', '03', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '3', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d4b50007', '代理商', 'pub', '04', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '4', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d4bf0008', '供货商', 'pub', '05', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '5', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d4c80009', '合作伙伴', 'pub', '06', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '6', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5ae97036015ae972d4d1000a', '其它', 'pub', '07', 'ukewo', null, '4028838b5ae97036015ae972b6f10003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', '0', '7', '4028838b5ae97036015ae972b6f10003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5aeba14b015aebbbceea0008', '三沙市', 'pub', '460300', 'ukewo', null, '297e1e874f83129d014f832155f300d7', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-03-20 20:40:38', '2017-03-20 20:40:38', '0', '1', '297e1e874f83129d014f832090e200b8', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5b565caf015b566d11d80010', '标签类型', 'pub', 'com.dic.tag.type', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:00', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5b565caf015b566de3180011', '咨询客户', 'pub', 'user', 'ukewo', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:53', '2017-04-10 13:54:53', '0', '1', '4028838b5b565caf015b566d11d80010', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028838b5b565caf015b566de32a0012', '工单', 'pub', 'workorders', 'ukewo', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:53', '2017-04-10 13:54:53', '0', '2', '4028838b5b565caf015b566d11d80010', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f07827e0002', '智能机器人输入条件', 'pub', 'com.dic.xiaoe.input', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:20:40', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f07c6190003', '智能机器人输出条件', 'pub', 'com.dic.xiaoe.output', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:20:57', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f083d010004', '姓名', 'pub', '01', 'ukewo', null, '402888815c2e2f66015c2f07827e0002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', '0', '1', '402888815c2e2f66015c2f07827e0002', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f083d180005', '性别', 'pub', '02', 'ukewo', null, '402888815c2e2f66015c2f07827e0002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', '0', '2', '402888815c2e2f66015c2f07827e0002', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f083d250006', '年龄', 'pub', '03', 'ukewo', null, '402888815c2e2f66015c2f07827e0002', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', '0', '3', '402888815c2e2f66015c2f07827e0002', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f087e510007', '姓名', 'pub', '01', 'ukewo', null, '402888815c2e2f66015c2f07c6190003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:44', '2017-05-22 15:21:44', '0', '1', '402888815c2e2f66015c2f07c6190003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815c2e2f66015c2f087e660008', '年龄', 'pub', '02', 'ukewo', null, '402888815c2e2f66015c2f07c6190003', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:44', '2017-05-22 15:21:44', '0', '2', '402888815c2e2f66015c2f07c6190003', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815cf217cd015cf219f9f80002', '呼叫中心服务类型', 'pub', 'ccsummary', 'ukewo', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-06-29 12:26:47', null, '1', '0', '4028838b5b565caf015b566d11d80010', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815d2fe37f015d2fe75cc80002', '系统权限资源数据', 'pub', 'com.dic.auth.resource', null, 'auth', '0', '系统权限资源数据', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-07-11 12:27:58', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815d55aa7d015d55b869740002', '全部联系人', 'pub', 'A', null, 'auth', '402888815d2fe37f015d2fe75cc80002', null, null, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe612;</i>', null, null, '297e8c7b455798280145579c73e501c1', '2017-07-18 20:42:15', null, '0', '0', '402888815d2fe37f015d2fe75cc80002', '0', '0', '/apps/contacts/index.html', 'webim', '1', null, 'left');
INSERT INTO `bm_sysdic` VALUES ('402888815d55aa7d015d55b88b9b0003', '全部客户', 'pub', 'B', null, 'auth', '402888815d2fe37f015d2fe75cc80002', null, null, '<i class=\"kfont\" style=\"position: relative;\">&#xe650;</i>', null, null, '297e8c7b455798280145579c73e501c1', '2017-07-18 20:42:24', null, '0', '0', '402888815d2fe37f015d2fe75cc80002', '0', '0', '/apps/customer/index.html', 'webim', '1', null, 'left');
INSERT INTO `bm_sysdic` VALUES ('402888815d55aa7d015d55b8bb110004', '客服设置', 'pub', 'C', null, 'auth', '402888815d2fe37f015d2fe75cc80002', null, null, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', null, null, '297e8c7b455798280145579c73e501c1', '2017-07-18 20:42:36', null, '0', '0', '402888815d2fe37f015d2fe75cc80002', '0', '0', '/setting/agent/index.html', 'webim', '1', 'on', 'left');
INSERT INTO `bm_sysdic` VALUES ('402888815d55aa7d015d55b8e82e0005', '会话历史', 'pub', 'D', null, 'auth', '402888815d2fe37f015d2fe75cc80002', null, null, '<i class=\"kfont\" style=\"position: relative;\">&#xe7eb;</i>', null, null, '297e8c7b455798280145579c73e501c1', '2017-07-18 20:42:47', null, '0', '0', '402888815d2fe37f015d2fe75cc80002', '0', '0', '/service/history/index.html', 'webim', '1', null, 'left');
INSERT INTO `bm_sysdic` VALUES ('402888815d89b1aa015d89b318ab0002', '知识库知识', 'pub', 'kbs', 'ukewo', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-07-28 22:56:42', '2017-07-28 22:56:42', '0', '1', '4028838b5b565caf015b566d11d80010', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e0521d8015e0522f03b0000', '游戏类型', 'pub', 'com.dic.game.type', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-08-21 22:12:09', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e0521d8015e052341f70001', '麻将', 'pub', 'majiang', 'beimi', 'hall', '402888815e0521d8015e0522f03b0000', '', null, '/images/majiang.jpg', '', null, '297e8c7b455798280145579c73e501c1', '2017-08-21 22:12:30', '2017-08-21 22:12:30', '0', '1', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e0521d8015e052342080002', '斗地主', 'pub', 'dizhu', 'beimi', 'hall', '402888815e0521d8015e0522f03b0000', '', null, '/images/dizhu.jpg', '', null, '297e8c7b455798280145579c73e501c1', '2017-08-21 22:12:30', '2017-08-21 22:12:30', '0', '2', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e14abfb015e14b5f6570000', '血战到底', 'pub', 'end', 'beimi', null, '402888815e0521d8015e052341f70001', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-08-24 22:47:03', '2017-08-24 22:47:03', '0', '1', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e14abfb015e14b5f6840001', '血流成河', 'pub', 'river', 'beimi', null, '402888815e0521d8015e052341f70001', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-08-24 22:47:03', '2017-08-24 22:47:03', '0', '2', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e14abfb015e14b6e2080002', '经典玩法', 'pub', 'basic', 'beimi', 'layui-icon', '402888815e0521d8015e052342080002', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-08-24 22:48:03', '2017-08-24 22:48:03', '0', '1', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e695788015e697647d80000', '游戏场景', 'pub', 'com.dic.scene.item', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-09-10 09:45:13', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e695788015e69766fe90001', '斗地主', 'pub', 'dizhu', 'beimi', null, '402888815e695788015e697647d80000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-09-10 09:45:23', '2017-09-10 09:45:23', '0', '1', '402888815e695788015e697647d80000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815e6f0177015e7151ccd60000', '麻将', 'pub', 'majiang', 'beimi', 'layui-icon', '402888815e695788015e697647d80000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-09-11 22:22:20', null, '1', '0', '402888815e695788015e697647d80000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815fdd8418015fdecb921a0000', '游戏模式', 'pub', 'com.dic.game.model', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-11-21 21:36:44', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815fdd8418015fdecbf5fe0001', '大厅模式', 'pub', 'hall', 'beimi', null, '402888815fdd8418015fdecb921a0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-11-21 21:37:10', '2017-11-21 21:37:10', '0', '1', '402888815fdd8418015fdecb921a0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815fdd8418015fdecbf6150002', '房卡模式', 'pub', 'room', 'beimi', null, '402888815fdd8418015fdecb921a0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-11-21 21:37:10', '2017-11-21 21:37:10', '0', '2', '402888815fdd8418015fdecb921a0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815fe3f44a015feba097ce0000', '房卡', 'pub', 'createroom', 'beimi', 'room', '402888815e0521d8015e0522f03b0000', '', null, '/images/room.jpg', '', null, '297e8c7b455798280145579c73e501c1', '2017-11-24 09:24:51', null, '1', '0', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888815fe3f44a015feba50c940001', '房卡模式', 'pub', 'createroom', 'beimi', 'room', '402888815fe3f44a015feba097ce0000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-11-24 09:29:43', null, '1', '0', '402888815e0521d8015e0522f03b0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b509af0000', '房卡游戏标题', 'pub', 'com.dic.game.room.title', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:25:32', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b54fb50001', '房间-经典斗地主', 'pub', 'doudizhu', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:25:50', '2017-12-05 11:25:50', '0', '1', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b691080002', '房间-广东麻将', 'pub', 'gdmajiang', 'beimi', 'hall', '402888816024a16a016024b509af0000', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '1', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b6911a0003', '房间-德州扑克', 'pub', 'dezhou', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '2', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b6912b0004', '房间-麻将', 'pub', 'majiang', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '3', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b691380005', '房间-跑胡子', 'pub', 'paohuzi', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '4', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b691500006', '房间-十三水', 'pub', 'shisanshui', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '5', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('402888816024a16a016024b6915a0007', '房间-诈金花', 'pub', 'zhajinhua', 'beimi', null, '402888816024a16a016024b509af0000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-05 11:27:13', '2017-12-05 11:27:13', '0', '6', '402888816024a16a016024b509af0000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f6f17890000', '斗地主牌型', 'pub', 'com.dic.game.dizhu.cardtype', null, 'data', '0', '', null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:24:58', null, '1', '0', null, '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f73870d0004', '三带一', 'pub', '4', 'beimi', null, '40288881602c594201602f6f17890000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:29:49', '2017-12-07 13:29:49', '0', '4', '40288881602c594201602f6f17890000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f7387250005', '三带一对', 'pub', '41', 'beimi', null, '40288881602c594201602f6f17890000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:29:49', '2017-12-07 13:29:49', '0', '5', '40288881602c594201602f6f17890000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f7387590009', '飞机', 'pub', '8', 'beimi', null, '40288881602c594201602f6f17890000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:29:49', '2017-12-07 13:29:49', '0', '9', '40288881602c594201602f6f17890000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f738763000a', '飞机带两对', 'pub', '81', 'beimi', null, '40288881602c594201602f6f17890000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:29:49', '2017-12-07 13:29:49', '0', '10', '40288881602c594201602f6f17890000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('40288881602c594201602f73876e000b', '四带二', 'pub', '9', 'beimi', null, '40288881602c594201602f6f17890000', null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-12-07 13:29:49', '2017-12-07 13:29:49', '0', '11', '40288881602c594201602f6f17890000', '0', '0', null, null, null, null, null);
INSERT INTO `bm_sysdic` VALUES ('4028e3815bafaa94015bafb14edf0002', '服务类型', 'pub', 'summary', 'ukewo', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', null, '', '', null, '297e8c7b455798280145579c73e501c1', '2017-04-27 21:54:44', null, '1', '0', '4028838b5b565caf015b566d11d80010', '0', '0', null, null, null, null, null);

-- ----------------------------
-- Table structure for `bm_systemconfig`
-- ----------------------------
DROP TABLE IF EXISTS `bm_systemconfig`;
CREATE TABLE `bm_systemconfig` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(100) DEFAULT NULL COMMENT '名称',
  `TITLE` varchar(100) DEFAULT NULL COMMENT '标题',
  `CODE` varchar(100) DEFAULT NULL COMMENT '编码',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CTYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '描述',
  `MEMO` varchar(32) DEFAULT NULL,
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `ICONSKIN` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `CATETYPE` varchar(32) DEFAULT NULL COMMENT '分类',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `HASCHILD` tinyint(4) DEFAULT NULL COMMENT '是否有下级',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `DEFAULTVALUE` tinyint(4) DEFAULT NULL COMMENT '默认值',
  `THEME` varchar(50) DEFAULT NULL COMMENT '皮肤',
  `LOGLEVEL` varchar(32) DEFAULT NULL COMMENT '日志级别',
  `ENABLESSL` tinyint(4) DEFAULT NULL COMMENT '启用SSL',
  `JKSFILE` varchar(255) DEFAULT NULL COMMENT 'JKS文件路径',
  `JKSPASSWORD` varchar(255) DEFAULT NULL COMMENT 'JKS密码',
  `MAPKEY` varchar(255) DEFAULT NULL COMMENT '百度地图授权编码',
  `workorders` tinyint(4) DEFAULT NULL COMMENT '启用工单三栏布局',
  `callcenter` tinyint(4) DEFAULT NULL COMMENT '启用呼叫中心',
  `cc_extention` varchar(32) DEFAULT NULL COMMENT '分机',
  `cc_quene` varchar(32) DEFAULT NULL COMMENT '技能组队列',
  `cc_router` varchar(32) DEFAULT NULL COMMENT '路由策略',
  `cc_ivr` varchar(32) DEFAULT NULL COMMENT 'IVR模板',
  `cc_acl` varchar(32) DEFAULT NULL COMMENT '访问列表模板',
  `cc_siptrunk` varchar(32) DEFAULT NULL COMMENT 'SIP配置模板',
  `cc_callcenter` varchar(32) DEFAULT NULL COMMENT '呼叫中心配置',
  `CALLOUT` tinyint(4) DEFAULT NULL COMMENT '是否允许点击号码外呼',
  `AUTH` tinyint(4) DEFAULT NULL COMMENT '启用权限控制',
  UNIQUE KEY `SQL121227155532210` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_systemconfig
-- ----------------------------
INSERT INTO `bm_systemconfig` VALUES ('402883965c12006b015c12013b990002', null, null, null, 'ukewo', null, null, null, null, null, null, null, '297e8c7b455798280145579c73e501c1', '2017-05-17 00:04:49', null, null, null, null, null, '02', 'info', '0', 'catalina.out', '123456', '', '0', '1', '297e63f05d1fac44015d1fadd35f0004', '297e63f05d1fac44015d1fad1b9f0002', '297e63f05d1fac44015d1fae11810005', '297e63f05d1de125015d1df495710002', '297e63f05d1fac44015d1facc9a10001', '297e63f05d1de125015d1df495780003', '297e63f05d1de125015d1df495780003', '1', '0');

-- ----------------------------
-- Table structure for `bm_tableproperties`
-- ----------------------------
DROP TABLE IF EXISTS `bm_tableproperties`;
CREATE TABLE `bm_tableproperties` (
  `ID` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `GROUPID` varchar(255) DEFAULT NULL COMMENT '组ID',
  `USERID` varchar(255) DEFAULT NULL COMMENT '创建人ID',
  `FIELDNAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `DATATYPECODE` int(11) NOT NULL COMMENT '数据类型代码',
  `DATATYPENAME` varchar(255) DEFAULT NULL COMMENT '字段类型名称',
  `DBTABLEID` varchar(255) DEFAULT NULL COMMENT '数据表ID',
  `INDEXDATATYPE` varchar(255) DEFAULT NULL COMMENT '字段类型',
  `PK` smallint(6) DEFAULT NULL COMMENT '是否外键',
  `MODITS` smallint(6) DEFAULT NULL,
  `INDEXFIELD` varchar(32) DEFAULT NULL COMMENT '是否索引',
  `PLUGIN` varchar(32) DEFAULT NULL COMMENT '处理插件',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `FKTABLE` varchar(32) DEFAULT NULL COMMENT '外键表',
  `FKPROPERTY` varchar(32) DEFAULT NULL COMMENT '外键字段',
  `TABLENAME` varchar(255) DEFAULT NULL COMMENT '数据表名称',
  `viewtype` varchar(255) DEFAULT NULL,
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  `SYSTEMFIELD` tinyint(4) DEFAULT NULL COMMENT '系统字段',
  `INX` tinyint(4) DEFAULT NULL COMMENT '索引',
  `TOKEN` tinyint(4) DEFAULT NULL COMMENT '分词',
  `LENGTH` int(11) DEFAULT NULL COMMENT '长度',
  `FIELDSTATUS` tinyint(4) DEFAULT NULL COMMENT '字段状态',
  `SELDATA` tinyint(4) DEFAULT NULL COMMENT '关联字段数据',
  `SELDATACODE` varchar(32) DEFAULT NULL COMMENT '关联字段代码',
  `SELDATAKEY` varchar(32) DEFAULT NULL COMMENT '关联key',
  `SELDATAVALUE` varchar(32) DEFAULT NULL COMMENT '关联字段值',
  `SELDATATYPE` varchar(32) DEFAULT NULL COMMENT '关联类型',
  `REFTBID` varchar(32) DEFAULT NULL COMMENT '引用表ID',
  `REFTPID` varchar(32) DEFAULT NULL COMMENT '引用字段ID',
  `REFTYPE` varchar(32) DEFAULT NULL COMMENT '引用类型',
  `REFTBNAME` varchar(60) DEFAULT NULL COMMENT '引用表名称',
  `REFTPNAME` varchar(60) DEFAULT NULL,
  `REFTPTITLEFIELD` varchar(60) DEFAULT NULL,
  `REFFK` tinyint(4) DEFAULT NULL,
  `DEFAULTSORT` tinyint(4) DEFAULT NULL,
  `DEFAULTVALUE` varchar(255) DEFAULT NULL,
  `DEFAULTVALUETITLE` varchar(255) DEFAULT NULL,
  `DEFAULTFIELDVALUE` varchar(255) DEFAULT NULL,
  `MULTPARTFILE` tinyint(4) DEFAULT NULL,
  `UPLOADTYPE` varchar(255) DEFAULT NULL,
  `cascadetype` varchar(255) DEFAULT NULL,
  `title` tinyint(4) DEFAULT NULL,
  `DESCORDER` tinyint(4) DEFAULT NULL,
  `impfield` tinyint(4) DEFAULT '0',
  `tokentype` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `SQL130112140848940` (`ID`) USING BTREE,
  KEY `FKF8D74787854BC62` (`DBTABLEID`) USING BTREE,
  KEY `FKF8D747811BE44FF` (`FKPROPERTY`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_tableproperties
-- ----------------------------
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a20011', '主键id', null, null, null, 'id', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '32', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a30012', '语言', null, null, null, 'language', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a30013', '用户名', null, null, null, 'username', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a30014', '密码', null, null, null, 'password', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a30015', '安全级别', null, null, null, 'secureconf', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a30016', '邮件', null, null, null, 'email', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a40017', '姓', null, null, null, 'firstname', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a40018', '名', null, null, null, 'midname', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a40019', '名', null, null, null, 'lastname', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a4001a', '职位', null, null, null, 'jobtitle', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a5001b', '部门', null, null, null, 'department', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a5001c', '性别', null, null, null, 'gender', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a5001d', '生日', null, null, null, 'birthday', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a5001e', '昵称', null, null, null, 'nickname', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a6001f', '用户类型', null, null, null, 'usertype', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a60020', '角色', null, null, null, 'rulename', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a60021', '备用', null, null, null, 'searchprojectid', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a60022', '租户id', null, null, null, 'orgi', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '32', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a60023', '创建人', null, null, null, 'creater', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '32', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a70024', '创建时间', null, null, null, 'createtime', '0', 'datetime', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '19', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a70025', '备注', null, null, null, 'memo', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '255', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a70026', '更新时间', null, null, null, 'updatetime', '0', 'datetime', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '19', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a70027', '手机号', null, null, null, 'mobile', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '32', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a80028', '最后 一次密码修改时间', null, null, null, 'passupdatetime', '0', 'datetime', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '19', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a80029', 'sign', null, null, null, 'sign', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '65535', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a8002a', 'del', null, null, null, 'del', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a8002b', 'login', null, null, null, 'login', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a8002c', 'online', null, null, null, 'online', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a9002d', '是否设置头像', null, null, null, 'headimg', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a9002e', '是否设置密保问题', null, null, null, 'secquestion', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a9002f', '玩家等级', null, null, null, 'playerlevel', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '32', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741a90030', '玩家积分', null, null, null, 'experience', '0', 'number', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '10', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0031', 'uname', null, null, null, 'uname', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '100', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0032', 'musteditpassword', null, null, null, 'musteditpassword', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0033', '省份', null, null, null, 'province', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '50', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0034', '城市', null, null, null, 'city', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '50', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0035', '关注人数', null, null, null, 'fans', '0', 'number', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '10', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741aa0036', '被关注次数', null, null, null, 'follows', '0', 'number', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '10', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab0037', 'integral', null, null, null, 'integral', '0', 'number', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '10', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab0038', '最后登录时间', null, null, null, 'lastlogintime', '0', 'datetime', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '19', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab0039', '状态', null, null, null, 'status', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '10', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab003a', '离线时间', null, null, null, 'deactivetime', '0', 'datetime', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '19', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab003b', '标题', null, null, null, 'title', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '50', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);
INSERT INTO `bm_tableproperties` VALUES ('402888815db7065f015db70741ab003c', '数据状态', null, null, null, 'datastatus', '0', 'text', '402888815db7065f015db70741a20010', null, '0', '0', null, null, 'ukewo', null, null, 'bm_playuser', null, '1', '0', '1', '0', '3', '1', '0', null, null, null, '', null, null, null, null, null, null, '0', '0', null, null, null, '1', null, null, '0', '0', '0', null);

-- ----------------------------
-- Table structure for `bm_tabletask`
-- ----------------------------
DROP TABLE IF EXISTS `bm_tabletask`;
CREATE TABLE `bm_tabletask` (
  `ID` varchar(32) NOT NULL DEFAULT '',
  `NAME` varchar(255) DEFAULT NULL,
  `SECURE` varchar(255) DEFAULT NULL,
  `TASKSTATUS` varchar(255) DEFAULT NULL,
  `TABLEDIRID` varchar(255) DEFAULT NULL,
  `DBID` varchar(255) DEFAULT NULL,
  `CODE` varchar(255) DEFAULT NULL,
  `GROUPID` varchar(255) DEFAULT NULL,
  `CREATER` varchar(32) DEFAULT NULL,
  `CREATERNAME` varchar(255) DEFAULT NULL,
  `TASKTYPE` varchar(255) DEFAULT NULL,
  `TASKNAME` varchar(255) DEFAULT NULL,
  `TASKPLAN` varchar(255) DEFAULT NULL,
  `CONFIGURE` varchar(255) DEFAULT NULL,
  `SECURECONF` varchar(255) DEFAULT NULL,
  `USERID` varchar(255) DEFAULT NULL,
  `PREVIEWTEMPLET` text,
  `LISTBLOCKTEMPLET` text,
  `TABLENAME` varchar(255) DEFAULT NULL,
  `TABLETYPE` varchar(255) DEFAULT NULL,
  `STARTINDEX` int(11) NOT NULL,
  `UPDATETIME` datetime DEFAULT NULL,
  `UPDATETIMENUMBER` int(11) NOT NULL,
  `DATASQL` longtext,
  `DATABASETASK` varchar(32) DEFAULT NULL,
  `DRIVERPLUGIN` varchar(32) DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `WORKFLOW` tinyint(10) DEFAULT NULL,
  `FROMDB` tinyint(4) DEFAULT NULL,
  `tabtype` varchar(32) DEFAULT NULL,
  `pid` varchar(32) DEFAULT NULL,
  `secmenuid` varchar(32) DEFAULT NULL,
  `reportid` varchar(32) DEFAULT NULL,
  `eventname` varchar(32) DEFAULT NULL,
  `tltemplet` varchar(32) DEFAULT NULL,
  `timeline` tinyint(4) DEFAULT NULL,
  `tbversion` int(11) DEFAULT NULL,
  `LASTUPDATE` datetime DEFAULT NULL,
  `CREATETIME` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_tabletask
-- ----------------------------
INSERT INTO `bm_tabletask` VALUES ('402888815db7065f015db70741a20010', 'bm_playuser', null, null, '0', null, null, null, '297e8c7b455798280145579c73e501c1', 'admin', null, 'bm_playuser', null, null, null, null, null, null, 'bm_playuser', '1', '0', '2017-08-06 18:11:32', '0', null, null, null, 'ukewo', '0', '0', null, null, null, null, null, null, '0', '0', null, '2017-08-06 18:11:32');

-- ----------------------------
-- Table structure for `bm_team`
-- ----------------------------
DROP TABLE IF EXISTS `bm_team`;
CREATE TABLE `bm_team` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENT` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `SKILL` tinyint(4) DEFAULT '0' COMMENT '启用技能组',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_team
-- ----------------------------
INSERT INTO `bm_team` VALUES ('40288881601f3b2501601f3cc4d60000', '电销项目组', 'sales', null, null, null, 'beimi', null, null, '0');

-- ----------------------------
-- Table structure for `bm_templet`
-- ----------------------------
DROP TABLE IF EXISTS `bm_templet`;
CREATE TABLE `bm_templet` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '模板名称',
  `DESCRIPTION` longtext COMMENT '描述',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `GROUPID` varchar(255) DEFAULT NULL COMMENT '组ID',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `USERID` varchar(255) DEFAULT NULL COMMENT '创建人ID',
  `TEMPLETTEXT` longtext COMMENT '模板内容',
  `TEMPLETTYPE` varchar(255) DEFAULT NULL COMMENT '模板类型',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `MEMO` varchar(255) DEFAULT NULL COMMENT '备注',
  `ORDERINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  `TYPEID` varchar(32) DEFAULT NULL COMMENT '分类ID',
  `SELDATA` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_templet
-- ----------------------------

-- ----------------------------
-- Table structure for `bm_user`
-- ----------------------------
DROP TABLE IF EXISTS `bm_user`;
CREATE TABLE `bm_user` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `LANGUAGE` varchar(255) DEFAULT NULL COMMENT '语言',
  `USERNAME` varchar(255) DEFAULT NULL COMMENT '用户名',
  `PASSWORD` varchar(255) DEFAULT NULL COMMENT '密码',
  `SECURECONF` varchar(255) DEFAULT NULL COMMENT '安全级别',
  `EMAIL` varchar(255) DEFAULT NULL COMMENT '邮件',
  `FIRSTNAME` varchar(255) DEFAULT NULL COMMENT '姓',
  `MIDNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `LASTNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `JOBTITLE` varchar(255) DEFAULT NULL COMMENT '职位',
  `DEPARTMENT` varchar(255) DEFAULT NULL COMMENT '部门',
  `GENDER` varchar(255) DEFAULT NULL COMMENT '性别',
  `BIRTHDAY` varchar(255) DEFAULT NULL COMMENT '生日',
  `NICKNAME` varchar(255) DEFAULT NULL COMMENT '昵称',
  `USERTYPE` varchar(255) DEFAULT NULL COMMENT '用户类型',
  `RULENAME` varchar(255) DEFAULT NULL COMMENT '角色',
  `SEARCHPROJECTID` varchar(255) DEFAULT NULL COMMENT '备用',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `MEMO` varchar(255) DEFAULT NULL COMMENT '备注',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `MOBILE` varchar(32) DEFAULT NULL COMMENT '手机号',
  `passupdatetime` datetime DEFAULT NULL COMMENT '最后 一次密码修改时间',
  `sign` text,
  `del` tinyint(4) DEFAULT '0',
  `uname` varchar(100) DEFAULT NULL,
  `musteditpassword` tinyint(4) DEFAULT NULL,
  `AGENT` tinyint(4) DEFAULT NULL COMMENT '工号',
  `SKILL` varchar(32) DEFAULT NULL COMMENT '技能组',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `fans` int(11) DEFAULT NULL COMMENT '关注人数',
  `follows` int(11) DEFAULT NULL COMMENT '被关注次数',
  `integral` int(11) DEFAULT NULL,
  `lastlogintime` datetime DEFAULT NULL COMMENT '最后登录时间',
  `status` varchar(10) DEFAULT NULL COMMENT '状态',
  `deactivetime` datetime DEFAULT NULL COMMENT '离线时间',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `DATASTATUS` tinyint(4) DEFAULT NULL COMMENT '数据状态',
  `callcenter` tinyint(4) DEFAULT NULL COMMENT '启用呼叫中心坐席',
  `SUPERUSER` tinyint(4) DEFAULT NULL COMMENT '是否超级管理员',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_user
-- ----------------------------
INSERT INTO `bm_user` VALUES ('297e8c7b455798280145579c73e501c1', null, 'admin', '14e1b600b1fd579f47433b88e8d85291', '5', 'admin@beixi.me', null, null, null, null, null, '0', null, null, '0', null, null, 'beimi', null, '2017-03-16 13:56:34', '北京', '2017-08-06 18:25:12', '40288881601a365301601a3b79560000', '18510129577', null, null, '0', '系统管理员', '0', '1', null, '北京', '北京', '2', '1', '0', '2018-03-26 16:08:31', null, null, null, '0', '0', '1');
INSERT INTO `bm_user` VALUES ('402883965c1dfe92015c1e12651d0002', null, 'test', '14e1b600b1fd579f47433b88e8d85291', '5', 'test@beixi.me', null, null, null, null, null, null, null, null, null, null, null, 'beimi', null, '2017-05-19 08:19:01', null, '2017-08-06 18:25:25', '40288881601a365301601a3b79560000', '18510294566', '2017-05-19 08:19:01', null, '0', '陈法蓉', null, '0', null, null, null, '0', '0', '0', '2017-07-26 17:02:18', null, null, null, '0', '0', '0');

-- ----------------------------
-- Table structure for `bm_userrole`
-- ----------------------------
DROP TABLE IF EXISTS `bm_userrole`;
CREATE TABLE `bm_userrole` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `user_id` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `role_id` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of bm_userrole
-- ----------------------------
INSERT INTO `bm_userrole` VALUES ('402888815e026a43015e02abde690002', '297e8c7b455798280145579c73e501c1', '402888815e026a43015e02aba80f0000', '297e8c7b455798280145579c73e501c1', '2017-08-21 10:42:52', 'ukewo');
INSERT INTO `bm_userrole` VALUES ('402888815e026a43015e02abde760003', '402883965c1dfe92015c1e12651d0002', '402888815e026a43015e02aba80f0000', '297e8c7b455798280145579c73e501c1', '2017-08-21 10:42:52', 'ukewo');

-- ----------------------------
-- Table structure for `bm_wares`
-- ----------------------------
DROP TABLE IF EXISTS `bm_wares`;
CREATE TABLE `bm_wares` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(50) DEFAULT NULL,
  `CODE` varchar(50) DEFAULT NULL,
  `CREATETIME` datetime DEFAULT NULL,
  `CREATER` varchar(32) DEFAULT NULL,
  `UPDATETIME` datetime DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `USERNAME` varchar(50) DEFAULT NULL,
  `WARESTYPE` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `INX` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `STARTDATE` datetime DEFAULT NULL COMMENT '有效期开始时间',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '分类描述',
  `PRICE` int(11) DEFAULT NULL,
  `STOCK` int(11) DEFAULT NULL,
  `IMAGEURL` varchar(50) DEFAULT NULL,
  `PMETHOD` varchar(32) DEFAULT NULL,
  `SHOPID` varchar(32) DEFAULT NULL,
  `SPU` int(11) DEFAULT NULL,
  `STATUS` varchar(32) DEFAULT NULL,
  `RECOMTYPE` varchar(32) DEFAULT NULL,
  `ENABLESKU` tinyint(4) DEFAULT NULL,
  `PAYMENT` varchar(32) DEFAULT NULL,
  `ENDTIME` datetime DEFAULT NULL,
  `STARTTIME` datetime DEFAULT NULL,
  `QUANTITY` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- ----------------------------
-- Records of bm_wares
-- ----------------------------
INSERT INTO `bm_wares` VALUES ('4028811b61f4ca0d0161f4e88a0c0002', '一些金币', null, '2018-03-05 14:45:36', null, '2018-03-06 11:06:07', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '阿斯顿发', '48', '0', 'g_01', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f4e8fb0161f4f565bf0001', '一堆金币', null, '2018-03-05 14:59:39', null, '2018-03-06 11:06:10', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '阿斯顿发', '120', '0', 'g_02', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f4e8fb0161f4f7ead00002', '一大堆金币', null, '2018-03-05 15:02:24', null, '2018-03-06 11:06:12', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '', '200', '0', 'g_03', null, null, '0', 'on', '4028811b61f418a40161f43aa6a70002', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f505460161f508d6990000', '一大袋金币', null, '2018-03-05 15:20:49', null, '2018-03-06 11:06:15', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '2222', '2000', '0', 'g_04', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f531d70161f8f772f5000c', '两大袋金币', null, '2018-03-06 09:40:22', null, '2018-03-06 11:06:17', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '', '2000', '0', 'g_05', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f531d70161f8f7b752000d', '一大箱金币', null, '2018-03-06 09:40:39', null, '2018-03-06 11:06:20', 'beimi', null, '4028811b61df005e0161dffe1e800001', '1', null, '', '1000', '0', 'g_06', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f7b0007', null, null, '1000');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f9787e2c0000', '一小堆钻石', null, '2018-03-06 12:01:19', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '6', '0', 'd_01', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '30');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f98e43b60001', '一大堆钻石', null, '2018-03-06 12:25:06', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '6', '0', 'd_02', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '30');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f98ec0090002', '一小袋钻石', null, '2018-03-06 12:25:38', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '12', '0', 'd_03', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '60');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f98f17bd0003', '一大袋钻石', null, '2018-03-06 12:26:00', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '60', '0', 'd_04', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '60');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f98f60ba0004', '两大袋钻石', null, '2018-03-06 12:26:19', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '60', '0', 'd_05', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '120');
INSERT INTO `bm_wares` VALUES ('4028811b61f906010161f98f9c050005', '一箱钻石', null, '2018-03-06 12:26:34', '297e8c7b455798280145579c73e501c1', null, 'beimi', null, '4028811b61df005e0161dffe1e900002', '1', null, '', '600', '0', 'd_06', null, null, '0', 'on', '4028811b61f418a40161f43aa68c0001', '1', '4028811b61f418a40161f46e1f890008', null, null, '600');

-- ----------------------------
-- Table structure for `bm_wares_sku`
-- ----------------------------
DROP TABLE IF EXISTS `bm_wares_sku`;
CREATE TABLE `bm_wares_sku` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(50) DEFAULT NULL,
  `CODE` varchar(50) DEFAULT NULL,
  `CREATETIME` datetime DEFAULT NULL,
  `CREATER` varchar(32) DEFAULT NULL,
  `UPDATETIME` datetime DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `USERNAME` varchar(50) DEFAULT NULL,
  `WARESID` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `INX` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `STARTDATE` datetime DEFAULT NULL COMMENT '有效期开始时间',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '分类描述',
  `PRICE` int(11) DEFAULT NULL,
  `STOCK` int(11) DEFAULT NULL,
  `IMAGEURL` varchar(50) DEFAULT NULL,
  `PMETHOD` varchar(32) DEFAULT NULL,
  `SHOPID` varchar(32) DEFAULT NULL,
  `SKU` int(11) DEFAULT NULL,
  `STATUS` varchar(32) DEFAULT NULL,
  `DEFAULTSKU` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- ----------------------------
-- Records of bm_wares_sku
-- ----------------------------
INSERT INTO `bm_wares_sku` VALUES ('4028811b618320fb016183233dbe0388', 'abc', null, '2018-02-11 12:33:00', '4028cac3614cd2f901614cf8be1f0324', null, 'ukewo', null, '0', '1', null, 'abc', null, null, null, null, null, null, null, null);

-- ----------------------------
-- Table structure for `bm_wares_type`
-- ----------------------------
DROP TABLE IF EXISTS `bm_wares_type`;
CREATE TABLE `bm_wares_type` (
  `ID` varchar(32) NOT NULL,
  `NAME` varchar(50) DEFAULT NULL,
  `CODE` varchar(50) DEFAULT NULL,
  `CREATETIME` datetime DEFAULT NULL,
  `CREATER` varchar(32) DEFAULT NULL,
  `UPDATETIME` datetime DEFAULT NULL,
  `ORGI` varchar(32) DEFAULT NULL,
  `USERNAME` varchar(50) DEFAULT NULL,
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `INX` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `STARTDATE` datetime DEFAULT NULL COMMENT '有效期开始时间',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '分类描述',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- ----------------------------
-- Records of bm_wares_type
-- ----------------------------
INSERT INTO `bm_wares_type` VALUES ('4028811b618320fb016183233dbe0388', 'abc', null, '2018-02-11 12:33:00', '4028cac3614cd2f901614cf8be1f0324', null, 'ukewo', null, '0', '1', null, 'abc');
